#include "plugin_includes.h"

extern unsigned int gimplePssa (void);

extern int serialize_state;

extern int GimpleSSA_dump_nr;

static struct
gimple_opt_pass pass_dump_GSSA =
{
  {
    GIMPLE_PASS,
    "gimplePSSA",				/* name */
    is_alwaysTrue,				/* gate */
    gimplePssa, 				/* execute */
    NULL,					/* sub */
    NULL,					/* next */
    0,						/* static_pass_number */
    0,						/* tv_id */
    PROP_cfg | PROP_ssa,			/* properties_required */
    0,						/* properties_provided */
    0,						/* properties_destroyed */
    0,						/* todo_flags_start */
    TODO_verify_ssa				/* todo_flags_finish */
    | TODO_cleanup_cfg
    | TODO_update_ssa
  }
};

int
plugin_init (struct plugin_name_args *plugin_info,
             struct plugin_gcc_version *version)
{
  if (!plugin_default_version_check (version, &gcc_version))
    return 1;

  struct register_pass_info pass_info;
  const char *plugin_name = plugin_info->base_name;
  int argc = plugin_info->argc;
  struct plugin_argument *argv = plugin_info->argv;

  pass_info.pass = &pass_dump_GSSA.pass;
  pass_info.reference_pass_name = "optimized";

  /* Do it for every instance if it is 0. */
  pass_info.ref_pass_instance_number = 1;

  /* This pass can go almost anywhere as long as you're in SSA form */
  pass_info.pos_op = PASS_POS_INSERT_BEFORE;

  pass_init_dump_file (pass_info.pass);

  /* Register this new pass with GCC */
  register_callback (plugin_name, PLUGIN_PASS_MANAGER_SETUP, NULL,
                     &pass_info);
  serialize_state = -1;
  GimpleSSA_dump_nr = pass_info.pass->static_pass_number;

  return 0;
}


