/*
 *
 *                   _/_/_/    _/_/   _/    _/ _/_/_/    _/_/
 *                  _/   _/ _/    _/ _/_/  _/ _/   _/ _/    _/
 *                 _/_/_/  _/_/_/_/ _/  _/_/ _/   _/ _/_/_/_/
 *                _/      _/    _/ _/    _/ _/   _/ _/    _/
 *               _/      _/    _/ _/    _/ _/_/_/  _/    _/
 *
 *             ***********************************************
 *                              PandA Project 
 *                     URL: http://panda.dei.polimi.it
 *                       Politecnico di Milano - DEI
 *                        System Architectures Group
 *             ***********************************************
 *              Copyright (c) 2004-2012 Politecnico di Milano
 *
 *   This file is part of the PandA framework.
 *
 *   The PandA framework is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
/**
 * @file unique_binding_register.hpp
 * @brief Class specification of unique binding register allocation algorithm
 *
 *
 * @author Fabrizio Ferrandi <ferrandi@elet.polimi.it>
 * @version $Revision: 10608 $
 * @date $Date: 2012-03-12 10:46:42 +0100 (Mon, 12 Mar 2012) $
 * $Revision: 10608 $
 * $Date: 2012-03-12 10:46:42 +0100 (Mon, 12 Mar 2012) $
 * Last modified by $Author: ferrandi $
 *
*/
#ifndef UNIQUE_BINDING_REGISTER_HPP
#define UNIQUE_BINDING_REGISTER_HPP

#include "reg_binding_creator.hpp"

class unique_binding_register : public reg_binding_creator
{
   public:

      /**
       * Constructor of the class.
       */
      unique_binding_register(const ParameterRef Param, const hlsRef HLS, const storage_value_insertionRef svi_algorithm);

      /**
       * Destructor of the class.
       */
      ~unique_binding_register();

      /**
       * Unique binding register allocation algorithm execution.
       */
      void exec();

      /**
       * Returns the name of the implemented algorithm
       */
      virtual std::string get_kind_text() const;

};

#endif
