/*
 *
 *                   _/_/_/    _/_/   _/    _/ _/_/_/    _/_/
 *                  _/   _/ _/    _/ _/_/  _/ _/   _/ _/    _/
 *                 _/_/_/  _/_/_/_/ _/  _/_/ _/   _/ _/_/_/_/
 *                _/      _/    _/ _/    _/ _/   _/ _/    _/
 *               _/      _/    _/ _/    _/ _/_/_/  _/    _/
 *
 *             ***********************************************
 *                              PandA Project 
 *                     URL: http://panda.dei.polimi.it
 *                       Politecnico di Milano - DEI
 *                        System Architectures Group
 *             ***********************************************
 *              Copyright (c) 2004-2012 Politecnico di Milano
 *
 *   This file is part of the PandA framework.
 *
 *   The PandA framework is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
/**
 * @file set_intersection.hpp
 * @brief This file collects some utility functions for set intersection.
 *
 *
 * @author Christian Pilato <pilato@elet.polimi.it>
 * $Revision: 10608 $
 * $Date: 2012-03-12 10:46:42 +0100 (Mon, 12 Mar 2012) $
 * Last modified by $Author: ferrandi $
 *
*/
#ifndef SET_INTERSECTION_HPP
#define SET_INTERSECTION_HPP

#include <tr1/unordered_set>
template<class T>
void set_intersection(const std::set<unsigned int>& first, const std::tr1::unordered_set<unsigned int>& second, T& result)
{
   result.clear();
   for(std::set<unsigned int>::const_iterator i = first.begin(); i != first.end(); i++)
      if (second.find(*i) != second.end())
         result.insert(*i);
}

template<class T>
void set_intersection(const std::tr1::unordered_set<unsigned int>& first, const std::set<unsigned int>& second, T& result)
{
   result.clear();
   for(std::set<unsigned int>::const_iterator i = second.begin(); i != second.end(); i++)
      if (first.find(*i) != first.end())
         result.insert(*i);
}

#endif

