/*
 *
 *                   _/_/_/    _/_/   _/    _/ _/_/_/    _/_/
 *                  _/   _/ _/    _/ _/_/  _/ _/   _/ _/    _/
 *                 _/_/_/  _/_/_/_/ _/  _/_/ _/   _/ _/_/_/_/
 *                _/      _/    _/ _/    _/ _/   _/ _/    _/
 *               _/      _/    _/ _/    _/ _/_/_/  _/    _/
 *
 *             ***********************************************
 *                              PandA Project 
 *                     URL: http://panda.dei.polimi.it
 *                       Politecnico di Milano - DEI
 *                        System Architectures Group
 *             ***********************************************
 *              Copyright (c) 2004-2012 Politecnico di Milano
 *
 *   This file is part of the PandA framework.
 *
 *   The PandA framework is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
/**
 * @file op_graph.hpp
 * @brief Data stuctures used in operations graph
 *
 * @author Marco Lattuada <lattuada@elet.polimi.it> 
 * $Revision: 10608 $
 * $Date: 2012-03-12 10:46:42 +0100 (Mon, 12 Mar 2012) $
 * Last modified by $Author: ferrandi $
 *
*/

///Superclass include
#include "graph.hpp"

#ifndef OP_GRAPH_HPP
#define OP_GRAPH_HPP
/**
 * information associated with the whole graph
 */
struct op_graph_info : public graph_info
{

   /**
    * Constructor
    */
   op_graph_info();

   /**
    * Destructor();
    */
   ~op_graph_info();

   /// Index identifying the entry vertex
   vertex entry_vertex;

   /// Index identifying the exit vertex
   vertex exit_vertex;

};

#define GET_ENTRY_VERTEX(data) \
    Cget_graph_info<op_graph_info>(*(data))->entry_vertex


#define GET_EXIT_VERTEX(data) \
    Cget_graph_info<op_graph_info>(*(data))->exit_vertex

#endif

