
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */


/**
* Includes
*/

///Autoheader include
#include "config_HAVE_CODE_ESTIMATION_BUILT.hpp"
#include "config_HAVE_MAPPING_BUILT.hpp"
#include "config_HAVE_RTL_BUILT.hpp"
#include "config_ENABLE_NLS.hpp"
#define YYENABLE_NLS ENABLE_NLS
#define YYLTYPE_IS_TRIVIAL 0

#include <string>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <fstream>
#include "exceptions.hpp"
#include "gcc_wrapper.hpp"
#include "treeParser.h"
#include "treeLexer.hpp"
#include "tree_node.hpp"
#include "tree_basic_block.hpp"
#include "tree_reindex.hpp"
#include "tree_manager.hpp"
#include "fileIO.hpp"
#include "Parameter.hpp"
#if HAVE_MAPPING_BUILT
#include "machine_node.hpp"
#endif
#if HAVE_CODE_ESTIMATION_BUILT
#include "probability_distribution.hpp"
#include "weight_information.hpp"
#endif
/**
* Defines
*/
//#define YYDEBUG 1
//#define NDEBUG 1
///Skipping warnings due to bison
#pragma GCC diagnostic ignored "-Wconversion"
#pragma GCC diagnostic ignored "-Wsign-conversion"
#pragma GCC diagnostic ignored "-Wunused-parameter"
#pragma GCC diagnostic ignored "-Wwrite-strings"
#pragma GCC diagnostic ignored "-Wold-style-cast"
/**
* MACROS
*/

#if HAVE_RTL_BUILT
#define SET_DATA(data, value) data = value
#else
#define SET_DATA(data, value)
#endif

#define NO_OPT(cond, action) if(cond) action else YYABORT;
#define OPT(cond, action) if(cond) action

/**
 * Macro used to set a generic field of a generic object.
 * @param obj_node is the type of the object to which the field is setted.
 * @param field is the name of the member of the obj_node to be setted. The type of field member has to be tree_nodeRef.
*/
#define NS(obj_node, field) \
  assign_tree_reindex_to_member(data.curr_tree_nodeRef, &obj_node::field, data.curr_NODE_ID, data.current_TM);

/**
 * Macro used to set a generic field of a generic object.
 * @param curr is the current object reference.
 * @param obj_node is the type of the object to which the field is setted.
 * @param field is the name of the member of the obj_node to be setted. The type of field member has to be tree_nodeRef.
*/
#define NS2(curr, obj_node, field) \
  assign_tree_reindex_to_member(curr, &obj_node::field, data.curr_NODE_ID, data.current_TM);

/**
 * Macro used to set a generic field with a generic value of a generic object.
 * @param obj_node is the type of the object to which the field is setted.
 * @param field is the name of the member of the obj_node to be setted.
 * @param value is the value used to set the field member.
*/
#define NSV(obj_node, field, value) \
    assign_value_to_member(data.curr_tree_nodeRef, &obj_node::field, value);

/**
 * Macro used to set a generic field with a generic value of a generic object.
 * @param obj_node is the type of the object to which the field is setted.
 * @param field is the name of the member of the obj_node to be setted.
 * @param value is the value used to set the field member.
*/
#define NBV(obj_node, field, value) \
  assign_value_to_member<obj_node, blocRef, unsigned int>(data.curr_blocRef, &obj_node::field, value);

/**
 * Create the empty tree_node and set the curr_tree_nodeRef.
 * @param obj_node is the type of the tree_node to create.
*/
#define CTN(obj_node) \
  create_Ref_id<obj_node>(data, &bison_parser_data::curr_tree_nodeRef);

/**
 * Create the identifier_node
*/
#define CTN_ID(parameter) \
  create_Ref_identifier(&bison_parser_data::curr_tree_nodeRef, data, parameter, data.current_TM);

/**
 * Create the empty bloc and set the curr_blocRef.
 * @param obj_node is the type of the bloc to create.
*/
#define CB() \
  create_Ref<bloc,bloc>(&bison_parser_data::curr_blocRef, data);


/**
 * Create the empty vops and set the curr_vopsRef.
 * @param obj_node is the type of the vops to create.
*/
#define CVOPS() \
  create_Ref<vops,vops>(&bison_parser_data::curr_vopsRef, data);

/**
 * Create the empty vuse and set the curr_vuseRef.
*/
#define CVUSE() \
  create_Ref<vuse,vuse>(&bison_parser_data::curr_vuseRef, data);

/**
 * Create the empty vdef and set the curr_vdefRef.
*/
#define CVDEF() \
  create_Ref<vdef,vdef>(&bison_parser_data::curr_vdefRef, data);

/**
 * Macro used to add attribute to the class attr.
 * @param token is the token associated to the attribute.
*/
#define ADD_ATTR(token) \
  add_attr<attr>(data.curr_tree_nodeRef, token);

/**
 * Macro used to add attribute to the class function_decl.
 * @param token is the token associated to the attribute.
*/
#define ADD_OP_NAME(token) \
  add_op_name<function_decl>(data.curr_tree_nodeRef, token);

/**
* Macro used to add a NODE_ID to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADDVVUSE(obj_node, add_function) \
  addv<obj_node, vuseRef>(data.curr_vuseRef, &obj_node::add_function, data.curr_NODE_ID, data.current_TM);

/**
* Macro used to add a NODE_ID to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADDVVDEF(obj_node, add_function) \
  addv<obj_node, vdefRef>(data.curr_vdefRef, &obj_node::add_function, data.curr_NODE_ID, data.current_TM);

/**
* Macro used to add a NODE_ID to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADDV(obj_node, add_function) \
  addv(data.curr_tree_nodeRef, &obj_node::add_function, data.curr_NODE_ID, data.current_TM);

/**
 * Macro used to add a phi node to the object obj_node through the function add_function.
 * @param obj_node is the type of the object to which the field is setted.
 * @param add_function is the name of function that add a phi
*/
#define ADDP(obj_node, add_function) \
  addv(data.curr_blocRef, &obj_node::add_function, data.curr_NODE_ID, data.current_TM);

/**
* Macro used to add a NODE_ID to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADDV2(obj_node, add_function) \
  addv2<obj_node, tree_nodeRef>(data.curr_tree_nodeRef, &obj_node::add_function, data.curr_NODE_ID_BIS, data.curr_NODE_ID, data.current_TM);

/**
* Macro used to add a NODE_ID to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADDV3(obj_node, add_function) \
  addv3<obj_node, tree_nodeRef>(data.curr_tree_nodeRef, &obj_node::add_function, data.curr_NODE_ID, data.curr_unumber, data.current_TM);

/**
* Macro used to add an unsigned int to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a NODE_ID
*/
#define ADD_UNSIGNED(obj_node, add_function) \
  add_unsigned<obj_node, tree_nodeRef>(data.curr_tree_nodeRef, &obj_node::add_function, data.curr_NODE_ID, data.curr_unumber, data.current_TM);

/**
* Macro used to add a bloc to the object obj_node through the function add_function.
* @param obj_node is the type of the object to which the field is setted.
* @param add_function is the name of function that add a bloc
* @param bloc is the bloc to add.
*/
#define ADDB(obj_node, add_function, vbloc) \
  addo<obj_node, tree_nodeRef, blocRef>(data.curr_tree_nodeRef, &obj_node::add_function, vbloc);

/**
 * Macro used to add a value to the object obj_node through the function add_function.
 * @param obj_node is the type of the object to which the field is setted.
 * @param add_function is the name of function that add a pred
 * @param val is the value to add.
*/
#define ADDVALUE(obj_node, add_function, val) \
  addo(data.curr_blocRef, &obj_node::add_function, val);

/**
 * Macro used to add a vuse to the object obj_node through the function add_function.
 * @param obj_node is the type of the object to which the field is setted.
 * @param add_function is the name of function that add a vuse
 * @param vuse is the vuse to add.
*/
#define ADDVVOPS(obj_node, add_function, vuse) \
  addo(data.curr_vopsRef, &obj_node::add_function, vuse);

/**
 * Macro used to add access_binf
 * @param obj_node is the type of the object to which the field is setted.
 * @param add_function is the name of function that add a vuse
 * @param binf is the binf
 * @param access is a token between TOK_PUB TOK_PROT TOK_PRIV.
*/
#define ADD_ACCESS_BINF(obj_node, add_function) \
  add_access_binf(data.curr_tree_nodeRef, data.curr_NODE_ID, data.curr_token_enum, data.current_TM);


struct bison_parser_data
{
   bison_parser_data(const ParameterConstRef _Param, int _debug_level) :
      Param(_Param),
      debug_level(_debug_level),
      curr_NODE_ID(0),
      curr_NODE_ID_BIS(0),
      implement_node(false),
      curr_number(0),
      curr_size_t_number(0),
      id(0)
   {
#if HAVE_MAPPING_BUILT
      std::string driving_component_string = Param->getOption<std::string>(OPT_driving_component_type);
      driving_component = processingElement::get_component_type((driving_component_string));
#endif
   }
   //the set of parameter
   const ParameterConstRef Param;

   ///debug level
   int debug_level;

   /// Current tree_node reference
   tree_nodeRef curr_tree_nodeRef;

   /// Current bloc reference
   blocRef curr_blocRef;

   /// Current vops reference
   vopsRef curr_vopsRef;

   /// Current vuse reference
   vuseRef curr_vuseRef;

   /// Current vdef reference
   vdefRef curr_vdefRef;

   /// Current string reference
   std::string curr_string;

   /// GCC version
   std::string gcc_version;

   /// Store the current NODE_ID as integer.
   unsigned int curr_NODE_ID;

   /// Store the current NODE_ID_BIS as integer.
   unsigned int curr_NODE_ID_BIS;

   /// Is true if the current node is an implementation node
   bool implement_node;

   /// Store the current signed NUMBER.
   int curr_number;

   /// Store the current size_t NUMBER.
   size_t curr_size_t_number;

   /// Store the current unsigned NUMBER
   unsigned int curr_unumber;

   /// Store the current NUMBER (long)
   int long curr_long_number;

   /// Store the current NUMBER (long long)
   int long long curr_long_long_number;

   /// Store the current NUMBER (long double)
   long double curr_double_number;

   /// Store the current token_enum (long double)
   treeVocabularyTokenTypes::token_enum curr_token_enum;

   /// Store the current id of the node. Used by node to identify the id of the current node.
   int id;

   ///merge all the raw read
   tree_managerRef final_TM;

   ///current tree manager
   tree_managerRef current_TM;

#if HAVE_RTL_BUILT
   ///current list of enum rtl_kind
   std::list<std::pair<enum rtl_kind, enum mode_kind> > rtls;

   ///current rtl
   enum rtl_kind single_rtl;

   ///current mode_kind
   enum mode_kind mode_rtl;
#endif

#if HAVE_MAPPING_BUILT
   ///The type of the driving_component
   ComponentTypeConstRef driving_component;
#endif
};

/**
* Local Data Structures
*/

/**
* Global Data Structures
*/

/** 
* Function Prototypes
*/
extern int yylex(YYSTYPE *lvalp, treeFlexLexer& lexer);
extern void yyerror(bison_parser_data &data, treeFlexLexer& lexer, char *s);

/**
* Templates
*/
template<class obj_node, class TRef, class value_t>
inline
void assign_value_to_member(const TRef &curr, value_t obj_node::* field, const value_t value)
  {
    THROW_ASSERT(curr, "");
    ((dynamic_cast<obj_node*>(curr.get())) ->* field) = value;
  }

template<class obj_node, class TRef>
inline
void assign_tree_reindex_to_member(const TRef &curr, tree_nodeRef obj_node::* field, const int &cni, tree_managerRef const &Root)
  {
    THROW_ASSERT(curr, "");
((dynamic_cast<obj_node*>(curr.get())) ->* field) = tree_nodeRef(new tree_reindex(cni, Root->add(cni)));
  }

template<class obj_node, class ret>
inline
void create_Ref( refcount<ret> bison_parser_data::* field, bison_parser_data &data)
  {
   (data .* field) = refcount<ret>(new obj_node());
  }

template<class obj_node>
inline
void create_Ref_id(bison_parser_data &data, tree_nodeRef bison_parser_data::* field)
{
    (data .* field) = tree_nodeRef(new obj_node(data.id));
}

template<class constructor_parameter_type>
inline
void create_Ref_identifier(tree_nodeRef bison_parser_data::* field, bison_parser_data &data, constructor_parameter_type par, tree_managerRef const &Root)
{
    (data .* field) = tree_nodeRef(new identifier_node(data.id,par,Root.get()));
}

template<class attr>
inline
void add_attr(const tree_nodeRef &curr, const int &token_i)
  {
    (dynamic_cast<attr*>(curr.get()))->add(token_i);
  }

template<class attr>
inline
void add_attr_node(const tree_nodeRef &curr, const int &token_i, tree_managerRef const &Root)
  {
    (dynamic_cast<attr*>(curr.get()))->add(tree_nodeRef(new tree_reindex(token_i, Root->add(token_i))));
  }

template<class function_decl>
inline
void add_op_name(const tree_nodeRef &curr, const std::string & token_s)
  {
    (dynamic_cast<function_decl*>(curr.get()))->add(token_s);
  }

template<class obj_node, class TRef>
inline
void  addv(const TRef &curr, void (obj_node::*add_function)(const tree_nodeRef), const int &cni, tree_managerRef const &Root)
  {
((dynamic_cast<obj_node*>(curr.get()))->*add_function)(tree_nodeRef(new tree_reindex(cni, Root->add(cni))));
  }

template<class obj_node, class TRef>
inline
void  addv2(const TRef &curr, void (obj_node::*add_function)(const tree_nodeRef, const tree_nodeRef), const int cni1, const int cni2, tree_managerRef const &Root)
{
((dynamic_cast<obj_node*>(curr.get()))->*add_function)(tree_nodeRef(new tree_reindex(cni1, Root->add(cni1))), tree_nodeRef(new tree_reindex(cni2, Root->add(cni2))));
}

template<class obj_node, class TRef>
inline
void  addv3(const TRef &curr, void (obj_node::*add_function)(const tree_nodeRef&, int), const unsigned int &cni1, const unsigned int &cni2, tree_managerRef const &Root)
{
((dynamic_cast<obj_node*>(curr.get()))->*add_function)(tree_nodeRef(new tree_reindex(cni1, Root->add(cni1))), cni2);
}

template<class obj_node, class TRef>
inline
void  add_unsigned(const TRef &curr, void (obj_node::*add_function)(const tree_nodeRef, unsigned int), const unsigned int cni1, const unsigned int cni2, tree_managerRef const &Root)
{
   ((dynamic_cast<obj_node*>(curr.get()))->*add_function)(tree_nodeRef(new tree_reindex(cni1, Root->add(cni1))), cni2);
}


template<class obj_node, class TRefCurr, class TRef>
inline
void  addo(const TRefCurr &curr, void (obj_node::*add_function)(const TRef), const TRef & obj)
  {
    ((dynamic_cast<obj_node*>(curr.get()))->*add_function)(obj);
  }

inline
void add_access_binf(const tree_nodeRef & curr, const unsigned int binf_index, const treeVocabularyTokenTypes::token_enum enum_access, tree_managerRef const & Root)
{
   (dynamic_cast<binfo*>(curr.get()))->add_access_binf(tree_nodeRef(new tree_reindex(binf_index, Root->add(binf_index))), enum_access);
}

  
inline
void do_fun_decl(const bool &in, const int & cnib, const int & cni, bison_parser_data &data, tree_managerRef const &Root)
  {
    Root->add_function(cni, data.curr_tree_nodeRef);
  }

template<class type_node>
inline
void do_qual(const tree_nodeRef &curr, const int & value)
  {
    THROW_ASSERT(curr, "");
    ((dynamic_cast<type_node*>(curr.get()))->qual) = value;
  }

inline
void do_node(const tree_nodeRef &curr, const int & value, tree_managerRef const &Root)
  {
    THROW_ASSERT(curr, "");
    Root->add(value, curr);
  }





/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NODE_ID = 258,
     TOK_BISON_STRING = 259,
     TOK_BISON_NUMBER = 260,
     TOK_BISON_GCC_VERSION = 261,
     TOK_BISON_PLUGIN_VERSION = 262,
     TOK_BISON_ERROR_MARK = 263,
     TOK_BISON_IDENTIFIER_NODE = 264,
     TOK_BISON_TREE_LIST = 265,
     TOK_BISON_TREE_VEC = 266,
     TOK_BISON_BLOCK = 267,
     TOK_BISON_VOID_TYPE = 268,
     TOK_BISON_INTEGER_TYPE = 269,
     TOK_BISON_REAL_TYPE = 270,
     TOK_BISON_COMPLEX_TYPE = 271,
     TOK_BISON_VECTOR_TYPE = 272,
     TOK_BISON_ENUMERAL_TYPE = 273,
     TOK_BISON_BOOLEAN_TYPE = 274,
     TOK_BISON_CHAR_TYPE = 275,
     TOK_BISON_POINTER_TYPE = 276,
     TOK_BISON_OFFSET_TYPE = 277,
     TOK_BISON_REFERENCE_TYPE = 278,
     TOK_BISON_METHOD_TYPE = 279,
     TOK_BISON_ARRAY_TYPE = 280,
     TOK_BISON_SET_TYPE = 281,
     TOK_BISON_RECORD_TYPE = 282,
     TOK_BISON_UNION_TYPE = 283,
     TOK_BISON_QUAL_UNION_TYPE = 284,
     TOK_BISON_FUNCTION_TYPE = 285,
     TOK_BISON_LANG_TYPE = 286,
     TOK_BISON_INTEGER_CST = 287,
     TOK_BISON_REAL_CST = 288,
     TOK_BISON_COMPLEX_CST = 289,
     TOK_BISON_VECTOR_CST = 290,
     TOK_BISON_STRING_CST = 291,
     TOK_BISON_FUNCTION_DECL = 292,
     TOK_BISON_LABEL_DECL = 293,
     TOK_BISON_CONST_DECL = 294,
     TOK_BISON_TYPE_DECL = 295,
     TOK_BISON_VAR_DECL = 296,
     TOK_BISON_PARM_DECL = 297,
     TOK_BISON_RESULT_DECL = 298,
     TOK_BISON_FIELD_DECL = 299,
     TOK_BISON_NAMESPACE_DECL = 300,
     TOK_BISON_TRANSLATION_UNIT_DECL = 301,
     TOK_BISON_COMPONENT_REF = 302,
     TOK_BISON_BIT_FIELD_REF = 303,
     TOK_BISON_INDIRECT_REF = 304,
     TOK_BISON_BUFFER_REF = 305,
     TOK_BISON_ARRAY_REF = 306,
     TOK_BISON_ARRAY_RANGE_REF = 307,
     TOK_BISON_VTABLE_REF = 308,
     TOK_BISON_EXC_PTR_EXPR = 309,
     TOK_BISON_FILTER_EXPR = 310,
     TOK_BISON_CONSTRUCTOR = 311,
     TOK_BISON_DESTRUCTOR = 312,
     TOK_BISON_COMPOUND_EXPR = 313,
     TOK_BISON_MODIFY_EXPR = 314,
     TOK_BISON_GIMPLE_ASSIGN = 315,
     TOK_BISON_INIT_EXPR = 316,
     TOK_BISON_TARGET_EXPR = 317,
     TOK_BISON_COND_EXPR = 318,
     TOK_BISON_GIMPLE_COND = 319,
     TOK_BISON_GIMPLE_BIND = 320,
     TOK_BISON_LABELED_BLOCK_EXPR = 321,
     TOK_BISON_GIMPLE_CALL = 322,
     TOK_BISON_CALL_EXPR = 323,
     TOK_BISON_WITH_CLEANUP_EXPR = 324,
     TOK_BISON_GIMPLE_NOP = 325,
     TOK_BISON_CLEANUP_POINT_EXPR = 326,
     TOK_BISON_PLACEHOLDER_EXPR = 327,
     TOK_BISON_PLUS_EXPR = 328,
     TOK_BISON_MINUS_EXPR = 329,
     TOK_BISON_MULT_EXPR = 330,
     TOK_BISON_TRUNC_DIV_EXPR = 331,
     TOK_BISON_CEIL_DIV_EXPR = 332,
     TOK_BISON_FLOOR_DIV_EXPR = 333,
     TOK_BISON_ROUND_DIV_EXPR = 334,
     TOK_BISON_TRUNC_MOD_EXPR = 335,
     TOK_BISON_CEIL_MOD_EXPR = 336,
     TOK_BISON_FLOOR_MOD_EXPR = 337,
     TOK_BISON_ROUND_MOD_EXPR = 338,
     TOK_BISON_RDIV_EXPR = 339,
     TOK_BISON_EXACT_DIV_EXPR = 340,
     TOK_BISON_FIX_TRUNC_EXPR = 341,
     TOK_BISON_FIX_CEIL_EXPR = 342,
     TOK_BISON_FIX_FLOOR_EXPR = 343,
     TOK_BISON_FIX_ROUND_EXPR = 344,
     TOK_BISON_FLOAT_EXPR = 345,
     TOK_BISON_NEGATE_EXPR = 346,
     TOK_BISON_MIN_EXPR = 347,
     TOK_BISON_MAX_EXPR = 348,
     TOK_BISON_ABS_EXPR = 349,
     TOK_BISON_LSHIFT_EXPR = 350,
     TOK_BISON_RSHIFT_EXPR = 351,
     TOK_BISON_LROTATE_EXPR = 352,
     TOK_BISON_RROTATE_EXPR = 353,
     TOK_BISON_BIT_IOR_EXPR = 354,
     TOK_BISON_BIT_XOR_EXPR = 355,
     TOK_BISON_BIT_AND_EXPR = 356,
     TOK_BISON_BIT_NOT_EXPR = 357,
     TOK_BISON_TRUTH_ANDIF_EXPR = 358,
     TOK_BISON_TRUTH_ORIF_EXPR = 359,
     TOK_BISON_TRUTH_AND_EXPR = 360,
     TOK_BISON_TRUTH_OR_EXPR = 361,
     TOK_BISON_TRUTH_XOR_EXPR = 362,
     TOK_BISON_TRUTH_NOT_EXPR = 363,
     TOK_BISON_LT_EXPR = 364,
     TOK_BISON_LE_EXPR = 365,
     TOK_BISON_GT_EXPR = 366,
     TOK_BISON_GE_EXPR = 367,
     TOK_BISON_EQ_EXPR = 368,
     TOK_BISON_NE_EXPR = 369,
     TOK_BISON_UNORDERED_EXPR = 370,
     TOK_BISON_ORDERED_EXPR = 371,
     TOK_BISON_UNLT_EXPR = 372,
     TOK_BISON_UNLE_EXPR = 373,
     TOK_BISON_UNGT_EXPR = 374,
     TOK_BISON_UNGE_EXPR = 375,
     TOK_BISON_UNEQ_EXPR = 376,
     TOK_BISON_LTGT_EXPR = 377,
     TOK_BISON_IN_EXPR = 378,
     TOK_BISON_SET_LE_EXPR = 379,
     TOK_BISON_CARD_EXPR = 380,
     TOK_BISON_RANGE_EXPR = 381,
     TOK_BISON_CONVERT_EXPR = 382,
     TOK_BISON_NOP_EXPR = 383,
     TOK_BISON_NON_LVALUE_EXPR = 384,
     TOK_BISON_VIEW_CONVERT_EXPR = 385,
     TOK_BISON_SAVE_EXPR = 386,
     TOK_BISON_UNSAVE_EXPR = 387,
     TOK_BISON_ADDR_EXPR = 388,
     TOK_BISON_REFERENCE_EXPR = 389,
     TOK_BISON_FDESC_EXPR = 390,
     TOK_BISON_COMPLEX_EXPR = 391,
     TOK_BISON_CONJ_EXPR = 392,
     TOK_BISON_REALPART_EXPR = 393,
     TOK_BISON_IMAGPART_EXPR = 394,
     TOK_BISON_PREDECREMENT_EXPR = 395,
     TOK_BISON_PREINCREMENT_EXPR = 396,
     TOK_BISON_POSTDECREMENT_EXPR = 397,
     TOK_BISON_POSTINCREMENT_EXPR = 398,
     TOK_BISON_VA_ARG_EXPR = 399,
     TOK_BISON_TRY_CATCH_EXPR = 400,
     TOK_BISON_TRY_FINALLY = 401,
     TOK_BISON_ = 402,
     TOK_BISON_GIMPLE_GOTO = 403,
     TOK_BISON_GOTO_SUBROUTINE = 404,
     TOK_BISON_GIMPLE_RETURN = 405,
     TOK_BISON_EXIT_EXPR = 406,
     TOK_BISON_LOOP_EXPR = 407,
     TOK_BISON_EXIT_BLOCK_EXPR = 408,
     TOK_BISON_GIMPLE_SWITCH = 409,
     TOK_BISON_CASE_LABEL_EXPR = 410,
     TOK_BISON_GIMPLE_RESX = 411,
     TOK_BISON_GIMPLE_ASM = 412,
     TOK_BISON_SSA_NAME = 413,
     TOK_BISON_GIMPLE_PHI = 414,
     TOK_BISON_CATCH_EXPR = 415,
     TOK_BISON_EH_FILTER_EXPR = 416,
     TOK_BISON_STATEMENT_LIST = 417,
     TOK_BISON_TEMPLATE_DECL = 418,
     TOK_BISON_TEMPLATE_TYPE_PARM = 419,
     TOK_BISON_CAST_EXPR = 420,
     TOK_BISON_STATIC_CAST_EXPR = 421,
     TOK_BISON_TYPENAME_TYPE = 422,
     TOK_BISON_SIZEOF_EXPR = 423,
     TOK_BISON_AGGR_INIT_EXPR = 424,
     TOK_BISON_SCOPE_REF = 425,
     TOK_BISON_COMPOUND_STMT = 426,
     TOK_BISON_CTOR_INITIALIZER = 427,
     TOK_BISON_DECL_STMT = 428,
     TOK_BISON_DO_STMT = 429,
     TOK_BISON_EXPR_STMT = 430,
     TOK_BISON_FOR_STMT = 431,
     TOK_BISON_IF_STMT = 432,
     TOK_BISON_RETURN_STMT = 433,
     TOK_BISON_WHILE_STMT = 434,
     TOK_BISON_MODOP_EXPR = 435,
     TOK_BISON_NEW_EXPR = 436,
     TOK_BISON_VEC_NEW_EXPR = 437,
     TOK_BISON_OVERLOAD = 438,
     TOK_BISON_REINTERPRET_CAST_EXPR = 439,
     TOK_BISON_TEMPLATE_ID_EXPR = 440,
     TOK_BISON_THROW_EXPR = 441,
     TOK_BISON_TRY_BLOCK = 442,
     TOK_BISON_ARROW_EXPR = 443,
     TOK_BISON_HANDLER = 444,
     TOK_BISON_BASELINK = 445,
     TOK_BISON_NAME = 446,
     TOK_BISON_TYPE = 447,
     TOK_BISON_SRCP = 448,
     TOK_BISON_ARG = 449,
     TOK_BISON_BODY = 450,
     TOK_BISON_STRG = 451,
     TOK_BISON_LNGT = 452,
     TOK_BISON_SIZE = 453,
     TOK_BISON_ALGN = 454,
     TOK_BISON_RETN = 455,
     TOK_BISON_PRMS = 456,
     TOK_BISON_SCPE = 457,
     TOK_BISON_USED = 458,
     TOK_BISON_VALUE = 459,
     TOK_BISON_ARGT = 460,
     TOK_BISON_PREC = 461,
     TOK_BISON_MIN = 462,
     TOK_BISON_MAX = 463,
     TOK_BISON_VALU = 464,
     TOK_BISON_CHAN = 465,
     TOK_BISON_STMT = 466,
     TOK_BISON_OP = 467,
     TOK_BISON_TIME_WEIGHT = 468,
     TOK_BISON_SIZE_WEIGHT = 469,
     TOK_BISON_RTL_SIZE_WEIGHT = 470,
     TOK_BISON_VARS = 471,
     TOK_BISON_UNQL = 472,
     TOK_BISON_ELTS = 473,
     TOK_BISON_DOMN = 474,
     TOK_BISON_BLOC = 475,
     TOK_BISON_DCLS = 476,
     TOK_BISON_MNGL = 477,
     TOK_BISON_PTD = 478,
     TOK_BISON_REFD = 479,
     TOK_BISON_QUAL = 480,
     TOK_BISON_VALR = 481,
     TOK_BISON_VALX = 482,
     TOK_BISON_FLDS = 483,
     TOK_BISON_VFLD = 484,
     TOK_BISON_BPOS = 485,
     TOK_BISON_FN = 486,
     TOK_BISON_GOTO = 487,
     TOK_BISON_REAL = 488,
     TOK_BISON_IMAG = 489,
     TOK_BISON_BINFO = 490,
     TOK_BISON_PUB = 491,
     TOK_BISON_PROT = 492,
     TOK_BISON_PRIV = 493,
     TOK_BISON_BINF = 494,
     TOK_BISON_UID = 495,
     TOK_BISON_OLD_UID = 496,
     TOK_BISON_INIT = 497,
     TOK_BISON_FINI = 498,
     TOK_BISON_PURP = 499,
     TOK_BISON_PRED = 500,
     TOK_BISON_SUCC = 501,
     TOK_BISON_HPL = 502,
     TOK_BISON_ATTRIBUTES = 503,
     TOK_BISON_PHI = 504,
     TOK_BISON_RES = 505,
     TOK_BISON_DEF = 506,
     TOK_BISON_EDGE = 507,
     TOK_BISON_VAR = 508,
     TOK_BISON_DEF_STMT = 509,
     TOK_BISON_VERS = 510,
     TOK_BISON_CNST = 511,
     TOK_BISON_CLAS = 512,
     TOK_BISON_DECL = 513,
     TOK_BISON_CLNP = 514,
     TOK_BISON_LAB = 515,
     TOK_BISON_TRY = 516,
     TOK_BISON_EX = 517,
     TOK_BISON_OUT = 518,
     TOK_BISON_IN = 519,
     TOK_BISON_STR = 520,
     TOK_BISON_CLOB = 521,
     TOK_BISON_REF = 522,
     TOK_BISON_FNCS = 523,
     TOK_BISON_CSTS = 524,
     TOK_BISON_RSLT = 525,
     TOK_BISON_INST = 526,
     TOK_BISON_SPCS = 527,
     TOK_BISON_CLS = 528,
     TOK_BISON_BFLD = 529,
     TOK_BISON_CTOR = 530,
     TOK_BISON_NEXT = 531,
     TOK_BISON_COND = 532,
     TOK_BISON_EXPR = 533,
     TOK_BISON_THEN = 534,
     TOK_BISON_ELSE = 535,
     TOK_BISON_CRNT = 536,
     TOK_BISON_HDLR = 537,
     TOK_BISON_USE_TMPL = 538,
     TOK_BISON_TMPL_PARMS = 539,
     TOK_BISON_TMPL_ARGS = 540,
     TOK_BISON_ARTIFICIAL = 541,
     TOK_BISON_SYSTEM = 542,
     TOK_BISON_OPERATING_SYSTEM = 543,
     TOK_BISON_LIBRARY_SYSTEM = 544,
     TOK_BISON_EXTERN = 545,
     TOK_BISON_C = 546,
     TOK_BISON_LSHIFT = 547,
     TOK_BISON_GLOBAL_INIT = 548,
     TOK_BISON_GLOBAL_FINI = 549,
     TOK_BISON_UNDEFINED = 550,
     TOK_BISON_OPERATOR = 551,
     TOK_BISON_OVERFLOW = 552,
     TOK_BISON_VIRT = 553,
     TOK_BISON_UNSIGNED = 554,
     TOK_BISON_STRUCT = 555,
     TOK_BISON_UNION = 556,
     TOK_BISON_REGISTER = 557,
     TOK_BISON_STATIC = 558,
     TOK_BISON_DEFAULT = 559,
     TOK_BISON_VOLATILE = 560,
     TOK_BISON_INF = 561,
     TOK_BISON_NAN = 562,
     TOK_BISON_VARARGS = 563,
     TOK_BISON_ENTRY = 564,
     TOK_BISON_EXIT = 565,
     TOK_BISON_NEW = 566,
     TOK_BISON_DELETE = 567,
     TOK_BISON_ASSIGN = 568,
     TOK_BISON_MEMBER = 569,
     TOK_BISON_PUBLIC = 570,
     TOK_BISON_PRIVATE = 571,
     TOK_BISON_PROTECTED = 572,
     TOK_BISON_NORETURN = 573,
     TOK_BISON_NOINLINE = 574,
     TOK_BISON_ALWAYS_INLINE = 575,
     TOK_BISON_UNUSED = 576,
     TOK_BISON_CONST = 577,
     TOK_BISON_TRANSPARENT_UNION = 578,
     TOK_BISON_MODE = 579,
     TOK_BISON_SECTION = 580,
     TOK_BISON_ALIGNED = 581,
     TOK_BISON_WEAK = 582,
     TOK_BISON_ALIAS = 583,
     TOK_BISON_NO_INSTRUMENT_FUNCTION = 584,
     TOK_BISON_MALLOC = 585,
     TOK_BISON_NO_STACK_LIMIT = 586,
     TOK_BISON_NO_STACK = 587,
     TOK_BISON_PURE = 588,
     TOK_BISON_DEPRECATED = 589,
     TOK_BISON_VECTOR_SIZE = 590,
     TOK_BISON_VISIBILITY = 591,
     TOK_BISON_TLS_MODEL = 592,
     TOK_BISON_NONNULL = 593,
     TOK_BISON_NOTHROW = 594,
     TOK_BISON_MAY_ALIAS = 595,
     TOK_BISON_WARN_UNUSED_RESULT = 596,
     TOK_BISON_FORMAT = 597,
     TOK_BISON_FORMAT_ARG = 598,
     TOK_BISON_NULL = 599,
     TOK_BISON_CONVERSION = 600,
     TOK_BISON_VIRTUAL = 601,
     TOK_BISON_MUTABLE = 602,
     TOK_BISON_PSEUDO_TMPL = 603,
     TOK_BISON_SPEC = 604,
     TOK_BISON_LINE = 605,
     TOK_BISON_FIXD = 606,
     TOK_BISON_VECNEW = 607,
     TOK_BISON_VECDELETE = 608,
     TOK_BISON_POS = 609,
     TOK_BISON_NEG = 610,
     TOK_BISON_ADDR = 611,
     TOK_BISON_DEREF = 612,
     TOK_BISON_NOT = 613,
     TOK_BISON_LNOT = 614,
     TOK_BISON_PREINC = 615,
     TOK_BISON_PREDEC = 616,
     TOK_BISON_PLUSASSIGN = 617,
     TOK_BISON_PLUS = 618,
     TOK_BISON_MINUSASSIGN = 619,
     TOK_BISON_MINUS = 620,
     TOK_BISON_MULTASSIGN = 621,
     TOK_BISON_MULT = 622,
     TOK_BISON_DIVASSIGN = 623,
     TOK_BISON_DIV = 624,
     TOK_BISON_MODASSIGN = 625,
     TOK_BISON_MOD = 626,
     TOK_BISON_ANDASSIGN = 627,
     TOK_BISON_AND = 628,
     TOK_BISON_ORASSIGN = 629,
     TOK_BISON_OR = 630,
     TOK_BISON_XORASSIGN = 631,
     TOK_BISON_XOR = 632,
     TOK_BISON_LSHIFTASSIGN = 633,
     TOK_BISON_RSHIFTASSIGN = 634,
     TOK_BISON_RSHIFT = 635,
     TOK_BISON_EQ = 636,
     TOK_BISON_NE = 637,
     TOK_BISON_LT = 638,
     TOK_BISON_GT = 639,
     TOK_BISON_LE = 640,
     TOK_BISON_GE = 641,
     TOK_BISON_LAND = 642,
     TOK_BISON_LOR = 643,
     TOK_BISON_COMPOUND = 644,
     TOK_BISON_MEMREF = 645,
     TOK_BISON_SUBS = 646,
     TOK_BISON_POSTINC = 647,
     TOK_BISON_POSTDEC = 648,
     TOK_BISON_CALL = 649,
     TOK_BISON_THUNK = 650,
     TOK_BISON_THIS_ADJUSTING = 651,
     TOK_BISON_RESULT_ADJUSTING = 652,
     TOK_BISON_PTRMEM = 653,
     TOK_BISON_QUAL_R = 654,
     TOK_BISON_QUAL_V = 655,
     TOK_BISON_QUAL_VR = 656,
     TOK_BISON_QUAL_C = 657,
     TOK_BISON_QUAL_CR = 658,
     TOK_BISON_QUAL_CV = 659,
     TOK_BISON_QUAL_CVR = 660,
     TOK_BISON_TEMPLATE_PARM_INDEX = 661,
     TOK_BISON_INLINE_BODY = 662,
     TOK_BISON_BITFIELD = 663,
     TOK_BISON_WITH_SIZE_EXPR = 664,
     TOK_BISON_OBJ_TYPE_REF = 665,
     TOK_BISON_VUSE = 666,
     TOK_BISON_VUSE_OP = 667,
     TOK_BISON_LOADS = 668,
     TOK_BISON_VDEF = 669,
     TOK_BISON_VDEF_OP = 670,
     TOK_BISON_STORES = 671,
     TOK_BISON_STRUCT_FIELD_TAG = 672,
     TOK_BISON_NAME_MEMORY_TAG = 673,
     TOK_BISON_SYMBOL_MEMORY_TAG = 674,
     TOK_BISON_MEMORY_PARTITION_TAG = 675,
     TOK_BISON_PTR_INFO = 676,
     TOK_BISON_TRUE_EDGE = 677,
     TOK_BISON_FALSE_EDGE = 678,
     TOK_BISON_POINTER_PLUS_EXPR = 679,
     TOK_BISON_TARGET_MEM_REF = 680,
     TOK_BISON_TARGET_MEM_REF461 = 681,
     TOK_BISON_SYMBOL = 682,
     TOK_BISON_BASE = 683,
     TOK_BISON_IDX = 684,
     TOK_BISON_IDX2 = 685,
     TOK_BISON_STEP = 686,
     TOK_BISON_OFFSET = 687,
     TOK_BISON_ORIG = 688,
     TOK_BISON_TAG = 689,
     TOK_BISON_SMT_ANN = 690,
     TOK_BISON_TRAIT_EXPR = 691,
     TOK_BISON_GIMPLE_PREDICT = 692,
     TOK_BISON_MEM_REF = 693,
     TOK_BISON_WIDEN_SUM_EXPR = 694,
     TOK_BISON_WIDEN_MULT_EXPR = 695,
     TOK_BISON_RTL = 696,
     TOK_BISON_ABS_R = 697,
     TOK_BISON_AND_R = 698,
     TOK_BISON_ASHIFT_R = 699,
     TOK_BISON_ASHIFTRT_R = 700,
     TOK_BISON_BSWAP_R = 701,
     TOK_BISON_CALL_R = 702,
     TOK_BISON_CALL_INSN_R = 703,
     TOK_BISON_CLZ_R = 704,
     TOK_BISON_CODE_LABEL_R = 705,
     TOK_BISON_COMPARE_R = 706,
     TOK_BISON_CONCAT_R = 707,
     TOK_BISON_CTZ_R = 708,
     TOK_BISON_DIV_R = 709,
     TOK_BISON_EQ_R = 710,
     TOK_BISON_FFS_R = 711,
     TOK_BISON_FIX_R = 712,
     TOK_BISON_FLOAT_R = 713,
     TOK_BISON_FLOAT_EXTEND_R = 714,
     TOK_BISON_FLOAT_TRUNCATE_R = 715,
     TOK_BISON_FRACT_CONVERT_R = 716,
     TOK_BISON_GE_R = 717,
     TOK_BISON_GEU_R = 718,
     TOK_BISON_GT_R = 719,
     TOK_BISON_GTU_R = 720,
     TOK_BISON_HIGH_R = 721,
     TOK_BISON_IF_THEN_ELSE_R = 722,
     TOK_BISON_INSN_R = 723,
     TOK_BISON_IOR_R = 724,
     TOK_BISON_JUMP_INSN_R = 725,
     TOK_BISON_LABEL_REF_R = 726,
     TOK_BISON_LE_R = 727,
     TOK_BISON_LEU_R = 728,
     TOK_BISON_LSHIFTRT_R = 729,
     TOK_BISON_LO_SUM_R = 730,
     TOK_BISON_LT_R = 731,
     TOK_BISON_LTGT_R = 732,
     TOK_BISON_LTU_R = 733,
     TOK_BISON_WRITE_MEM_R = 734,
     TOK_BISON_READ_MEM_R = 735,
     TOK_BISON_MINUS_R = 736,
     TOK_BISON_MOD_R = 737,
     TOK_BISON_MULT_R = 738,
     TOK_BISON_NE_R = 739,
     TOK_BISON_NEG_R = 740,
     TOK_BISON_NOT_R = 741,
     TOK_BISON_ORDERED_R = 742,
     TOK_BISON_PARALLEL_R = 743,
     TOK_BISON_PARITY_R = 744,
     TOK_BISON_PC_R = 745,
     TOK_BISON_PLUS_R = 746,
     TOK_BISON_POPCOUNT_R = 747,
     TOK_BISON_REG_R = 748,
     TOK_BISON_ROTATE_R = 749,
     TOK_BISON_ROTATERT_R = 750,
     TOK_BISON_SAT_FRACT_R = 751,
     TOK_BISON_SET_R = 752,
     TOK_BISON_SIGN_EXTEND_R = 753,
     TOK_BISON_SMAX_R = 754,
     TOK_BISON_SMIN_R = 755,
     TOK_BISON_SQRT_R = 756,
     TOK_BISON_SYMBOL_REF_R = 757,
     TOK_BISON_TRUNCATE_R = 758,
     TOK_BISON_UDIV_R = 759,
     TOK_BISON_UMAX_R = 760,
     TOK_BISON_UMIN_R = 761,
     TOK_BISON_UMOD_R = 762,
     TOK_BISON_UNEQ_R = 763,
     TOK_BISON_UNGE_R = 764,
     TOK_BISON_UNGT_R = 765,
     TOK_BISON_UNLE_R = 766,
     TOK_BISON_UNLT_R = 767,
     TOK_BISON_UNORDERED_R = 768,
     TOK_BISON_UNSIGNED_FIX_R = 769,
     TOK_BISON_UNSIGNED_FLOAT_R = 770,
     TOK_BISON_UNSIGNED_FRACT_CONVERT_R = 771,
     TOK_BISON_UNSIGNED_SAT_FRACT_R = 772,
     TOK_BISON_XOR_R = 773,
     TOK_BISON_ZERO_EXTEND_R = 774,
     TOK_BISON_QC_R = 775,
     TOK_BISON_HC_R = 776,
     TOK_BISON_SC_R = 777,
     TOK_BISON_DC_R = 778,
     TOK_BISON_TC_R = 779,
     TOK_BISON_CQI_R = 780,
     TOK_BISON_CHI_R = 781,
     TOK_BISON_CSI_R = 782,
     TOK_BISON_CDI_R = 783,
     TOK_BISON_CTI_R = 784,
     TOK_BISON_QF_R = 785,
     TOK_BISON_HF_R = 786,
     TOK_BISON_SF_R = 787,
     TOK_BISON_DF_R = 788,
     TOK_BISON_TF_R = 789,
     TOK_BISON_QI_R = 790,
     TOK_BISON_HI_R = 791,
     TOK_BISON_SI_R = 792,
     TOK_BISON_DO_R = 793,
     TOK_BISON_TI_R = 794,
     TOK_BISON_V2SI_R = 795,
     TOK_BISON_V4HI_R = 796,
     TOK_BISON_V8QI_R = 797,
     TOK_BISON_CC_R = 798,
     TOK_BISON_CCFP_R = 799,
     TOK_BISON_CCFPE_R = 800,
     TOK_BISON_CCZ_R = 801
   };
#endif
/* Tokens.  */
#define NODE_ID 258
#define TOK_BISON_STRING 259
#define TOK_BISON_NUMBER 260
#define TOK_BISON_GCC_VERSION 261
#define TOK_BISON_PLUGIN_VERSION 262
#define TOK_BISON_ERROR_MARK 263
#define TOK_BISON_IDENTIFIER_NODE 264
#define TOK_BISON_TREE_LIST 265
#define TOK_BISON_TREE_VEC 266
#define TOK_BISON_BLOCK 267
#define TOK_BISON_VOID_TYPE 268
#define TOK_BISON_INTEGER_TYPE 269
#define TOK_BISON_REAL_TYPE 270
#define TOK_BISON_COMPLEX_TYPE 271
#define TOK_BISON_VECTOR_TYPE 272
#define TOK_BISON_ENUMERAL_TYPE 273
#define TOK_BISON_BOOLEAN_TYPE 274
#define TOK_BISON_CHAR_TYPE 275
#define TOK_BISON_POINTER_TYPE 276
#define TOK_BISON_OFFSET_TYPE 277
#define TOK_BISON_REFERENCE_TYPE 278
#define TOK_BISON_METHOD_TYPE 279
#define TOK_BISON_ARRAY_TYPE 280
#define TOK_BISON_SET_TYPE 281
#define TOK_BISON_RECORD_TYPE 282
#define TOK_BISON_UNION_TYPE 283
#define TOK_BISON_QUAL_UNION_TYPE 284
#define TOK_BISON_FUNCTION_TYPE 285
#define TOK_BISON_LANG_TYPE 286
#define TOK_BISON_INTEGER_CST 287
#define TOK_BISON_REAL_CST 288
#define TOK_BISON_COMPLEX_CST 289
#define TOK_BISON_VECTOR_CST 290
#define TOK_BISON_STRING_CST 291
#define TOK_BISON_FUNCTION_DECL 292
#define TOK_BISON_LABEL_DECL 293
#define TOK_BISON_CONST_DECL 294
#define TOK_BISON_TYPE_DECL 295
#define TOK_BISON_VAR_DECL 296
#define TOK_BISON_PARM_DECL 297
#define TOK_BISON_RESULT_DECL 298
#define TOK_BISON_FIELD_DECL 299
#define TOK_BISON_NAMESPACE_DECL 300
#define TOK_BISON_TRANSLATION_UNIT_DECL 301
#define TOK_BISON_COMPONENT_REF 302
#define TOK_BISON_BIT_FIELD_REF 303
#define TOK_BISON_INDIRECT_REF 304
#define TOK_BISON_BUFFER_REF 305
#define TOK_BISON_ARRAY_REF 306
#define TOK_BISON_ARRAY_RANGE_REF 307
#define TOK_BISON_VTABLE_REF 308
#define TOK_BISON_EXC_PTR_EXPR 309
#define TOK_BISON_FILTER_EXPR 310
#define TOK_BISON_CONSTRUCTOR 311
#define TOK_BISON_DESTRUCTOR 312
#define TOK_BISON_COMPOUND_EXPR 313
#define TOK_BISON_MODIFY_EXPR 314
#define TOK_BISON_GIMPLE_ASSIGN 315
#define TOK_BISON_INIT_EXPR 316
#define TOK_BISON_TARGET_EXPR 317
#define TOK_BISON_COND_EXPR 318
#define TOK_BISON_GIMPLE_COND 319
#define TOK_BISON_GIMPLE_BIND 320
#define TOK_BISON_LABELED_BLOCK_EXPR 321
#define TOK_BISON_GIMPLE_CALL 322
#define TOK_BISON_CALL_EXPR 323
#define TOK_BISON_WITH_CLEANUP_EXPR 324
#define TOK_BISON_GIMPLE_NOP 325
#define TOK_BISON_CLEANUP_POINT_EXPR 326
#define TOK_BISON_PLACEHOLDER_EXPR 327
#define TOK_BISON_PLUS_EXPR 328
#define TOK_BISON_MINUS_EXPR 329
#define TOK_BISON_MULT_EXPR 330
#define TOK_BISON_TRUNC_DIV_EXPR 331
#define TOK_BISON_CEIL_DIV_EXPR 332
#define TOK_BISON_FLOOR_DIV_EXPR 333
#define TOK_BISON_ROUND_DIV_EXPR 334
#define TOK_BISON_TRUNC_MOD_EXPR 335
#define TOK_BISON_CEIL_MOD_EXPR 336
#define TOK_BISON_FLOOR_MOD_EXPR 337
#define TOK_BISON_ROUND_MOD_EXPR 338
#define TOK_BISON_RDIV_EXPR 339
#define TOK_BISON_EXACT_DIV_EXPR 340
#define TOK_BISON_FIX_TRUNC_EXPR 341
#define TOK_BISON_FIX_CEIL_EXPR 342
#define TOK_BISON_FIX_FLOOR_EXPR 343
#define TOK_BISON_FIX_ROUND_EXPR 344
#define TOK_BISON_FLOAT_EXPR 345
#define TOK_BISON_NEGATE_EXPR 346
#define TOK_BISON_MIN_EXPR 347
#define TOK_BISON_MAX_EXPR 348
#define TOK_BISON_ABS_EXPR 349
#define TOK_BISON_LSHIFT_EXPR 350
#define TOK_BISON_RSHIFT_EXPR 351
#define TOK_BISON_LROTATE_EXPR 352
#define TOK_BISON_RROTATE_EXPR 353
#define TOK_BISON_BIT_IOR_EXPR 354
#define TOK_BISON_BIT_XOR_EXPR 355
#define TOK_BISON_BIT_AND_EXPR 356
#define TOK_BISON_BIT_NOT_EXPR 357
#define TOK_BISON_TRUTH_ANDIF_EXPR 358
#define TOK_BISON_TRUTH_ORIF_EXPR 359
#define TOK_BISON_TRUTH_AND_EXPR 360
#define TOK_BISON_TRUTH_OR_EXPR 361
#define TOK_BISON_TRUTH_XOR_EXPR 362
#define TOK_BISON_TRUTH_NOT_EXPR 363
#define TOK_BISON_LT_EXPR 364
#define TOK_BISON_LE_EXPR 365
#define TOK_BISON_GT_EXPR 366
#define TOK_BISON_GE_EXPR 367
#define TOK_BISON_EQ_EXPR 368
#define TOK_BISON_NE_EXPR 369
#define TOK_BISON_UNORDERED_EXPR 370
#define TOK_BISON_ORDERED_EXPR 371
#define TOK_BISON_UNLT_EXPR 372
#define TOK_BISON_UNLE_EXPR 373
#define TOK_BISON_UNGT_EXPR 374
#define TOK_BISON_UNGE_EXPR 375
#define TOK_BISON_UNEQ_EXPR 376
#define TOK_BISON_LTGT_EXPR 377
#define TOK_BISON_IN_EXPR 378
#define TOK_BISON_SET_LE_EXPR 379
#define TOK_BISON_CARD_EXPR 380
#define TOK_BISON_RANGE_EXPR 381
#define TOK_BISON_CONVERT_EXPR 382
#define TOK_BISON_NOP_EXPR 383
#define TOK_BISON_NON_LVALUE_EXPR 384
#define TOK_BISON_VIEW_CONVERT_EXPR 385
#define TOK_BISON_SAVE_EXPR 386
#define TOK_BISON_UNSAVE_EXPR 387
#define TOK_BISON_ADDR_EXPR 388
#define TOK_BISON_REFERENCE_EXPR 389
#define TOK_BISON_FDESC_EXPR 390
#define TOK_BISON_COMPLEX_EXPR 391
#define TOK_BISON_CONJ_EXPR 392
#define TOK_BISON_REALPART_EXPR 393
#define TOK_BISON_IMAGPART_EXPR 394
#define TOK_BISON_PREDECREMENT_EXPR 395
#define TOK_BISON_PREINCREMENT_EXPR 396
#define TOK_BISON_POSTDECREMENT_EXPR 397
#define TOK_BISON_POSTINCREMENT_EXPR 398
#define TOK_BISON_VA_ARG_EXPR 399
#define TOK_BISON_TRY_CATCH_EXPR 400
#define TOK_BISON_TRY_FINALLY 401
#define TOK_BISON_ 402
#define TOK_BISON_GIMPLE_GOTO 403
#define TOK_BISON_GOTO_SUBROUTINE 404
#define TOK_BISON_GIMPLE_RETURN 405
#define TOK_BISON_EXIT_EXPR 406
#define TOK_BISON_LOOP_EXPR 407
#define TOK_BISON_EXIT_BLOCK_EXPR 408
#define TOK_BISON_GIMPLE_SWITCH 409
#define TOK_BISON_CASE_LABEL_EXPR 410
#define TOK_BISON_GIMPLE_RESX 411
#define TOK_BISON_GIMPLE_ASM 412
#define TOK_BISON_SSA_NAME 413
#define TOK_BISON_GIMPLE_PHI 414
#define TOK_BISON_CATCH_EXPR 415
#define TOK_BISON_EH_FILTER_EXPR 416
#define TOK_BISON_STATEMENT_LIST 417
#define TOK_BISON_TEMPLATE_DECL 418
#define TOK_BISON_TEMPLATE_TYPE_PARM 419
#define TOK_BISON_CAST_EXPR 420
#define TOK_BISON_STATIC_CAST_EXPR 421
#define TOK_BISON_TYPENAME_TYPE 422
#define TOK_BISON_SIZEOF_EXPR 423
#define TOK_BISON_AGGR_INIT_EXPR 424
#define TOK_BISON_SCOPE_REF 425
#define TOK_BISON_COMPOUND_STMT 426
#define TOK_BISON_CTOR_INITIALIZER 427
#define TOK_BISON_DECL_STMT 428
#define TOK_BISON_DO_STMT 429
#define TOK_BISON_EXPR_STMT 430
#define TOK_BISON_FOR_STMT 431
#define TOK_BISON_IF_STMT 432
#define TOK_BISON_RETURN_STMT 433
#define TOK_BISON_WHILE_STMT 434
#define TOK_BISON_MODOP_EXPR 435
#define TOK_BISON_NEW_EXPR 436
#define TOK_BISON_VEC_NEW_EXPR 437
#define TOK_BISON_OVERLOAD 438
#define TOK_BISON_REINTERPRET_CAST_EXPR 439
#define TOK_BISON_TEMPLATE_ID_EXPR 440
#define TOK_BISON_THROW_EXPR 441
#define TOK_BISON_TRY_BLOCK 442
#define TOK_BISON_ARROW_EXPR 443
#define TOK_BISON_HANDLER 444
#define TOK_BISON_BASELINK 445
#define TOK_BISON_NAME 446
#define TOK_BISON_TYPE 447
#define TOK_BISON_SRCP 448
#define TOK_BISON_ARG 449
#define TOK_BISON_BODY 450
#define TOK_BISON_STRG 451
#define TOK_BISON_LNGT 452
#define TOK_BISON_SIZE 453
#define TOK_BISON_ALGN 454
#define TOK_BISON_RETN 455
#define TOK_BISON_PRMS 456
#define TOK_BISON_SCPE 457
#define TOK_BISON_USED 458
#define TOK_BISON_VALUE 459
#define TOK_BISON_ARGT 460
#define TOK_BISON_PREC 461
#define TOK_BISON_MIN 462
#define TOK_BISON_MAX 463
#define TOK_BISON_VALU 464
#define TOK_BISON_CHAN 465
#define TOK_BISON_STMT 466
#define TOK_BISON_OP 467
#define TOK_BISON_TIME_WEIGHT 468
#define TOK_BISON_SIZE_WEIGHT 469
#define TOK_BISON_RTL_SIZE_WEIGHT 470
#define TOK_BISON_VARS 471
#define TOK_BISON_UNQL 472
#define TOK_BISON_ELTS 473
#define TOK_BISON_DOMN 474
#define TOK_BISON_BLOC 475
#define TOK_BISON_DCLS 476
#define TOK_BISON_MNGL 477
#define TOK_BISON_PTD 478
#define TOK_BISON_REFD 479
#define TOK_BISON_QUAL 480
#define TOK_BISON_VALR 481
#define TOK_BISON_VALX 482
#define TOK_BISON_FLDS 483
#define TOK_BISON_VFLD 484
#define TOK_BISON_BPOS 485
#define TOK_BISON_FN 486
#define TOK_BISON_GOTO 487
#define TOK_BISON_REAL 488
#define TOK_BISON_IMAG 489
#define TOK_BISON_BINFO 490
#define TOK_BISON_PUB 491
#define TOK_BISON_PROT 492
#define TOK_BISON_PRIV 493
#define TOK_BISON_BINF 494
#define TOK_BISON_UID 495
#define TOK_BISON_OLD_UID 496
#define TOK_BISON_INIT 497
#define TOK_BISON_FINI 498
#define TOK_BISON_PURP 499
#define TOK_BISON_PRED 500
#define TOK_BISON_SUCC 501
#define TOK_BISON_HPL 502
#define TOK_BISON_ATTRIBUTES 503
#define TOK_BISON_PHI 504
#define TOK_BISON_RES 505
#define TOK_BISON_DEF 506
#define TOK_BISON_EDGE 507
#define TOK_BISON_VAR 508
#define TOK_BISON_DEF_STMT 509
#define TOK_BISON_VERS 510
#define TOK_BISON_CNST 511
#define TOK_BISON_CLAS 512
#define TOK_BISON_DECL 513
#define TOK_BISON_CLNP 514
#define TOK_BISON_LAB 515
#define TOK_BISON_TRY 516
#define TOK_BISON_EX 517
#define TOK_BISON_OUT 518
#define TOK_BISON_IN 519
#define TOK_BISON_STR 520
#define TOK_BISON_CLOB 521
#define TOK_BISON_REF 522
#define TOK_BISON_FNCS 523
#define TOK_BISON_CSTS 524
#define TOK_BISON_RSLT 525
#define TOK_BISON_INST 526
#define TOK_BISON_SPCS 527
#define TOK_BISON_CLS 528
#define TOK_BISON_BFLD 529
#define TOK_BISON_CTOR 530
#define TOK_BISON_NEXT 531
#define TOK_BISON_COND 532
#define TOK_BISON_EXPR 533
#define TOK_BISON_THEN 534
#define TOK_BISON_ELSE 535
#define TOK_BISON_CRNT 536
#define TOK_BISON_HDLR 537
#define TOK_BISON_USE_TMPL 538
#define TOK_BISON_TMPL_PARMS 539
#define TOK_BISON_TMPL_ARGS 540
#define TOK_BISON_ARTIFICIAL 541
#define TOK_BISON_SYSTEM 542
#define TOK_BISON_OPERATING_SYSTEM 543
#define TOK_BISON_LIBRARY_SYSTEM 544
#define TOK_BISON_EXTERN 545
#define TOK_BISON_C 546
#define TOK_BISON_LSHIFT 547
#define TOK_BISON_GLOBAL_INIT 548
#define TOK_BISON_GLOBAL_FINI 549
#define TOK_BISON_UNDEFINED 550
#define TOK_BISON_OPERATOR 551
#define TOK_BISON_OVERFLOW 552
#define TOK_BISON_VIRT 553
#define TOK_BISON_UNSIGNED 554
#define TOK_BISON_STRUCT 555
#define TOK_BISON_UNION 556
#define TOK_BISON_REGISTER 557
#define TOK_BISON_STATIC 558
#define TOK_BISON_DEFAULT 559
#define TOK_BISON_VOLATILE 560
#define TOK_BISON_INF 561
#define TOK_BISON_NAN 562
#define TOK_BISON_VARARGS 563
#define TOK_BISON_ENTRY 564
#define TOK_BISON_EXIT 565
#define TOK_BISON_NEW 566
#define TOK_BISON_DELETE 567
#define TOK_BISON_ASSIGN 568
#define TOK_BISON_MEMBER 569
#define TOK_BISON_PUBLIC 570
#define TOK_BISON_PRIVATE 571
#define TOK_BISON_PROTECTED 572
#define TOK_BISON_NORETURN 573
#define TOK_BISON_NOINLINE 574
#define TOK_BISON_ALWAYS_INLINE 575
#define TOK_BISON_UNUSED 576
#define TOK_BISON_CONST 577
#define TOK_BISON_TRANSPARENT_UNION 578
#define TOK_BISON_MODE 579
#define TOK_BISON_SECTION 580
#define TOK_BISON_ALIGNED 581
#define TOK_BISON_WEAK 582
#define TOK_BISON_ALIAS 583
#define TOK_BISON_NO_INSTRUMENT_FUNCTION 584
#define TOK_BISON_MALLOC 585
#define TOK_BISON_NO_STACK_LIMIT 586
#define TOK_BISON_NO_STACK 587
#define TOK_BISON_PURE 588
#define TOK_BISON_DEPRECATED 589
#define TOK_BISON_VECTOR_SIZE 590
#define TOK_BISON_VISIBILITY 591
#define TOK_BISON_TLS_MODEL 592
#define TOK_BISON_NONNULL 593
#define TOK_BISON_NOTHROW 594
#define TOK_BISON_MAY_ALIAS 595
#define TOK_BISON_WARN_UNUSED_RESULT 596
#define TOK_BISON_FORMAT 597
#define TOK_BISON_FORMAT_ARG 598
#define TOK_BISON_NULL 599
#define TOK_BISON_CONVERSION 600
#define TOK_BISON_VIRTUAL 601
#define TOK_BISON_MUTABLE 602
#define TOK_BISON_PSEUDO_TMPL 603
#define TOK_BISON_SPEC 604
#define TOK_BISON_LINE 605
#define TOK_BISON_FIXD 606
#define TOK_BISON_VECNEW 607
#define TOK_BISON_VECDELETE 608
#define TOK_BISON_POS 609
#define TOK_BISON_NEG 610
#define TOK_BISON_ADDR 611
#define TOK_BISON_DEREF 612
#define TOK_BISON_NOT 613
#define TOK_BISON_LNOT 614
#define TOK_BISON_PREINC 615
#define TOK_BISON_PREDEC 616
#define TOK_BISON_PLUSASSIGN 617
#define TOK_BISON_PLUS 618
#define TOK_BISON_MINUSASSIGN 619
#define TOK_BISON_MINUS 620
#define TOK_BISON_MULTASSIGN 621
#define TOK_BISON_MULT 622
#define TOK_BISON_DIVASSIGN 623
#define TOK_BISON_DIV 624
#define TOK_BISON_MODASSIGN 625
#define TOK_BISON_MOD 626
#define TOK_BISON_ANDASSIGN 627
#define TOK_BISON_AND 628
#define TOK_BISON_ORASSIGN 629
#define TOK_BISON_OR 630
#define TOK_BISON_XORASSIGN 631
#define TOK_BISON_XOR 632
#define TOK_BISON_LSHIFTASSIGN 633
#define TOK_BISON_RSHIFTASSIGN 634
#define TOK_BISON_RSHIFT 635
#define TOK_BISON_EQ 636
#define TOK_BISON_NE 637
#define TOK_BISON_LT 638
#define TOK_BISON_GT 639
#define TOK_BISON_LE 640
#define TOK_BISON_GE 641
#define TOK_BISON_LAND 642
#define TOK_BISON_LOR 643
#define TOK_BISON_COMPOUND 644
#define TOK_BISON_MEMREF 645
#define TOK_BISON_SUBS 646
#define TOK_BISON_POSTINC 647
#define TOK_BISON_POSTDEC 648
#define TOK_BISON_CALL 649
#define TOK_BISON_THUNK 650
#define TOK_BISON_THIS_ADJUSTING 651
#define TOK_BISON_RESULT_ADJUSTING 652
#define TOK_BISON_PTRMEM 653
#define TOK_BISON_QUAL_R 654
#define TOK_BISON_QUAL_V 655
#define TOK_BISON_QUAL_VR 656
#define TOK_BISON_QUAL_C 657
#define TOK_BISON_QUAL_CR 658
#define TOK_BISON_QUAL_CV 659
#define TOK_BISON_QUAL_CVR 660
#define TOK_BISON_TEMPLATE_PARM_INDEX 661
#define TOK_BISON_INLINE_BODY 662
#define TOK_BISON_BITFIELD 663
#define TOK_BISON_WITH_SIZE_EXPR 664
#define TOK_BISON_OBJ_TYPE_REF 665
#define TOK_BISON_VUSE 666
#define TOK_BISON_VUSE_OP 667
#define TOK_BISON_LOADS 668
#define TOK_BISON_VDEF 669
#define TOK_BISON_VDEF_OP 670
#define TOK_BISON_STORES 671
#define TOK_BISON_STRUCT_FIELD_TAG 672
#define TOK_BISON_NAME_MEMORY_TAG 673
#define TOK_BISON_SYMBOL_MEMORY_TAG 674
#define TOK_BISON_MEMORY_PARTITION_TAG 675
#define TOK_BISON_PTR_INFO 676
#define TOK_BISON_TRUE_EDGE 677
#define TOK_BISON_FALSE_EDGE 678
#define TOK_BISON_POINTER_PLUS_EXPR 679
#define TOK_BISON_TARGET_MEM_REF 680
#define TOK_BISON_TARGET_MEM_REF461 681
#define TOK_BISON_SYMBOL 682
#define TOK_BISON_BASE 683
#define TOK_BISON_IDX 684
#define TOK_BISON_IDX2 685
#define TOK_BISON_STEP 686
#define TOK_BISON_OFFSET 687
#define TOK_BISON_ORIG 688
#define TOK_BISON_TAG 689
#define TOK_BISON_SMT_ANN 690
#define TOK_BISON_TRAIT_EXPR 691
#define TOK_BISON_GIMPLE_PREDICT 692
#define TOK_BISON_MEM_REF 693
#define TOK_BISON_WIDEN_SUM_EXPR 694
#define TOK_BISON_WIDEN_MULT_EXPR 695
#define TOK_BISON_RTL 696
#define TOK_BISON_ABS_R 697
#define TOK_BISON_AND_R 698
#define TOK_BISON_ASHIFT_R 699
#define TOK_BISON_ASHIFTRT_R 700
#define TOK_BISON_BSWAP_R 701
#define TOK_BISON_CALL_R 702
#define TOK_BISON_CALL_INSN_R 703
#define TOK_BISON_CLZ_R 704
#define TOK_BISON_CODE_LABEL_R 705
#define TOK_BISON_COMPARE_R 706
#define TOK_BISON_CONCAT_R 707
#define TOK_BISON_CTZ_R 708
#define TOK_BISON_DIV_R 709
#define TOK_BISON_EQ_R 710
#define TOK_BISON_FFS_R 711
#define TOK_BISON_FIX_R 712
#define TOK_BISON_FLOAT_R 713
#define TOK_BISON_FLOAT_EXTEND_R 714
#define TOK_BISON_FLOAT_TRUNCATE_R 715
#define TOK_BISON_FRACT_CONVERT_R 716
#define TOK_BISON_GE_R 717
#define TOK_BISON_GEU_R 718
#define TOK_BISON_GT_R 719
#define TOK_BISON_GTU_R 720
#define TOK_BISON_HIGH_R 721
#define TOK_BISON_IF_THEN_ELSE_R 722
#define TOK_BISON_INSN_R 723
#define TOK_BISON_IOR_R 724
#define TOK_BISON_JUMP_INSN_R 725
#define TOK_BISON_LABEL_REF_R 726
#define TOK_BISON_LE_R 727
#define TOK_BISON_LEU_R 728
#define TOK_BISON_LSHIFTRT_R 729
#define TOK_BISON_LO_SUM_R 730
#define TOK_BISON_LT_R 731
#define TOK_BISON_LTGT_R 732
#define TOK_BISON_LTU_R 733
#define TOK_BISON_WRITE_MEM_R 734
#define TOK_BISON_READ_MEM_R 735
#define TOK_BISON_MINUS_R 736
#define TOK_BISON_MOD_R 737
#define TOK_BISON_MULT_R 738
#define TOK_BISON_NE_R 739
#define TOK_BISON_NEG_R 740
#define TOK_BISON_NOT_R 741
#define TOK_BISON_ORDERED_R 742
#define TOK_BISON_PARALLEL_R 743
#define TOK_BISON_PARITY_R 744
#define TOK_BISON_PC_R 745
#define TOK_BISON_PLUS_R 746
#define TOK_BISON_POPCOUNT_R 747
#define TOK_BISON_REG_R 748
#define TOK_BISON_ROTATE_R 749
#define TOK_BISON_ROTATERT_R 750
#define TOK_BISON_SAT_FRACT_R 751
#define TOK_BISON_SET_R 752
#define TOK_BISON_SIGN_EXTEND_R 753
#define TOK_BISON_SMAX_R 754
#define TOK_BISON_SMIN_R 755
#define TOK_BISON_SQRT_R 756
#define TOK_BISON_SYMBOL_REF_R 757
#define TOK_BISON_TRUNCATE_R 758
#define TOK_BISON_UDIV_R 759
#define TOK_BISON_UMAX_R 760
#define TOK_BISON_UMIN_R 761
#define TOK_BISON_UMOD_R 762
#define TOK_BISON_UNEQ_R 763
#define TOK_BISON_UNGE_R 764
#define TOK_BISON_UNGT_R 765
#define TOK_BISON_UNLE_R 766
#define TOK_BISON_UNLT_R 767
#define TOK_BISON_UNORDERED_R 768
#define TOK_BISON_UNSIGNED_FIX_R 769
#define TOK_BISON_UNSIGNED_FLOAT_R 770
#define TOK_BISON_UNSIGNED_FRACT_CONVERT_R 771
#define TOK_BISON_UNSIGNED_SAT_FRACT_R 772
#define TOK_BISON_XOR_R 773
#define TOK_BISON_ZERO_EXTEND_R 774
#define TOK_BISON_QC_R 775
#define TOK_BISON_HC_R 776
#define TOK_BISON_SC_R 777
#define TOK_BISON_DC_R 778
#define TOK_BISON_TC_R 779
#define TOK_BISON_CQI_R 780
#define TOK_BISON_CHI_R 781
#define TOK_BISON_CSI_R 782
#define TOK_BISON_CDI_R 783
#define TOK_BISON_CTI_R 784
#define TOK_BISON_QF_R 785
#define TOK_BISON_HF_R 786
#define TOK_BISON_SF_R 787
#define TOK_BISON_DF_R 788
#define TOK_BISON_TF_R 789
#define TOK_BISON_QI_R 790
#define TOK_BISON_HI_R 791
#define TOK_BISON_SI_R 792
#define TOK_BISON_DO_R 793
#define TOK_BISON_TI_R 794
#define TOK_BISON_V2SI_R 795
#define TOK_BISON_V4HI_R 796
#define TOK_BISON_V8QI_R 797
#define TOK_BISON_CC_R 798
#define TOK_BISON_CCFP_R 799
#define TOK_BISON_CCFPE_R 800
#define TOK_BISON_CCZ_R 801




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{


const char *text;
int value;
long long int long_value;
bool pred;



} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2113

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  547
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  752
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1291
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1724

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   801

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    13,    14,    20,    21,
      25,    27,    29,    31,    33,    35,    37,    39,    41,    43,
      45,    47,    49,    51,    53,    55,    57,    59,    61,    63,
      65,    67,    69,    71,    73,    75,    77,    79,    81,    83,
      85,    87,    89,    91,    93,    95,    97,    99,   101,   103,
     105,   107,   109,   111,   113,   115,   117,   119,   121,   123,
     125,   127,   129,   131,   133,   135,   137,   139,   141,   143,
     145,   147,   149,   151,   153,   155,   157,   159,   161,   163,
     165,   167,   169,   171,   173,   175,   177,   179,   181,   183,
     185,   187,   189,   191,   193,   195,   197,   199,   201,   203,
     205,   207,   209,   211,   213,   215,   217,   219,   221,   223,
     225,   227,   229,   231,   233,   235,   237,   239,   241,   243,
     245,   247,   249,   251,   253,   255,   257,   259,   261,   263,
     265,   267,   269,   271,   273,   275,   277,   279,   281,   283,
     285,   287,   289,   291,   293,   295,   297,   299,   301,   303,
     305,   307,   309,   311,   313,   315,   317,   319,   321,   323,
     325,   327,   329,   331,   333,   335,   337,   339,   341,   343,
     345,   347,   349,   351,   353,   355,   357,   359,   361,   363,
     365,   367,   369,   371,   373,   375,   377,   379,   381,   383,
     385,   387,   389,   391,   393,   395,   397,   399,   401,   403,
     405,   407,   409,   410,   412,   413,   415,   416,   419,   420,
     421,   425,   426,   429,   430,   431,   435,   436,   437,   438,
     439,   440,   459,   460,   465,   468,   469,   470,   471,   480,
     481,   483,   484,   486,   487,   488,   489,   490,   491,   505,
     506,   507,   511,   512,   518,   519,   520,   526,   527,   528,
     529,   537,   538,   541,   543,   545,   548,   549,   551,   552,
     553,   554,   555,   556,   557,   575,   576,   577,   578,   586,
     587,   591,   592,   596,   597,   601,   602,   604,   605,   610,
     611,   616,   617,   621,   622,   626,   627,   631,   632,   636,
     637,   641,   642,   646,   647,   652,   653,   655,   656,   657,
     658,   659,   671,   672,   674,   675,   676,   677,   678,   690,
     691,   696,   697,   702,   703,   704,   711,   712,   714,   715,
     717,   718,   720,   721,   724,   725,   728,   729,   730,   734,
     735,   736,   737,   738,   739,   758,   759,   762,   763,   766,
     767,   775,   776,   777,   778,   787,   788,   789,   793,   794,
     799,   800,   804,   805,   809,   810,   815,   816,   821,   822,
     823,   824,   825,   836,   837,   838,   839,   840,   841,   855,
     856,   857,   858,   859,   870,   871,   875,   876,   880,   881,
     886,   887,   892,   893,   898,   899,   903,   904,   908,   909,
     913,   914,   918,   919,   923,   924,   928,   929,   933,   934,
     938,   939,   943,   944,   948,   949,   953,   954,   958,   959,
     963,   964,   968,   969,   973,   974,   978,   979,   983,   984,
     988,   989,   993,   994,   998,   999,  1003,  1004,  1008,  1009,
    1013,  1014,  1018,  1019,  1023,  1024,  1028,  1029,  1033,  1034,
    1038,  1039,  1043,  1044,  1048,  1049,  1053,  1054,  1058,  1059,
    1063,  1064,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1089,
    1090,  1094,  1095,  1099,  1100,  1104,  1105,  1109,  1110,  1114,
    1115,  1119,  1120,  1124,  1125,  1129,  1130,  1134,  1135,  1139,
    1140,  1144,  1145,  1149,  1150,  1154,  1155,  1159,  1160,  1164,
    1165,  1169,  1170,  1174,  1175,  1179,  1180,  1184,  1185,  1189,
    1190,  1194,  1195,  1199,  1200,  1204,  1205,  1209,  1210,  1214,
    1215,  1219,  1220,  1224,  1225,  1229,  1230,  1234,  1235,  1239,
    1240,  1244,  1245,  1249,  1250,  1254,  1255,  1259,  1260,  1264,
    1265,  1269,  1270,  1274,  1275,  1279,  1280,  1284,  1285,  1289,
    1290,  1294,  1295,  1299,  1300,  1304,  1305,  1309,  1310,  1314,
    1315,  1319,  1320,  1324,  1325,  1329,  1330,  1334,  1335,  1339,
    1340,  1344,  1345,  1349,  1351,  1354,  1355,  1356,  1362,  1363,
    1367,  1368,  1372,  1373,  1377,  1378,  1382,  1383,  1387,  1388,
    1392,  1393,  1397,  1398,  1399,  1400,  1401,  1411,  1413,  1416,
    1417,  1419,  1420,  1421,  1427,  1428,  1432,  1433,  1434,  1438,
    1439,  1443,  1444,  1445,  1452,  1453,  1454,  1455,  1456,  1457,
    1470,  1472,  1474,  1476,  1479,  1480,  1482,  1483,  1484,  1491,
    1492,  1493,  1500,  1501,  1503,  1504,  1508,  1509,  1510,  1517,
    1519,  1522,  1524,  1527,  1528,  1530,  1532,  1533,  1537,  1538,
    1542,  1543,  1544,  1550,  1551,  1555,  1557,  1558,  1561,  1564,
    1565,  1566,  1573,  1574,  1578,  1579,  1581,  1582,  1583,  1584,
    1593,  1595,  1596,  1597,  1598,  1606,  1607,  1608,  1614,  1615,
    1616,  1623,  1624,  1628,  1629,  1630,  1636,  1638,  1639,  1643,
    1644,  1648,  1649,  1650,  1651,  1659,  1660,  1661,  1662,  1670,
    1671,  1672,  1679,  1680,  1684,  1686,  1687,  1688,  1694,  1695,
    1698,  1699,  1703,  1705,  1706,  1707,  1713,  1714,  1718,  1719,
    1720,  1721,  1730,  1731,  1736,  1737,  1741,  1742,  1744,  1745,
    1746,  1747,  1748,  1760,  1761,  1765,  1767,  1768,  1774,  1775,
    1778,  1779,  1783,  1784,  1788,  1789,  1793,  1794,  1796,  1797,
    1798,  1805,  1806,  1810,  1811,  1815,  1816,  1817,  1824,  1825,
    1826,  1830,  1831,  1832,  1839,  1840,  1841,  1845,  1846,  1850,
    1851,  1855,  1857,  1858,  1862,  1863,  1867,  1868,  1870,  1871,
    1873,  1874,  1876,  1877,  1879,  1880,  1882,  1883,  1885,  1886,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1922,  1923,  1924,  1925,  1926,  1937,  1938,  1939,  1940,
    1941,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1972,  1973,
    1976,  1979,  1982,  1985,  1988,  1991,  1994,  1995,  1998,  2000,
    2002,  2004,  2006,  2008,  2010,  2012,  2014,  2016,  2018,  2020,
    2022,  2024,  2026,  2028,  2030,  2032,  2034,  2036,  2038,  2040,
    2042,  2044,  2046,  2048,  2050,  2052,  2054,  2056,  2058,  2060,
    2062,  2064,  2066,  2068,  2070,  2072,  2074,  2076,  2078,  2080,
    2082,  2084,  2086,  2088,  2090,  2092,  2094,  2096,  2098,  2100,
    2102,  2104,  2106,  2108,  2110,  2112,  2114,  2116,  2118,  2120,
    2122,  2124,  2126,  2128,  2130,  2132,  2134,  2136,  2138,  2140,
    2142,  2144,  2146,  2148,  2150,  2152,  2154,  2156,  2158,  2160,
    2162,  2164,  2166,  2168,  2170,  2172,  2174,  2176,  2178,  2180,
    2182,  2185,  2186,  2191,  2192,  2193,  2200,  2201,  2202,  2209,
    2210,  2212,  2213,  2217,  2218,  2219,  2220,  2227,  2228,  2230,
    2232,  2235,  2236,  2239,  2240,  2243,  2244,  2247,  2248,  2253,
    2255,  2257,  2259,  2261,  2263,  2265,  2267,  2269,  2271,  2273,
    2275,  2277,  2279,  2281,  2283,  2285,  2287,  2289,  2291,  2293,
    2295,  2297,  2299,  2301,  2303,  2305,  2307,  2309,  2311,  2313,
    2315,  2317,  2319,  2321,  2323,  2325,  2327,  2329,  2331,  2333,
    2335,  2337,  2339,  2341,  2343,  2345,  2347,  2349,  2351,  2353,
    2355,  2357,  2359,  2361,  2363,  2365,  2367,  2369,  2371,  2373,
    2375,  2377,  2379,  2381,  2383,  2385,  2387,  2389,  2391,  2393,
    2395,  2397,  2399,  2401,  2403,  2405,  2407,  2409,  2410,  2412,
    2414,  2416,  2418,  2420,  2422,  2424,  2426,  2428,  2430,  2432,
    2434,  2436,  2438,  2440,  2442,  2444,  2446,  2448,  2450,  2452,
    2454,  2456,  2458,  2460,  2462,  2464,  2465,  2466,  2467,  2468,
    2483,  2486,  2489,  2492,  2495,  2496,  2497,  2501,  2502,  2505,
    2507,  2510,  2511,  2516,  2517,  2520,  2522,  2525,  2527,  2530,
    2531,  2533,  2534,  2535,  2542,  2543,  2546,  2547,  2550,  2553,
    2554,  2557,  2558,  2562,  2563,  2567,  2568,  2572,  2573,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,
    2617,  2641,  2643,  2644,  2647,  2648,  2651,  2652,  2655,  2658,
    2661,  2664,  2667,  2670,  2673,  2676,  2679,  2682,  2685,  2688,
    2691,  2694,  2697,  2700,  2703,  2706,  2709,  2712,  2715,  2718,
    2721,  2724,  2727,  2730,  2733,  2736,  2739,  2742,  2745,  2748,
    2751,  2754,  2757,  2760,  2763,  2766,  2769,  2772,  2775,  2778,
    2781,  2784,  2787,  2790,  2793,  2796,  2799,  2802,  2805,  2808,
    2811,  2814,  2817,  2818,  2821,  2822,  2825,  2826,  2829,  2830,
    2833,  2834,  2837,  2838,  2841,  2842,  2845,  2846,  2849,  2850,
    2853,  2854,  2857,  2858,  2861,  2862,  2865,  2866,  2869,  2870,
    2873,  2874,  2877,  2878,  2881,  2882,  2885,  2886,  2889,  2890,
    2893,  2894,  2897,  2898,  2901,  2902,  2905,  2906,  2909,  2910,
    2912,  2913,  2916,  2917,  2920,  2921,  2924,  2925,  2928,  2929,
    2932,  2933,  2936,  2937,  2940,  2941,  2944,  2945,  2948,  2949,
    2952,  2953,  2956,  2957,  2960,  2961,  2964,  2967,  2968,  2971,
    2972,  2975,  2976,  2979,  2980,  2983,  2984,  2987,  2988,  2991,
    2992,  2995,  2996,  2999,  3000,  3003,  3004,  3007,  3008,  3011,
    3012,  3015,  3016,  3019,  3020,  3023,  3024,  3027,  3028,  3031,
    3032,  3035,  3036,  3039,  3040,  3043,  3044,  3047,  3049,  3051,
    3053,  3054
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     548,     0,    -1,   549,    -1,   548,   549,    -1,   550,    -1,
     549,   552,    -1,    -1,     6,  1296,   551,     7,  1296,    -1,
      -1,     3,   553,   554,    -1,   563,    -1,   569,    -1,   571,
      -1,   577,    -1,   585,    -1,   587,    -1,   633,    -1,   590,
      -1,   607,    -1,   948,    -1,   674,    -1,   704,    -1,   596,
      -1,   778,    -1,   603,    -1,   648,    -1,  1016,    -1,  1020,
      -1,   785,    -1,   609,    -1,   787,    -1,   789,    -1,   791,
      -1,   793,    -1,   795,    -1,   797,    -1,   799,    -1,   801,
      -1,   726,    -1,   706,    -1,   708,    -1,   720,    -1,   722,
      -1,   803,    -1,   724,    -1,   925,    -1,   805,    -1,   682,
      -1,   644,    -1,   611,    -1,   646,    -1,   614,    -1,   678,
      -1,   684,    -1,   630,    -1,   966,    -1,   728,    -1,   676,
      -1,   658,    -1,   689,    -1,  1047,    -1,  1052,    -1,   989,
      -1,   934,    -1,   914,    -1,   986,    -1,  1014,    -1,   774,
      -1,  1059,    -1,   887,    -1,   970,    -1,  1022,    -1,   616,
      -1,  1032,    -1,   639,    -1,   618,    -1,   620,    -1,   668,
      -1,   622,    -1,   666,    -1,   624,    -1,   730,    -1,  1045,
      -1,   760,    -1,   734,    -1,   937,    -1,   732,    -1,   995,
      -1,   890,    -1,   680,    -1,  1057,    -1,   895,    -1,   700,
      -1,   702,    -1,   807,    -1,   809,    -1,   811,    -1,   960,
      -1,   922,    -1,   978,    -1,   813,    -1,   815,    -1,   817,
      -1,   819,    -1,   821,    -1,   825,    -1,   736,    -1,   738,
      -1,   740,    -1,   742,    -1,   827,    -1,   829,    -1,   746,
      -1,   831,    -1,   833,    -1,   835,    -1,   837,    -1,   839,
      -1,   841,    -1,   843,    -1,   845,    -1,   847,    -1,   849,
      -1,   851,    -1,   853,    -1,   855,    -1,   857,    -1,   859,
      -1,   861,    -1,   863,    -1,   865,    -1,   867,    -1,   869,
      -1,   871,    -1,   873,    -1,   875,    -1,   877,    -1,   754,
      -1,   879,    -1,   756,    -1,   758,    -1,   710,    -1,   981,
      -1,   881,    -1,   748,    -1,   750,    -1,   752,    -1,   883,
      -1,   885,    -1,   963,    -1,   955,    -1,   714,    -1,   893,
      -1,   897,    -1,   716,    -1,   718,    -1,   999,    -1,   712,
      -1,  1025,    -1,   987,    -1,  1002,    -1,  1005,    -1,  1040,
      -1,   695,    -1,   628,    -1,   626,    -1,   762,    -1,   764,
      -1,   768,    -1,   942,    -1,   744,    -1,   823,    -1,  1011,
      -1,  1004,    -1,   971,    -1,   991,    -1,   952,    -1,   957,
      -1,   950,    -1,   905,    -1,   975,    -1,   766,    -1,   917,
      -1,   770,    -1,   907,    -1,   772,    -1,  1043,    -1,   983,
      -1,  1061,    -1,  1062,    -1,  1064,    -1,  1150,    -1,  1152,
      -1,  1154,    -1,  1156,    -1,  1168,    -1,  1158,    -1,  1180,
      -1,   776,    -1,   899,    -1,   901,    -1,   903,    -1,    -1,
     303,    -1,    -1,   295,    -1,    -1,   557,  1189,    -1,    -1,
      -1,   296,   559,   560,    -1,    -1,   560,  1296,    -1,    -1,
      -1,  1222,   562,  1223,    -1,    -1,    -1,    -1,    -1,    -1,
      37,   564,  1073,   558,  1102,   561,  1277,   565,  1276,   566,
    1257,   567,   557,   556,   555,  1240,   568,  1241,    -1,    -1,
       9,  1195,   570,  1228,    -1,     9,   296,    -1,    -1,    -1,
      -1,    30,   572,  1094,  1202,   573,  1245,   574,   575,    -1,
      -1,   308,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,
      -1,    42,   578,  1073,  1246,   579,  1242,   580,  1225,   581,
    1229,   582,   576,  1292,    -1,    -1,    -1,  1190,   584,   583,
      -1,    -1,    65,   586,  1084,   583,  1199,    -1,    -1,    -1,
      32,   588,  1198,   589,  1227,    -1,    -1,    -1,    -1,    10,
     591,  1260,   592,  1261,   593,  1243,    -1,    -1,   303,   303,
      -1,   303,    -1,   290,    -1,   290,   303,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,   597,  1073,
    1278,   598,  1102,   594,  1259,   599,  1242,   600,  1225,   601,
    1229,   602,   595,  1292,    -1,    -1,    -1,    -1,    36,   604,
    1239,   605,  1195,   606,  1228,    -1,    -1,    13,   608,  1094,
      -1,    -1,    19,   610,  1094,    -1,    -1,    31,   612,  1094,
      -1,    -1,   299,    -1,    -1,    16,   615,  1094,   613,    -1,
      -1,    17,   617,  1094,  1203,    -1,    -1,    20,   619,  1094,
      -1,    -1,    22,   621,  1094,    -1,    -1,    26,   623,  1094,
      -1,    -1,    29,   625,  1094,    -1,    -1,   167,   627,  1094,
      -1,    -1,   164,   629,  1094,    -1,    -1,    15,   631,  1094,
    1226,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    14,
     634,  1094,  1226,   635,  1298,   636,   632,  1279,   637,  1280,
      -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    18,   640,
    1094,  1226,   641,   638,  1279,   642,  1280,   643,  1201,    -1,
      -1,    21,   645,  1094,  1204,    -1,    -1,    23,   647,  1094,
    1205,    -1,    -1,    -1,    25,   649,  1094,  1203,   650,  1251,
      -1,    -1,   398,    -1,    -1,   349,    -1,    -1,   300,    -1,
      -1,   654,  1191,    -1,    -1,   655,  1192,    -1,    -1,    -1,
    1222,   657,  1223,    -1,    -1,    -1,    -1,    -1,    -1,    27,
     659,  1094,   656,   651,  1254,   660,  1270,   661,  1271,   662,
    1255,   663,   652,   653,   654,   655,  1258,    -1,    -1,   664,
    1191,    -1,    -1,   665,  1192,    -1,    -1,    28,   667,  1094,
     301,   664,   665,  1258,    -1,    -1,    -1,    -1,    24,   669,
    1094,  1247,   670,  1245,   671,  1263,    -1,    -1,    -1,  1222,
     673,  1223,    -1,    -1,    40,   675,  1073,   672,    -1,    -1,
      46,   677,  1073,    -1,    -1,    38,   679,  1073,    -1,    -1,
      39,   681,  1073,  1262,    -1,    -1,    45,   683,  1073,  1252,
      -1,    -1,    -1,    -1,    -1,    43,   685,  1073,  1259,   686,
    1200,   687,  1225,   688,  1292,    -1,    -1,    -1,    -1,    -1,
      -1,    44,   690,  1073,  1102,  1259,   691,  1242,   692,  1225,
     693,  1256,   694,  1292,    -1,    -1,    -1,    -1,    -1,   163,
     696,  1073,  1267,   697,  1268,   698,  1269,   699,  1245,    -1,
      -1,    54,   701,  1084,    -1,    -1,    55,   703,  1084,    -1,
      -1,   150,   705,  1089,  1250,    -1,    -1,   148,   707,  1089,
    1194,    -1,    -1,   147,   709,  1089,  1194,    -1,    -1,   132,
     711,  1104,    -1,    -1,   156,   713,  1104,    -1,    -1,   144,
     715,  1104,    -1,    -1,   151,   717,  1104,    -1,    -1,   152,
     719,  1104,    -1,    -1,   128,   721,  1104,    -1,    -1,    70,
     723,  1115,    -1,    -1,    91,   725,  1104,    -1,    -1,   108,
     727,  1104,    -1,    -1,   127,   729,  1104,    -1,    -1,   133,
     731,  1104,    -1,    -1,   134,   733,  1104,    -1,    -1,    71,
     735,  1104,    -1,    -1,    86,   737,  1104,    -1,    -1,    87,
     739,  1104,    -1,    -1,    88,   741,  1104,    -1,    -1,    89,
     743,  1104,    -1,    -1,    90,   745,  1104,    -1,    -1,    94,
     747,  1104,    -1,    -1,   137,   749,  1104,    -1,    -1,   138,
     751,  1104,    -1,    -1,   139,   753,  1104,    -1,    -1,   125,
     755,  1104,    -1,    -1,   129,   757,  1104,    -1,    -1,   130,
     759,  1104,    -1,    -1,    49,   761,  1104,    -1,    -1,   165,
     763,  1104,    -1,    -1,   166,   765,  1104,    -1,    -1,   184,
     767,  1104,    -1,    -1,   168,   769,  1104,    -1,    -1,   186,
     771,  1104,    -1,    -1,   188,   773,  1104,    -1,    -1,    50,
     775,  1104,    -1,    -1,   437,   777,  1104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,   779,  1089,  1194,   780,  1194,
     781,  1181,   782,  1182,   783,  1183,   784,  1123,    -1,    -1,
     111,   786,  1105,    -1,    -1,    73,   788,  1105,    -1,    -1,
     424,   790,  1105,    -1,    -1,    74,   792,  1105,    -1,    -1,
      75,   794,  1105,    -1,    -1,    76,   796,  1105,    -1,    -1,
      80,   798,  1105,    -1,    -1,   110,   800,  1105,    -1,    -1,
     106,   802,  1105,    -1,    -1,   114,   804,  1105,    -1,    -1,
     113,   806,  1105,    -1,    -1,    58,   808,  1105,    -1,    -1,
      61,   810,  1105,    -1,    -1,    77,   812,  1105,    -1,    -1,
      78,   814,  1105,    -1,    -1,    79,   816,  1105,    -1,    -1,
      81,   818,  1105,    -1,    -1,    82,   820,  1105,    -1,    -1,
      83,   822,  1105,    -1,    -1,    84,   824,  1105,    -1,    -1,
      85,   826,  1105,    -1,    -1,    92,   828,  1105,    -1,    -1,
      93,   830,  1105,    -1,    -1,    95,   832,  1105,    -1,    -1,
      96,   834,  1105,    -1,    -1,    97,   836,  1105,    -1,    -1,
      98,   838,  1105,    -1,    -1,    99,   840,  1105,    -1,    -1,
     100,   842,  1105,    -1,    -1,   101,   844,  1105,    -1,    -1,
     102,   846,  1104,    -1,    -1,   103,   848,  1105,    -1,    -1,
     104,   850,  1105,    -1,    -1,   105,   852,  1105,    -1,    -1,
     107,   854,  1105,    -1,    -1,   109,   856,  1105,    -1,    -1,
     112,   858,  1105,    -1,    -1,   115,   860,  1105,    -1,    -1,
     116,   862,  1105,    -1,    -1,   117,   864,  1105,    -1,    -1,
     118,   866,  1105,    -1,    -1,   119,   868,  1105,    -1,    -1,
     120,   870,  1105,    -1,    -1,   121,   872,  1105,    -1,    -1,
     122,   874,  1105,    -1,    -1,   123,   876,  1105,    -1,    -1,
     124,   878,  1105,    -1,    -1,   126,   880,  1105,    -1,    -1,
     136,   882,  1105,    -1,    -1,   140,   884,  1105,    -1,    -1,
     141,   886,  1105,    -1,    -1,    69,   888,  1107,    -1,  1193,
      -1,   889,  1193,    -1,    -1,    -1,    35,   891,  1198,   892,
     889,    -1,    -1,   145,   894,  1105,    -1,    -1,    53,   896,
    1107,    -1,    -1,   146,   898,  1105,    -1,    -1,   438,   900,
    1105,    -1,    -1,   439,   902,  1105,    -1,    -1,   440,   904,
    1105,    -1,    -1,   182,   906,  1084,    -1,    -1,    -1,    -1,
      -1,   187,   908,  1230,   909,  1199,   910,  1221,   911,  1272,
      -1,  1194,    -1,   912,  1194,    -1,    -1,   912,    -1,    -1,
      -1,    11,   915,  1228,   916,   913,    -1,    -1,   185,   918,
    1084,    -1,    -1,    -1,  1211,   920,  1264,    -1,    -1,  1215,
     921,  1259,    -1,    -1,    -1,    62,   923,  1084,  1214,   924,
     919,    -1,    -1,    -1,    -1,    -1,    -1,   158,   926,  1213,
     927,  1224,   928,  1283,   929,   931,  1069,   930,  1070,    -1,
     933,    -1,   932,    -1,  1187,    -1,   932,  1187,    -1,    -1,
     305,    -1,    -1,    -1,   154,   935,  1089,  1194,   936,  1194,
      -1,    -1,    -1,   131,   938,  1084,  1194,   939,   940,    -1,
      -1,  1194,    -1,    -1,  1194,   941,  1194,    -1,    -1,    -1,
     170,   943,  1084,  1194,   944,  1194,    -1,  1185,    -1,   945,
    1185,    -1,  1126,    -1,   946,  1126,    -1,    -1,   945,    -1,
     946,    -1,    -1,   162,   949,   947,    -1,    -1,   181,   951,
    1084,    -1,    -1,    -1,   178,   953,  1230,   954,  1273,    -1,
      -1,   143,   956,  1105,    -1,   180,    -1,    -1,   958,   959,
      -1,  1186,  1188,    -1,    -1,    -1,   159,   961,  1212,   962,
     958,  1069,    -1,    -1,   142,   964,  1105,    -1,    -1,   297,
      -1,    -1,    -1,    -1,    33,   967,  1198,   968,   965,  1196,
     969,  1197,    -1,    72,    -1,    -1,    -1,    -1,   173,   972,
    1230,   973,  1214,   974,  1218,    -1,    -1,    -1,   183,   976,
    1220,   977,  1243,    -1,    -1,    -1,    66,   979,  1084,  1265,
     980,  1199,    -1,    -1,   135,   982,  1105,    -1,    -1,    -1,
     189,   984,  1230,   985,  1199,    -1,     8,    -1,    -1,   160,
     988,  1105,    -1,    -1,    47,   990,  1107,    -1,    -1,    -1,
      -1,   175,   992,  1230,   993,  1219,   994,  1218,    -1,    -1,
      -1,    -1,    34,   996,  1198,   997,  1208,   998,  1209,    -1,
      -1,    -1,   153,  1000,  1084,  1298,  1001,  1216,    -1,    -1,
     161,  1003,  1105,    -1,   172,    -1,    -1,    -1,    56,  1006,
    1239,  1007,  1008,    -1,    -1,  1008,  1009,    -1,    -1,  1237,
    1010,  1193,    -1,  1193,    -1,    -1,    -1,   171,  1012,  1230,
    1013,  1199,    -1,    -1,    12,  1015,  1298,    -1,    -1,    -1,
      -1,    63,  1017,  1084,  1194,  1018,  1194,  1019,  1194,    -1,
      -1,    64,  1021,  1089,  1194,    -1,    -1,   149,  1023,  1105,
      -1,    -1,   305,    -1,    -1,    -1,    -1,    -1,   157,  1026,
    1089,  1024,  1217,  1027,  1281,  1028,  1282,  1029,  1266,    -1,
      -1,  1194,  1031,  1250,    -1,   304,    -1,    -1,   155,  1033,
    1084,  1030,  1207,    -1,    -1,  1034,  1035,    -1,    -1,   236,
    1036,  1210,    -1,    -1,   237,  1037,  1210,    -1,    -1,   238,
    1038,  1210,    -1,    -1,   298,    -1,    -1,    -1,   235,  1041,
    1239,  1042,  1039,  1034,    -1,    -1,   190,  1044,  1239,    -1,
      -1,    51,  1046,  1110,    -1,    -1,    -1,    68,  1048,  1084,
    1206,  1049,  1050,    -1,    -1,    -1,  1189,  1051,  1050,    -1,
      -1,    -1,    67,  1053,  1089,  1206,  1054,  1055,    -1,    -1,
      -1,  1189,  1056,  1055,    -1,    -1,    48,  1058,  1107,    -1,
      -1,    52,  1060,  1110,    -1,   406,    -1,    -1,   409,  1063,
    1105,    -1,    -1,   410,  1065,  1107,    -1,    -1,   291,    -1,
      -1,   286,    -1,    -1,   287,    -1,    -1,   346,    -1,    -1,
     304,    -1,    -1,   288,    -1,    -1,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1238,  1074,
    1253,  1075,  1291,  1076,  1239,  1077,  1248,  1078,  1115,  1243,
    1079,  1244,  1080,  1067,  1081,  1071,  1082,  1072,  1083,  1066,
    1274,    -1,    -1,    -1,    -1,    -1,  1239,  1085,  1115,  1181,
    1086,  1182,  1087,  1183,  1088,  1123,    -1,    -1,    -1,    -1,
      -1,  1133,  1090,  1115,  1181,  1091,  1182,  1092,  1183,  1093,
    1123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1101,  1095,
    1238,  1096,  1249,  1097,  1242,  1098,  1248,  1099,  1275,  1100,
    1068,    -1,    -1,   225,   399,    -1,   225,   400,    -1,   225,
     401,    -1,   225,   402,    -1,   225,   403,    -1,   225,   404,
      -1,   225,   405,    -1,    -1,  1102,  1103,    -1,   311,    -1,
     312,    -1,   313,    -1,   314,    -1,   315,    -1,   317,    -1,
     316,    -1,   318,    -1,   305,    -1,   319,    -1,   320,    -1,
     203,    -1,   321,    -1,   322,    -1,   323,    -1,    56,    -1,
      57,    -1,   324,    -1,   325,    -1,   326,    -1,   327,    -1,
     328,    -1,   329,    -1,   330,    -1,   331,    -1,   333,    -1,
     334,    -1,   335,    -1,   336,    -1,   337,    -1,   338,    -1,
     339,    -1,   340,    -1,   341,    -1,   342,    -1,   343,    -1,
     344,    -1,   293,    -1,   294,    -1,   345,    -1,   346,    -1,
     292,    -1,   347,    -1,   348,    -1,   352,    -1,   353,    -1,
     354,    -1,   355,    -1,   356,    -1,   357,    -1,   359,    -1,
     358,    -1,   360,    -1,   361,    -1,   362,    -1,   363,    -1,
     364,    -1,   365,    -1,   366,    -1,   367,    -1,   368,    -1,
     369,    -1,   370,    -1,   371,    -1,   372,    -1,   373,    -1,
     374,    -1,   375,    -1,   376,    -1,   377,    -1,   378,    -1,
     379,    -1,   380,    -1,   381,    -1,   382,    -1,   383,    -1,
     384,    -1,   385,    -1,   386,    -1,   387,    -1,   388,    -1,
     389,    -1,   390,    -1,   267,    -1,   391,    -1,   392,    -1,
     393,    -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,
     408,    -1,  1084,  1250,    -1,    -1,  1084,  1194,  1106,  1250,
      -1,    -1,    -1,  1084,  1194,  1108,  1194,  1109,  1250,    -1,
      -1,    -1,  1084,  1194,  1111,  1194,  1112,  1113,    -1,    -1,
    1194,    -1,    -1,  1194,  1114,  1194,    -1,    -1,    -1,    -1,
     193,  1296,  1116,  1297,  1117,  1297,    -1,    -1,   247,    -1,
    1131,    -1,  1119,  1131,    -1,    -1,  1120,  1132,    -1,    -1,
    1121,  1184,    -1,    -1,  1122,  1185,    -1,    -1,  1123,   441,
    1124,  1125,    -1,   442,    -1,   443,    -1,   444,    -1,   445,
      -1,   446,    -1,   447,    -1,   448,    -1,   449,    -1,   450,
      -1,   451,    -1,   452,    -1,   453,    -1,   454,    -1,   455,
      -1,   456,    -1,   457,    -1,   458,    -1,   459,    -1,   460,
      -1,   461,    -1,   462,    -1,   463,    -1,   464,    -1,   465,
      -1,   466,    -1,   467,    -1,   468,    -1,   469,    -1,   470,
      -1,   471,    -1,   472,    -1,   473,    -1,   475,    -1,   474,
      -1,   476,    -1,   477,    -1,   478,    -1,   479,    -1,   480,
      -1,   481,    -1,   482,    -1,   483,    -1,   484,    -1,   485,
      -1,   486,    -1,   487,    -1,   488,    -1,   489,    -1,   490,
      -1,   491,    -1,   492,    -1,   493,    -1,   494,    -1,   495,
      -1,   496,    -1,   497,    -1,   498,    -1,   499,    -1,   500,
      -1,   501,    -1,   502,    -1,   503,    -1,   504,    -1,   505,
      -1,   506,    -1,   507,    -1,   508,    -1,   509,    -1,   510,
      -1,   511,    -1,   512,    -1,   513,    -1,   514,    -1,   515,
      -1,   516,    -1,   517,    -1,   518,    -1,   519,    -1,    -1,
     520,    -1,   521,    -1,   522,    -1,   523,    -1,   524,    -1,
     525,    -1,   526,    -1,   527,    -1,   528,    -1,   529,    -1,
     530,    -1,   531,    -1,   532,    -1,   533,    -1,   534,    -1,
     535,    -1,   536,    -1,   537,    -1,   538,    -1,   539,    -1,
     540,    -1,   541,    -1,   542,    -1,   543,    -1,   544,    -1,
     545,    -1,   546,    -1,    -1,    -1,    -1,    -1,   220,  1127,
    1297,  1128,  1118,  1119,  1120,  1284,  1129,  1285,  1130,  1121,
    1122,  1123,    -1,   245,   309,    -1,   245,  1297,    -1,   246,
     310,    -1,   246,  1297,    -1,    -1,    -1,  1134,  1136,  1142,
      -1,    -1,  1135,  1141,    -1,  1137,    -1,  1136,  1137,    -1,
      -1,   411,  1138,  1139,  1140,    -1,    -1,  1139,  1231,    -1,
    1234,    -1,  1140,  1234,    -1,  1143,    -1,  1141,  1143,    -1,
      -1,  1141,    -1,    -1,    -1,   414,  1144,  1295,  1145,  1147,
    1146,    -1,    -1,  1146,  1235,    -1,    -1,  1147,  1232,    -1,
    1073,  1149,    -1,    -1,  1149,  1233,    -1,    -1,   417,  1151,
    1148,    -1,    -1,   418,  1153,  1148,    -1,    -1,   419,  1155,
    1148,    -1,    -1,   420,  1157,  1148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,  1159,  1198,  1160,
    1181,  1161,  1182,  1162,  1183,  1163,  1287,  1164,  1289,  1165,
    1293,  1166,  1288,  1167,  1294,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,  1169,  1198,
    1170,  1181,  1171,  1182,  1172,  1183,  1173,  1286,  1174,  1287,
    1175,  1293,  1176,  1288,  1177,  1289,  1178,  1236,  1179,  1290,
      -1,   436,    -1,    -1,   213,  1297,    -1,    -1,   214,  1297,
      -1,    -1,   215,  1297,    -1,   249,  1295,    -1,   211,  1295,
      -1,   251,  1295,    -1,   254,  1295,    -1,   252,  1297,    -1,
     194,  1295,    -1,   216,  1295,    -1,   228,  1295,    -1,   268,
    1295,    -1,   209,  1295,    -1,   212,  1295,    -1,   196,  1296,
      -1,   226,  1296,    -1,   227,  1296,    -1,   192,  1295,    -1,
     195,  1295,    -1,   198,  1295,    -1,   269,  1295,    -1,   200,
    1295,    -1,   218,  1295,    -1,   223,  1295,    -1,   224,  1295,
      -1,   231,  1295,    -1,   232,  1295,    -1,   233,  1295,    -1,
     234,  1295,    -1,   239,  1295,    -1,   242,  1295,    -1,   250,
    1295,    -1,   253,  1295,    -1,   258,  1295,    -1,   259,  1295,
      -1,   262,  1295,    -1,   265,  1296,    -1,   276,  1295,    -1,
     278,  1295,    -1,   281,  1295,    -1,   282,  1295,    -1,   284,
    1295,    -1,   285,  1295,    -1,   255,  1297,    -1,   199,  1297,
      -1,   206,  1297,    -1,   204,  1297,    -1,   197,  1297,    -1,
     203,  1297,    -1,   350,  1297,    -1,   412,  1295,    -1,   415,
    1295,    -1,   328,  1295,    -1,   413,  1295,    -1,   416,  1295,
      -1,   433,  1295,    -1,   429,  1295,    -1,    -1,   191,  1295,
      -1,    -1,   192,  1295,    -1,    -1,   195,  1295,    -1,    -1,
     407,  1295,    -1,    -1,   198,  1295,    -1,    -1,   210,  1295,
      -1,    -1,   248,  1295,    -1,    -1,   201,  1295,    -1,    -1,
     205,  1295,    -1,    -1,   200,  1295,    -1,    -1,   202,  1295,
      -1,    -1,   217,  1295,    -1,    -1,   212,  1295,    -1,    -1,
     219,  1295,    -1,    -1,   221,  1295,    -1,    -1,   222,  1295,
      -1,    -1,   223,  1295,    -1,    -1,   229,  1295,    -1,    -1,
     230,  1295,    -1,    -1,   231,  1295,    -1,    -1,   239,  1295,
      -1,    -1,   242,  1295,    -1,    -1,   244,  1295,    -1,    -1,
    1193,    -1,    -1,   256,  1295,    -1,    -1,   257,  1295,    -1,
      -1,   259,  1295,    -1,    -1,   260,  1295,    -1,    -1,   266,
    1295,    -1,    -1,   270,  1295,    -1,    -1,   271,  1295,    -1,
      -1,   272,  1295,    -1,    -1,   273,  1295,    -1,    -1,   274,
    1295,    -1,    -1,   276,  1295,    -1,    -1,   278,  1295,    -1,
      -1,   240,  1297,    -1,   241,  1297,    -1,    -1,   199,  1297,
      -1,    -1,   298,  1297,    -1,    -1,   351,  1297,    -1,    -1,
     283,  1297,    -1,    -1,   207,  1295,    -1,    -1,   208,  1295,
      -1,    -1,   263,  1295,    -1,    -1,   264,  1295,    -1,    -1,
     421,  1295,    -1,    -1,   422,  1297,    -1,    -1,   423,  1297,
      -1,    -1,   427,  1295,    -1,    -1,   428,  1295,    -1,    -1,
     431,  1295,    -1,    -1,   432,  1295,    -1,    -1,   434,  1295,
      -1,    -1,   433,  1295,    -1,    -1,   435,  1295,    -1,    -1,
     429,  1295,    -1,    -1,   430,  1295,    -1,     3,    -1,     4,
      -1,     5,    -1,    -1,  1296,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   673,   673,   674,   677,   678,   681,   680,   694,   694,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   760,   761,   762,   763,   764,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     786,   787,   788,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   849,   850,   851,   852,   853,   854,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,   865,
     866,   867,   868,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   890,   892,   895,   896,   899,   900,   903,   904,
     904,   907,   908,   911,   912,   912,   916,   921,   922,   923,
     927,   916,   932,   932,   933,   938,   939,   940,   938,   943,
     944,   950,   951,   955,   957,   958,   959,   960,   955,   965,
     966,   966,   969,   969,   973,   977,   972,   986,   986,   986,
     986,   988,   989,   990,   991,   992,   994,   994,   997,   999,
    1002,  1003,  1004,  1005,   997,  1011,  1011,  1011,  1011,  1014,
    1014,  1017,  1017,  1020,  1020,  1022,  1022,  1024,  1024,  1027,
    1027,  1030,  1030,  1033,  1033,  1036,  1036,  1039,  1039,  1042,
    1042,  1045,  1045,  1048,  1048,  1053,  1053,  1056,  1058,  1059,
    1061,  1056,  1065,  1065,  1068,  1070,  1072,  1073,  1068,  1078,
    1078,  1082,  1082,  1086,  1086,  1086,  1089,  1090,  1093,  1094,
    1097,  1098,  1101,  1102,  1105,  1106,  1109,  1110,  1110,  1114,
    1114,  1114,  1114,  1114,  1114,  1116,  1117,  1120,  1121,  1125,
    1125,  1128,  1128,  1128,  1128,  1131,  1132,  1132,  1135,  1135,
    1138,  1138,  1141,  1141,  1144,  1144,  1147,  1147,  1150,  1152,
    1153,  1154,  1150,  1159,  1162,  1163,  1164,  1165,  1159,  1170,
    1170,  1170,  1170,  1170,  1174,  1174,  1177,  1177,  1181,  1181,
    1189,  1189,  1192,  1192,  1195,  1195,  1198,  1198,  1201,  1201,
    1204,  1204,  1207,  1207,  1210,  1210,  1213,  1213,  1216,  1216,
    1219,  1219,  1222,  1222,  1225,  1225,  1228,  1228,  1231,  1231,
    1234,  1234,  1237,  1237,  1240,  1240,  1243,  1243,  1246,  1246,
    1249,  1249,  1252,  1252,  1255,  1255,  1258,  1258,  1261,  1261,
    1264,  1264,  1267,  1267,  1270,  1270,  1273,  1273,  1276,  1276,
    1279,  1279,  1282,  1282,  1285,  1285,  1288,  1288,  1291,  1291,
    1294,  1294,  1301,  1306,  1310,  1315,  1326,  1332,  1300,  1347,
    1347,  1350,  1350,  1353,  1353,  1356,  1356,  1359,  1359,  1362,
    1362,  1365,  1365,  1368,  1368,  1371,  1371,  1374,  1374,  1377,
    1377,  1380,  1380,  1383,  1383,  1386,  1386,  1389,  1389,  1392,
    1392,  1395,  1395,  1398,  1398,  1401,  1401,  1404,  1404,  1407,
    1407,  1410,  1410,  1413,  1413,  1416,  1416,  1419,  1419,  1422,
    1422,  1425,  1425,  1428,  1428,  1431,  1431,  1434,  1434,  1437,
    1437,  1440,  1440,  1443,  1443,  1446,  1446,  1449,  1449,  1452,
    1452,  1455,  1455,  1458,  1458,  1461,  1461,  1464,  1464,  1467,
    1467,  1470,  1470,  1473,  1473,  1476,  1476,  1479,  1479,  1482,
    1482,  1485,  1485,  1488,  1488,  1491,  1491,  1494,  1494,  1497,
    1497,  1500,  1500,  1502,  1503,  1505,  1505,  1505,  1508,  1508,
    1511,  1511,  1514,  1514,  1518,  1518,  1521,  1521,  1524,  1524,
    1527,  1527,  1530,  1530,  1530,  1530,  1530,  1532,  1533,  1535,
    1535,  1538,  1538,  1538,  1541,  1541,  1543,  1544,  1544,  1545,
    1545,  1548,  1548,  1548,  1551,  1552,  1553,  1554,  1556,  1551,
    1560,  1560,  1562,  1563,  1566,  1566,  1570,  1571,  1570,  1576,
    1579,  1575,  1583,  1584,  1587,  1586,  1593,  1593,  1593,  1595,
    1596,  1598,  1599,  1602,  1603,  1604,  1608,  1608,  1611,  1611,
    1614,  1614,  1614,  1618,  1618,  1621,  1623,  1624,  1627,  1631,
    1632,  1631,  1638,  1638,  1640,  1640,  1643,  1643,  1643,  1643,
    1646,  1649,  1649,  1649,  1649,  1652,  1652,  1652,  1656,  1656,
    1656,  1659,  1659,  1662,  1662,  1662,  1665,  1668,  1668,  1671,
    1671,  1674,  1674,  1674,  1674,  1677,  1677,  1677,  1677,  1680,
    1680,  1680,  1683,  1683,  1686,  1689,  1689,  1689,  1692,  1693,
    1696,  1696,  1697,  1701,  1701,  1701,  1704,  1704,  1708,  1710,
    1711,  1707,  1717,  1716,  1723,  1723,  1725,  1725,  1728,  1728,
    1728,  1728,  1728,  1730,  1730,  1731,  1734,  1734,  1737,  1738,
    1741,  1741,  1742,  1742,  1743,  1743,  1747,  1747,  1750,  1750,
    1750,  1754,  1754,  1758,  1758,  1761,  1763,  1761,  1767,  1768,
    1768,  1771,  1773,  1771,  1777,  1778,  1778,  1782,  1782,  1785,
    1785,  1788,  1791,  1791,  1794,  1794,  1797,  1799,  1802,  1802,
    1804,  1804,  1806,  1806,  1808,  1808,  1810,  1810,  1812,  1812,
    1815,  1816,  1817,  1818,  1819,  1821,  1822,  1823,  1824,  1825,
    1815,  1831,  1834,  1844,  1850,  1831,  1866,  1869,  1880,  1886,
    1866,  1901,  1902,  1903,  1904,  1905,  1906,  1901,  1911,  1912,
    1913,  1914,  1915,  1916,  1917,  1918,  1933,  1934,  1937,  1938,
    1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,
    1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,
    1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,
    1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,
    1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,
    1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,
    1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,
    2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,
    2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,
    2032,  2035,  2035,  2038,  2038,  2038,  2043,  2045,  2041,  2049,
    2050,  2053,  2052,  2059,  2059,  2059,  2059,  2064,  2065,  2068,
    2069,  2072,  2073,  2076,  2077,  2080,  2081,  2084,  2085,  2096,
    2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,
    2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,
    2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,
    2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,
    2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,  2165,  2166,
    2167,  2168,  2169,  2170,  2171,  2172,  2173,  2176,  2177,  2178,
    2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2206,  2207,  2211,  2212,  2206,
    2219,  2220,  2223,  2224,  2229,  2230,  2230,  2231,  2231,  2234,
    2235,  2238,  2238,  2241,  2242,  2245,  2246,  2249,  2250,  2253,
    2254,  2257,  2259,  2256,  2264,  2265,  2268,  2269,  2272,  2276,
    2277,  2281,  2281,  2284,  2284,  2287,  2287,  2290,  2290,  2292,
    2293,  2295,  2304,  2310,  2315,  2316,  2317,  2318,  2292,  2322,
    2323,  2325,  2334,  2340,  2345,  2346,  2347,  2348,  2349,  2350,
    2322,  2354,  2356,  2356,  2358,  2358,  2360,  2360,  2362,  2363,
    2364,  2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,  2376,
    2378,  2380,  2383,  2385,  2387,  2389,  2391,  2393,  2395,  2397,
    2399,  2401,  2403,  2405,  2407,  2409,  2411,  2413,  2415,  2417,
    2419,  2421,  2423,  2425,  2427,  2429,  2431,  2433,  2435,  2437,
    2439,  2441,  2443,  2445,  2447,  2449,  2451,  2453,  2455,  2457,
    2459,  2461,  2464,  2464,  2466,  2466,  2468,  2468,  2469,  2469,
    2471,  2471,  2473,  2473,  2475,  2475,  2477,  2477,  2479,  2479,
    2481,  2481,  2483,  2483,  2485,  2485,  2487,  2487,  2489,  2489,
    2491,  2491,  2493,  2493,  2495,  2495,  2497,  2497,  2499,  2499,
    2501,  2501,  2503,  2503,  2505,  2505,  2507,  2507,  2509,  2509,
    2511,  2511,  2513,  2513,  2515,  2515,  2517,  2517,  2519,  2519,
    2521,  2521,  2523,  2523,  2525,  2525,  2527,  2527,  2529,  2529,
    2531,  2531,  2533,  2533,  2535,  2535,  2535,  2537,  2537,  2539,
    2539,  2541,  2541,  2543,  2543,  2545,  2545,  2547,  2547,  2549,
    2549,  2551,  2551,  2553,  2553,  2555,  2555,  2557,  2557,  2559,
    2559,  2561,  2561,  2563,  2563,  2565,  2565,  2567,  2567,  2569,
    2569,  2571,  2571,  2573,  2573,  2575,  2575,  2578,  2579,  2580,
    2581,  2581
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NODE_ID", "TOK_BISON_STRING",
  "TOK_BISON_NUMBER", "TOK_BISON_GCC_VERSION", "TOK_BISON_PLUGIN_VERSION",
  "TOK_BISON_ERROR_MARK", "TOK_BISON_IDENTIFIER_NODE",
  "TOK_BISON_TREE_LIST", "TOK_BISON_TREE_VEC", "TOK_BISON_BLOCK",
  "TOK_BISON_VOID_TYPE", "TOK_BISON_INTEGER_TYPE", "TOK_BISON_REAL_TYPE",
  "TOK_BISON_COMPLEX_TYPE", "TOK_BISON_VECTOR_TYPE",
  "TOK_BISON_ENUMERAL_TYPE", "TOK_BISON_BOOLEAN_TYPE",
  "TOK_BISON_CHAR_TYPE", "TOK_BISON_POINTER_TYPE", "TOK_BISON_OFFSET_TYPE",
  "TOK_BISON_REFERENCE_TYPE", "TOK_BISON_METHOD_TYPE",
  "TOK_BISON_ARRAY_TYPE", "TOK_BISON_SET_TYPE", "TOK_BISON_RECORD_TYPE",
  "TOK_BISON_UNION_TYPE", "TOK_BISON_QUAL_UNION_TYPE",
  "TOK_BISON_FUNCTION_TYPE", "TOK_BISON_LANG_TYPE",
  "TOK_BISON_INTEGER_CST", "TOK_BISON_REAL_CST", "TOK_BISON_COMPLEX_CST",
  "TOK_BISON_VECTOR_CST", "TOK_BISON_STRING_CST",
  "TOK_BISON_FUNCTION_DECL", "TOK_BISON_LABEL_DECL",
  "TOK_BISON_CONST_DECL", "TOK_BISON_TYPE_DECL", "TOK_BISON_VAR_DECL",
  "TOK_BISON_PARM_DECL", "TOK_BISON_RESULT_DECL", "TOK_BISON_FIELD_DECL",
  "TOK_BISON_NAMESPACE_DECL", "TOK_BISON_TRANSLATION_UNIT_DECL",
  "TOK_BISON_COMPONENT_REF", "TOK_BISON_BIT_FIELD_REF",
  "TOK_BISON_INDIRECT_REF", "TOK_BISON_BUFFER_REF", "TOK_BISON_ARRAY_REF",
  "TOK_BISON_ARRAY_RANGE_REF", "TOK_BISON_VTABLE_REF",
  "TOK_BISON_EXC_PTR_EXPR", "TOK_BISON_FILTER_EXPR",
  "TOK_BISON_CONSTRUCTOR", "TOK_BISON_DESTRUCTOR",
  "TOK_BISON_COMPOUND_EXPR", "TOK_BISON_MODIFY_EXPR",
  "TOK_BISON_GIMPLE_ASSIGN", "TOK_BISON_INIT_EXPR",
  "TOK_BISON_TARGET_EXPR", "TOK_BISON_COND_EXPR", "TOK_BISON_GIMPLE_COND",
  "TOK_BISON_GIMPLE_BIND", "TOK_BISON_LABELED_BLOCK_EXPR",
  "TOK_BISON_GIMPLE_CALL", "TOK_BISON_CALL_EXPR",
  "TOK_BISON_WITH_CLEANUP_EXPR", "TOK_BISON_GIMPLE_NOP",
  "TOK_BISON_CLEANUP_POINT_EXPR", "TOK_BISON_PLACEHOLDER_EXPR",
  "TOK_BISON_PLUS_EXPR", "TOK_BISON_MINUS_EXPR", "TOK_BISON_MULT_EXPR",
  "TOK_BISON_TRUNC_DIV_EXPR", "TOK_BISON_CEIL_DIV_EXPR",
  "TOK_BISON_FLOOR_DIV_EXPR", "TOK_BISON_ROUND_DIV_EXPR",
  "TOK_BISON_TRUNC_MOD_EXPR", "TOK_BISON_CEIL_MOD_EXPR",
  "TOK_BISON_FLOOR_MOD_EXPR", "TOK_BISON_ROUND_MOD_EXPR",
  "TOK_BISON_RDIV_EXPR", "TOK_BISON_EXACT_DIV_EXPR",
  "TOK_BISON_FIX_TRUNC_EXPR", "TOK_BISON_FIX_CEIL_EXPR",
  "TOK_BISON_FIX_FLOOR_EXPR", "TOK_BISON_FIX_ROUND_EXPR",
  "TOK_BISON_FLOAT_EXPR", "TOK_BISON_NEGATE_EXPR", "TOK_BISON_MIN_EXPR",
  "TOK_BISON_MAX_EXPR", "TOK_BISON_ABS_EXPR", "TOK_BISON_LSHIFT_EXPR",
  "TOK_BISON_RSHIFT_EXPR", "TOK_BISON_LROTATE_EXPR",
  "TOK_BISON_RROTATE_EXPR", "TOK_BISON_BIT_IOR_EXPR",
  "TOK_BISON_BIT_XOR_EXPR", "TOK_BISON_BIT_AND_EXPR",
  "TOK_BISON_BIT_NOT_EXPR", "TOK_BISON_TRUTH_ANDIF_EXPR",
  "TOK_BISON_TRUTH_ORIF_EXPR", "TOK_BISON_TRUTH_AND_EXPR",
  "TOK_BISON_TRUTH_OR_EXPR", "TOK_BISON_TRUTH_XOR_EXPR",
  "TOK_BISON_TRUTH_NOT_EXPR", "TOK_BISON_LT_EXPR", "TOK_BISON_LE_EXPR",
  "TOK_BISON_GT_EXPR", "TOK_BISON_GE_EXPR", "TOK_BISON_EQ_EXPR",
  "TOK_BISON_NE_EXPR", "TOK_BISON_UNORDERED_EXPR",
  "TOK_BISON_ORDERED_EXPR", "TOK_BISON_UNLT_EXPR", "TOK_BISON_UNLE_EXPR",
  "TOK_BISON_UNGT_EXPR", "TOK_BISON_UNGE_EXPR", "TOK_BISON_UNEQ_EXPR",
  "TOK_BISON_LTGT_EXPR", "TOK_BISON_IN_EXPR", "TOK_BISON_SET_LE_EXPR",
  "TOK_BISON_CARD_EXPR", "TOK_BISON_RANGE_EXPR", "TOK_BISON_CONVERT_EXPR",
  "TOK_BISON_NOP_EXPR", "TOK_BISON_NON_LVALUE_EXPR",
  "TOK_BISON_VIEW_CONVERT_EXPR", "TOK_BISON_SAVE_EXPR",
  "TOK_BISON_UNSAVE_EXPR", "TOK_BISON_ADDR_EXPR",
  "TOK_BISON_REFERENCE_EXPR", "TOK_BISON_FDESC_EXPR",
  "TOK_BISON_COMPLEX_EXPR", "TOK_BISON_CONJ_EXPR",
  "TOK_BISON_REALPART_EXPR", "TOK_BISON_IMAGPART_EXPR",
  "TOK_BISON_PREDECREMENT_EXPR", "TOK_BISON_PREINCREMENT_EXPR",
  "TOK_BISON_POSTDECREMENT_EXPR", "TOK_BISON_POSTINCREMENT_EXPR",
  "TOK_BISON_VA_ARG_EXPR", "TOK_BISON_TRY_CATCH_EXPR",
  "TOK_BISON_TRY_FINALLY", "TOK_BISON_", "TOK_BISON_GIMPLE_GOTO",
  "TOK_BISON_GOTO_SUBROUTINE", "TOK_BISON_GIMPLE_RETURN",
  "TOK_BISON_EXIT_EXPR", "TOK_BISON_LOOP_EXPR",
  "TOK_BISON_EXIT_BLOCK_EXPR", "TOK_BISON_GIMPLE_SWITCH",
  "TOK_BISON_CASE_LABEL_EXPR", "TOK_BISON_GIMPLE_RESX",
  "TOK_BISON_GIMPLE_ASM", "TOK_BISON_SSA_NAME", "TOK_BISON_GIMPLE_PHI",
  "TOK_BISON_CATCH_EXPR", "TOK_BISON_EH_FILTER_EXPR",
  "TOK_BISON_STATEMENT_LIST", "TOK_BISON_TEMPLATE_DECL",
  "TOK_BISON_TEMPLATE_TYPE_PARM", "TOK_BISON_CAST_EXPR",
  "TOK_BISON_STATIC_CAST_EXPR", "TOK_BISON_TYPENAME_TYPE",
  "TOK_BISON_SIZEOF_EXPR", "TOK_BISON_AGGR_INIT_EXPR",
  "TOK_BISON_SCOPE_REF", "TOK_BISON_COMPOUND_STMT",
  "TOK_BISON_CTOR_INITIALIZER", "TOK_BISON_DECL_STMT", "TOK_BISON_DO_STMT",
  "TOK_BISON_EXPR_STMT", "TOK_BISON_FOR_STMT", "TOK_BISON_IF_STMT",
  "TOK_BISON_RETURN_STMT", "TOK_BISON_WHILE_STMT", "TOK_BISON_MODOP_EXPR",
  "TOK_BISON_NEW_EXPR", "TOK_BISON_VEC_NEW_EXPR", "TOK_BISON_OVERLOAD",
  "TOK_BISON_REINTERPRET_CAST_EXPR", "TOK_BISON_TEMPLATE_ID_EXPR",
  "TOK_BISON_THROW_EXPR", "TOK_BISON_TRY_BLOCK", "TOK_BISON_ARROW_EXPR",
  "TOK_BISON_HANDLER", "TOK_BISON_BASELINK", "TOK_BISON_NAME",
  "TOK_BISON_TYPE", "TOK_BISON_SRCP", "TOK_BISON_ARG", "TOK_BISON_BODY",
  "TOK_BISON_STRG", "TOK_BISON_LNGT", "TOK_BISON_SIZE", "TOK_BISON_ALGN",
  "TOK_BISON_RETN", "TOK_BISON_PRMS", "TOK_BISON_SCPE", "TOK_BISON_USED",
  "TOK_BISON_VALUE", "TOK_BISON_ARGT", "TOK_BISON_PREC", "TOK_BISON_MIN",
  "TOK_BISON_MAX", "TOK_BISON_VALU", "TOK_BISON_CHAN", "TOK_BISON_STMT",
  "TOK_BISON_OP", "TOK_BISON_TIME_WEIGHT", "TOK_BISON_SIZE_WEIGHT",
  "TOK_BISON_RTL_SIZE_WEIGHT", "TOK_BISON_VARS", "TOK_BISON_UNQL",
  "TOK_BISON_ELTS", "TOK_BISON_DOMN", "TOK_BISON_BLOC", "TOK_BISON_DCLS",
  "TOK_BISON_MNGL", "TOK_BISON_PTD", "TOK_BISON_REFD", "TOK_BISON_QUAL",
  "TOK_BISON_VALR", "TOK_BISON_VALX", "TOK_BISON_FLDS", "TOK_BISON_VFLD",
  "TOK_BISON_BPOS", "TOK_BISON_FN", "TOK_BISON_GOTO", "TOK_BISON_REAL",
  "TOK_BISON_IMAG", "TOK_BISON_BINFO", "TOK_BISON_PUB", "TOK_BISON_PROT",
  "TOK_BISON_PRIV", "TOK_BISON_BINF", "TOK_BISON_UID", "TOK_BISON_OLD_UID",
  "TOK_BISON_INIT", "TOK_BISON_FINI", "TOK_BISON_PURP", "TOK_BISON_PRED",
  "TOK_BISON_SUCC", "TOK_BISON_HPL", "TOK_BISON_ATTRIBUTES",
  "TOK_BISON_PHI", "TOK_BISON_RES", "TOK_BISON_DEF", "TOK_BISON_EDGE",
  "TOK_BISON_VAR", "TOK_BISON_DEF_STMT", "TOK_BISON_VERS",
  "TOK_BISON_CNST", "TOK_BISON_CLAS", "TOK_BISON_DECL", "TOK_BISON_CLNP",
  "TOK_BISON_LAB", "TOK_BISON_TRY", "TOK_BISON_EX", "TOK_BISON_OUT",
  "TOK_BISON_IN", "TOK_BISON_STR", "TOK_BISON_CLOB", "TOK_BISON_REF",
  "TOK_BISON_FNCS", "TOK_BISON_CSTS", "TOK_BISON_RSLT", "TOK_BISON_INST",
  "TOK_BISON_SPCS", "TOK_BISON_CLS", "TOK_BISON_BFLD", "TOK_BISON_CTOR",
  "TOK_BISON_NEXT", "TOK_BISON_COND", "TOK_BISON_EXPR", "TOK_BISON_THEN",
  "TOK_BISON_ELSE", "TOK_BISON_CRNT", "TOK_BISON_HDLR",
  "TOK_BISON_USE_TMPL", "TOK_BISON_TMPL_PARMS", "TOK_BISON_TMPL_ARGS",
  "TOK_BISON_ARTIFICIAL", "TOK_BISON_SYSTEM", "TOK_BISON_OPERATING_SYSTEM",
  "TOK_BISON_LIBRARY_SYSTEM", "TOK_BISON_EXTERN", "TOK_BISON_C",
  "TOK_BISON_LSHIFT", "TOK_BISON_GLOBAL_INIT", "TOK_BISON_GLOBAL_FINI",
  "TOK_BISON_UNDEFINED", "TOK_BISON_OPERATOR", "TOK_BISON_OVERFLOW",
  "TOK_BISON_VIRT", "TOK_BISON_UNSIGNED", "TOK_BISON_STRUCT",
  "TOK_BISON_UNION", "TOK_BISON_REGISTER", "TOK_BISON_STATIC",
  "TOK_BISON_DEFAULT", "TOK_BISON_VOLATILE", "TOK_BISON_INF",
  "TOK_BISON_NAN", "TOK_BISON_VARARGS", "TOK_BISON_ENTRY",
  "TOK_BISON_EXIT", "TOK_BISON_NEW", "TOK_BISON_DELETE",
  "TOK_BISON_ASSIGN", "TOK_BISON_MEMBER", "TOK_BISON_PUBLIC",
  "TOK_BISON_PRIVATE", "TOK_BISON_PROTECTED", "TOK_BISON_NORETURN",
  "TOK_BISON_NOINLINE", "TOK_BISON_ALWAYS_INLINE", "TOK_BISON_UNUSED",
  "TOK_BISON_CONST", "TOK_BISON_TRANSPARENT_UNION", "TOK_BISON_MODE",
  "TOK_BISON_SECTION", "TOK_BISON_ALIGNED", "TOK_BISON_WEAK",
  "TOK_BISON_ALIAS", "TOK_BISON_NO_INSTRUMENT_FUNCTION",
  "TOK_BISON_MALLOC", "TOK_BISON_NO_STACK_LIMIT", "TOK_BISON_NO_STACK",
  "TOK_BISON_PURE", "TOK_BISON_DEPRECATED", "TOK_BISON_VECTOR_SIZE",
  "TOK_BISON_VISIBILITY", "TOK_BISON_TLS_MODEL", "TOK_BISON_NONNULL",
  "TOK_BISON_NOTHROW", "TOK_BISON_MAY_ALIAS",
  "TOK_BISON_WARN_UNUSED_RESULT", "TOK_BISON_FORMAT",
  "TOK_BISON_FORMAT_ARG", "TOK_BISON_NULL", "TOK_BISON_CONVERSION",
  "TOK_BISON_VIRTUAL", "TOK_BISON_MUTABLE", "TOK_BISON_PSEUDO_TMPL",
  "TOK_BISON_SPEC", "TOK_BISON_LINE", "TOK_BISON_FIXD", "TOK_BISON_VECNEW",
  "TOK_BISON_VECDELETE", "TOK_BISON_POS", "TOK_BISON_NEG",
  "TOK_BISON_ADDR", "TOK_BISON_DEREF", "TOK_BISON_NOT", "TOK_BISON_LNOT",
  "TOK_BISON_PREINC", "TOK_BISON_PREDEC", "TOK_BISON_PLUSASSIGN",
  "TOK_BISON_PLUS", "TOK_BISON_MINUSASSIGN", "TOK_BISON_MINUS",
  "TOK_BISON_MULTASSIGN", "TOK_BISON_MULT", "TOK_BISON_DIVASSIGN",
  "TOK_BISON_DIV", "TOK_BISON_MODASSIGN", "TOK_BISON_MOD",
  "TOK_BISON_ANDASSIGN", "TOK_BISON_AND", "TOK_BISON_ORASSIGN",
  "TOK_BISON_OR", "TOK_BISON_XORASSIGN", "TOK_BISON_XOR",
  "TOK_BISON_LSHIFTASSIGN", "TOK_BISON_RSHIFTASSIGN", "TOK_BISON_RSHIFT",
  "TOK_BISON_EQ", "TOK_BISON_NE", "TOK_BISON_LT", "TOK_BISON_GT",
  "TOK_BISON_LE", "TOK_BISON_GE", "TOK_BISON_LAND", "TOK_BISON_LOR",
  "TOK_BISON_COMPOUND", "TOK_BISON_MEMREF", "TOK_BISON_SUBS",
  "TOK_BISON_POSTINC", "TOK_BISON_POSTDEC", "TOK_BISON_CALL",
  "TOK_BISON_THUNK", "TOK_BISON_THIS_ADJUSTING",
  "TOK_BISON_RESULT_ADJUSTING", "TOK_BISON_PTRMEM", "TOK_BISON_QUAL_R",
  "TOK_BISON_QUAL_V", "TOK_BISON_QUAL_VR", "TOK_BISON_QUAL_C",
  "TOK_BISON_QUAL_CR", "TOK_BISON_QUAL_CV", "TOK_BISON_QUAL_CVR",
  "TOK_BISON_TEMPLATE_PARM_INDEX", "TOK_BISON_INLINE_BODY",
  "TOK_BISON_BITFIELD", "TOK_BISON_WITH_SIZE_EXPR",
  "TOK_BISON_OBJ_TYPE_REF", "TOK_BISON_VUSE", "TOK_BISON_VUSE_OP",
  "TOK_BISON_LOADS", "TOK_BISON_VDEF", "TOK_BISON_VDEF_OP",
  "TOK_BISON_STORES", "TOK_BISON_STRUCT_FIELD_TAG",
  "TOK_BISON_NAME_MEMORY_TAG", "TOK_BISON_SYMBOL_MEMORY_TAG",
  "TOK_BISON_MEMORY_PARTITION_TAG", "TOK_BISON_PTR_INFO",
  "TOK_BISON_TRUE_EDGE", "TOK_BISON_FALSE_EDGE",
  "TOK_BISON_POINTER_PLUS_EXPR", "TOK_BISON_TARGET_MEM_REF",
  "TOK_BISON_TARGET_MEM_REF461", "TOK_BISON_SYMBOL", "TOK_BISON_BASE",
  "TOK_BISON_IDX", "TOK_BISON_IDX2", "TOK_BISON_STEP", "TOK_BISON_OFFSET",
  "TOK_BISON_ORIG", "TOK_BISON_TAG", "TOK_BISON_SMT_ANN",
  "TOK_BISON_TRAIT_EXPR", "TOK_BISON_GIMPLE_PREDICT", "TOK_BISON_MEM_REF",
  "TOK_BISON_WIDEN_SUM_EXPR", "TOK_BISON_WIDEN_MULT_EXPR", "TOK_BISON_RTL",
  "TOK_BISON_ABS_R", "TOK_BISON_AND_R", "TOK_BISON_ASHIFT_R",
  "TOK_BISON_ASHIFTRT_R", "TOK_BISON_BSWAP_R", "TOK_BISON_CALL_R",
  "TOK_BISON_CALL_INSN_R", "TOK_BISON_CLZ_R", "TOK_BISON_CODE_LABEL_R",
  "TOK_BISON_COMPARE_R", "TOK_BISON_CONCAT_R", "TOK_BISON_CTZ_R",
  "TOK_BISON_DIV_R", "TOK_BISON_EQ_R", "TOK_BISON_FFS_R",
  "TOK_BISON_FIX_R", "TOK_BISON_FLOAT_R", "TOK_BISON_FLOAT_EXTEND_R",
  "TOK_BISON_FLOAT_TRUNCATE_R", "TOK_BISON_FRACT_CONVERT_R",
  "TOK_BISON_GE_R", "TOK_BISON_GEU_R", "TOK_BISON_GT_R", "TOK_BISON_GTU_R",
  "TOK_BISON_HIGH_R", "TOK_BISON_IF_THEN_ELSE_R", "TOK_BISON_INSN_R",
  "TOK_BISON_IOR_R", "TOK_BISON_JUMP_INSN_R", "TOK_BISON_LABEL_REF_R",
  "TOK_BISON_LE_R", "TOK_BISON_LEU_R", "TOK_BISON_LSHIFTRT_R",
  "TOK_BISON_LO_SUM_R", "TOK_BISON_LT_R", "TOK_BISON_LTGT_R",
  "TOK_BISON_LTU_R", "TOK_BISON_WRITE_MEM_R", "TOK_BISON_READ_MEM_R",
  "TOK_BISON_MINUS_R", "TOK_BISON_MOD_R", "TOK_BISON_MULT_R",
  "TOK_BISON_NE_R", "TOK_BISON_NEG_R", "TOK_BISON_NOT_R",
  "TOK_BISON_ORDERED_R", "TOK_BISON_PARALLEL_R", "TOK_BISON_PARITY_R",
  "TOK_BISON_PC_R", "TOK_BISON_PLUS_R", "TOK_BISON_POPCOUNT_R",
  "TOK_BISON_REG_R", "TOK_BISON_ROTATE_R", "TOK_BISON_ROTATERT_R",
  "TOK_BISON_SAT_FRACT_R", "TOK_BISON_SET_R", "TOK_BISON_SIGN_EXTEND_R",
  "TOK_BISON_SMAX_R", "TOK_BISON_SMIN_R", "TOK_BISON_SQRT_R",
  "TOK_BISON_SYMBOL_REF_R", "TOK_BISON_TRUNCATE_R", "TOK_BISON_UDIV_R",
  "TOK_BISON_UMAX_R", "TOK_BISON_UMIN_R", "TOK_BISON_UMOD_R",
  "TOK_BISON_UNEQ_R", "TOK_BISON_UNGE_R", "TOK_BISON_UNGT_R",
  "TOK_BISON_UNLE_R", "TOK_BISON_UNLT_R", "TOK_BISON_UNORDERED_R",
  "TOK_BISON_UNSIGNED_FIX_R", "TOK_BISON_UNSIGNED_FLOAT_R",
  "TOK_BISON_UNSIGNED_FRACT_CONVERT_R", "TOK_BISON_UNSIGNED_SAT_FRACT_R",
  "TOK_BISON_XOR_R", "TOK_BISON_ZERO_EXTEND_R", "TOK_BISON_QC_R",
  "TOK_BISON_HC_R", "TOK_BISON_SC_R", "TOK_BISON_DC_R", "TOK_BISON_TC_R",
  "TOK_BISON_CQI_R", "TOK_BISON_CHI_R", "TOK_BISON_CSI_R",
  "TOK_BISON_CDI_R", "TOK_BISON_CTI_R", "TOK_BISON_QF_R", "TOK_BISON_HF_R",
  "TOK_BISON_SF_R", "TOK_BISON_DF_R", "TOK_BISON_TF_R", "TOK_BISON_QI_R",
  "TOK_BISON_HI_R", "TOK_BISON_SI_R", "TOK_BISON_DO_R", "TOK_BISON_TI_R",
  "TOK_BISON_V2SI_R", "TOK_BISON_V4HI_R", "TOK_BISON_V8QI_R",
  "TOK_BISON_CC_R", "TOK_BISON_CCFP_R", "TOK_BISON_CCFPE_R",
  "TOK_BISON_CCZ_R", "$accept", "root", "raw_unit", "version", "$@1",
  "node", "$@2", "node_d", "fun_ext_static", "tok_undefined", "fun_args",
  "fun_op", "$@3", "fun_op_strings", "fun_tmpl", "$@4", "wfunction_decl",
  "$@5", "$@6", "$@7", "$@8", "$@9", "widentifier_node", "$@10",
  "wfunction_type", "$@11", "$@12", "$@13", "tok_varargs",
  "parm_tok_register", "wparm_decl", "$@14", "$@15", "$@16", "$@17",
  "$@18", "gimple_bind_vars", "$@19", "wgimple_bind", "$@20",
  "winteger_cst", "$@21", "$@22", "wtree_list", "$@23", "$@24", "$@25",
  "var_decl_ext_stat", "var_tok_register", "wvar_decl", "$@26", "$@27",
  "$@28", "$@29", "$@30", "$@31", "wstring_cst", "$@32", "$@33", "$@34",
  "wvoid_type", "$@35", "wboolean_type", "$@36", "wlang_type", "$@37",
  "complex_tok_unsigned", "wcomplex_type", "$@38", "wvector_type", "$@39",
  "wCharType", "$@40", "woffset_type", "$@41", "wset_type", "$@42",
  "wqual_union_type", "$@43", "wtypename_type", "$@44",
  "wtemplate_type_parm", "$@45", "wreal_type", "$@46", "int_tok_unsigned",
  "winteger_type", "$@47", "$@48", "$@49", "$@50", "enum_tok_unsigned",
  "wenumeral_type", "$@51", "$@52", "$@53", "$@54", "wpointer_type",
  "$@55", "wreference_type", "$@56", "warray_type", "$@57", "$@58",
  "tok_ptrmem", "tok_spec", "tok_struct", "record_flds", "record_fncs",
  "rec_tmpl", "$@59", "wrecord_type", "$@60", "$@61", "$@62", "$@63",
  "$@64", "union_flds", "union_fncs", "wunion_type", "$@65",
  "wmethod_type", "$@66", "$@67", "$@68", "type_tmpl", "$@69",
  "wtype_decl", "$@70", "wtranslation_unit_decl", "$@71", "wlabel_decl",
  "$@72", "wconst_decl", "$@73", "wnamespace_decl", "$@74", "wresult_decl",
  "$@75", "$@76", "$@77", "$@78", "wfield_decl", "$@79", "$@80", "$@81",
  "$@82", "$@83", "wtemplate_decl", "$@84", "$@85", "$@86", "$@87",
  "wexc_ptr_expr", "$@88", "wfilter_expr", "$@89", "wreturn_expr", "$@90",
  "wgoto_expr", "$@91", "wgimple_label", "$@92", "wunsave_expr", "$@93",
  "wgimple_resx", "$@94", "wva_arg_expr", "$@95", "wexit_expr", "$@96",
  "wloop_expr", "$@97", "wnop_expr", "$@98", "wgimple_nop", "$@99",
  "wnegate_expr", "$@100", "wtruth_not_expr", "$@101", "wconvert_expr",
  "$@102", "waddr_expr", "$@103", "wreference_expr", "$@104",
  "wcleanup_point_expr", "$@105", "wfix_trunc_expr", "$@106",
  "wfix_ceil_expr", "$@107", "wfix_floor_expr", "$@108", "wfix_round_expr",
  "$@109", "wfloat_expr", "$@110", "wabs_expr", "$@111", "wconj_expr",
  "$@112", "wrealpart_expr", "$@113", "wimagpart_expr", "$@114",
  "wcard_expr", "$@115", "wnon_lvalue_expr", "$@116", "wview_convert_expr",
  "$@117", "windirect_ref", "$@118", "wcast_expr", "$@119",
  "wstatic_cast_expr", "$@120", "wreinterpret_cast_expr", "$@121",
  "wsizeof_expr", "$@122", "wthrow_expr", "$@123", "warrow_expr", "$@124",
  "wbuffer_ref", "$@125", "wgimple_predict", "$@126",
  "wgimple_modify_stmt", "$@127", "$@128", "$@129", "$@130", "$@131",
  "$@132", "wgt_expr", "$@133", "wplus_expr", "$@134",
  "wpointer_plus_expr", "$@135", "wminus_expr", "$@136", "wmult_expr",
  "$@137", "wtrunc_div_expr", "$@138", "wtrunc_mod_expr", "$@139",
  "wle_expr", "$@140", "wtruth_or_expr", "$@141", "wne_expr", "$@142",
  "weq_expr", "$@143", "wcompound_expr", "$@144", "winit_expr", "$@145",
  "wceil_div_expr", "$@146", "wfloor_div_expr", "$@147", "wround_div_expr",
  "$@148", "wceil_mod_expr", "$@149", "wfloor_mod_expr", "$@150",
  "wround_mod_expr", "$@151", "wrdiv_expr", "$@152", "wexact_div_expr",
  "$@153", "wmin_expr", "$@154", "wmax_expr", "$@155", "wlshift_expr",
  "$@156", "wrshift_expr", "$@157", "wlrotate_expr", "$@158",
  "wrrotate_expr", "$@159", "wbit_ior_expr", "$@160", "wbit_xor_expr",
  "$@161", "wbit_and_expr", "$@162", "wbit_not_expr", "$@163",
  "wtruth_andif_expr", "$@164", "wtruth_orif_expr", "$@165",
  "wtruth_and_expr", "$@166", "wtruth_xor_expr", "$@167", "wlt_expr",
  "$@168", "wge_expr", "$@169", "wunordered_expr", "$@170",
  "wordered_expr", "$@171", "wunlt_expr", "$@172", "wunle_expr", "$@173",
  "wungt_expr", "$@174", "wunge_expr", "$@175", "wuneq_expr", "$@176",
  "wltgt_expr", "$@177", "win_expr", "$@178", "wset_le_expr", "$@179",
  "wrange_expr", "$@180", "wcomplex_expr", "$@181", "wpredecrement_expr",
  "$@182", "wpreincrement_expr", "$@183", "wwith_cleanup_expr", "$@184",
  "vector_valu", "wvector_cst", "$@185", "$@186", "wtry_catch_expr",
  "$@187", "wvtable_ref", "$@188", "wtry_finally", "$@189", "wmem_ref",
  "$@190", "wwiden_sum_expr", "$@191", "wwiden_mult_expr", "$@192",
  "wvec_new_expr", "$@193", "wtry_block", "$@194", "$@195", "$@196",
  "$@197", "tree_vec_op", "tree_vec_op_opt", "wtree_vec", "$@198", "$@199",
  "wtemplate_id_expr", "$@200", "wtarget_expr_init_clnp", "$@201", "$@202",
  "wtarget_expr", "$@203", "$@204", "wssa_name", "$@205", "$@206", "$@207",
  "$@208", "$@209", "tok_ssa_name_def", "def_stmt_list",
  "tok_volatile_ssa_name", "wswitch_expr", "$@210", "$@211", "wsave_expr",
  "$@212", "$@213", "ternary_opt_ops", "$@214", "wscope_ref", "$@215",
  "$@216", "statement_list_stmt", "statement_list_bloc",
  "statement_list_stmt_bloc", "wstatement_list", "$@217", "wnew_expr",
  "$@218", "wreturn_stmt", "$@219", "$@220", "wpostincrement_expr",
  "$@221", "wmodop_expr", "gimple_phi_tuples", "gimple_phi_tuples_pair",
  "wphi_node", "$@222", "$@223", "wpostdecrement_expr", "$@224",
  "tok_overflow", "wreal_cst", "$@225", "$@226", "$@227",
  "wplaceholder_expr", "wdecl_stmt", "$@228", "$@229", "$@230",
  "woverload", "$@231", "$@232", "wlabeled_block_expr", "$@233", "$@234",
  "wfdesc_expr", "$@235", "whandler", "$@236", "$@237", "werror_mark",
  "wcatch_expr", "$@238", "wcomponent_ref", "$@239", "wexpr_stmt", "$@240",
  "$@241", "$@242", "wcomplex_cst", "$@243", "$@244", "$@245",
  "wexit_block_expr", "$@246", "$@247", "weh_filter_expr", "$@248",
  "wctor_initializer", "wconstructor", "$@249", "$@250",
  "constructor_elts", "constructor_elts_pair", "$@251", "wcompound_stmt",
  "$@252", "$@253", "wblock", "$@254", "wcond_expr", "$@255", "$@256",
  "$@257", "wgimple_cond", "$@258", "wgoto_subroutine", "$@259",
  "tok_volatile_asm", "wgimple_asm", "$@260", "$@261", "$@262", "$@263",
  "op_op_default", "$@264", "wcase_label_expr", "$@265", "binfo_baseinfos",
  "binfo_baseinfo_elts_pair", "$@266", "$@267", "$@268", "binfo_tok_virt",
  "wbinfo", "$@269", "$@270", "wbaselink", "$@271", "warray_ref", "$@272",
  "wcall_expr", "$@273", "$@274", "call_expr_args", "$@275",
  "wgimple_call", "$@276", "$@277", "gimple_call_args", "$@278",
  "wbit_field_ref", "$@279", "warray_range_ref", "$@280",
  "wtemplate_parm_index", "wwith_size_expr", "$@281", "wobj_type_ref",
  "$@282", "tok_C", "tok_artificial_opt", "tok_system_opt",
  "tok_virtual_opt", "tok_default_opt", "tok_operating_system_opt",
  "tok_library_system_opt", "wdecl_node", "$@283", "$@284", "$@285",
  "$@286", "$@287", "$@288", "$@289", "$@290", "$@291", "$@292",
  "wexpr_node", "$@293", "$@294", "$@295", "$@296", "wexpr_node_vops",
  "$@297", "$@298", "$@299", "$@300", "wtype_node", "$@301", "$@302",
  "$@303", "$@304", "$@305", "$@306", "qual_opt", "wattr", "wattr_el",
  "wunary_expr", "wbinary_expr", "$@307", "wternary_expr", "$@308",
  "$@309", "wquaternary_expr", "$@310", "$@311", "quaternary_opt_op",
  "$@312", "wsrcp_opt", "$@313", "$@314", "tok_hpl", "wpred_plus",
  "wsucc_star", "phi_star", "stmt_star", "rtl_star", "rtl", "rtl_mode",
  "wbloc", "$@315", "$@316", "$@317", "$@318", "wpred", "wsucc", "wvops",
  "$@319", "$@320", "wvuse", "wvuse_el", "$@321", "wvuse_op", "loads",
  "wvdef", "wvdef_opt", "wvdef_el", "$@322", "$@323", "stores", "wvdef_op",
  "wmemory_tag", "waliases", "wstruct_field_tag", "$@324",
  "wname_memory_tag", "$@325", "wsymbol_memory_tag", "$@326",
  "wmemory_partition_tag", "$@327", "wtarget_mem_ref461", "$@328", "$@329",
  "$@330", "$@331", "$@332", "$@333", "$@334", "$@335", "$@336",
  "wtarget_mem_ref", "$@337", "$@338", "$@339", "$@340", "$@341", "$@342",
  "$@343", "$@344", "$@345", "$@346", "$@347", "wtrait_expr",
  "time_weight_opt", "size_weight_opt", "rtl_size_weight_opt", "phi",
  "stmt", "def", "def_stmt", "edge", "arg", "vars", "flds", "fncs", "valu",
  "op", "strg", "valr", "valx", "type", "body", "size", "csts", "retn",
  "elts", "ptd", "refd", "fn", "got", "real", "imag", "binf", "init",
  "res", "var", "decl", "clnp", "exit", "str", "next", "expr", "crnt",
  "hdlr", "tmpl_parms", "tmpl_args", "vers", "algn", "prec", "value",
  "lngt", "used", "line", "vuse_op_el", "vdef_op_el", "alias", "loads_el",
  "stores_el", "orig", "idx", "name_opt", "type_opt", "body_opt",
  "inline_body_opt", "size_opt", "chan_opt", "attrib_opt", "prms_opt",
  "argt_opt", "retn_opt", "scpe_opt", "unql_opt", "op_opt", "domn_opt",
  "dcls_opt", "mngl_opt", "ptd_opt", "vfld_opt", "bpos_opt", "fn_opt",
  "binf_opt", "init_opt", "purp_opt", "valu_opt", "cnst_opt", "clas_opt",
  "clnp_opt", "lab_opt", "clob_opt", "rslt_opt", "inst_opt", "spcs_opt",
  "cls_opt", "bfld_opt", "next_opt", "expr_opt", "uid_opt", "algn_opt",
  "virt_opt", "fixd_opt", "use_tmpl_opt", "min_opt", "max_opt", "out_opt",
  "in_opt", "ptr_info_opt", "true_edge_opt", "false_edge_opt",
  "symbol_opt", "base_opt", "step_opt", "offset_opt", "tag_opt",
  "orig_opt", "smt_ann_opt", "idx_opt", "idx2_opt", "node_id", "string_id",
  "number_id", "string_id_opt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   547,   548,   548,   549,   549,   551,   550,   553,   552,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   555,   555,   556,   556,   557,   557,   558,   559,
     558,   560,   560,   561,   562,   561,   564,   565,   566,   567,
     568,   563,   570,   569,   569,   572,   573,   574,   571,   575,
     575,   576,   576,   578,   579,   580,   581,   582,   577,   583,
     584,   583,   586,   585,   588,   589,   587,   591,   592,   593,
     590,   594,   594,   594,   594,   594,   595,   595,   597,   598,
     599,   600,   601,   602,   596,   604,   605,   606,   603,   608,
     607,   610,   609,   612,   611,   613,   613,   615,   614,   617,
     616,   619,   618,   621,   620,   623,   622,   625,   624,   627,
     626,   629,   628,   631,   630,   632,   632,   634,   635,   636,
     637,   633,   638,   638,   640,   641,   642,   643,   639,   645,
     644,   647,   646,   649,   650,   648,   651,   651,   652,   652,
     653,   653,   654,   654,   655,   655,   656,   657,   656,   659,
     660,   661,   662,   663,   658,   664,   664,   665,   665,   667,
     666,   669,   670,   671,   668,   672,   673,   672,   675,   674,
     677,   676,   679,   678,   681,   680,   683,   682,   685,   686,
     687,   688,   684,   690,   691,   692,   693,   694,   689,   696,
     697,   698,   699,   695,   701,   700,   703,   702,   705,   704,
     707,   706,   709,   708,   711,   710,   713,   712,   715,   714,
     717,   716,   719,   718,   721,   720,   723,   722,   725,   724,
     727,   726,   729,   728,   731,   730,   733,   732,   735,   734,
     737,   736,   739,   738,   741,   740,   743,   742,   745,   744,
     747,   746,   749,   748,   751,   750,   753,   752,   755,   754,
     757,   756,   759,   758,   761,   760,   763,   762,   765,   764,
     767,   766,   769,   768,   771,   770,   773,   772,   775,   774,
     777,   776,   779,   780,   781,   782,   783,   784,   778,   786,
     785,   788,   787,   790,   789,   792,   791,   794,   793,   796,
     795,   798,   797,   800,   799,   802,   801,   804,   803,   806,
     805,   808,   807,   810,   809,   812,   811,   814,   813,   816,
     815,   818,   817,   820,   819,   822,   821,   824,   823,   826,
     825,   828,   827,   830,   829,   832,   831,   834,   833,   836,
     835,   838,   837,   840,   839,   842,   841,   844,   843,   846,
     845,   848,   847,   850,   849,   852,   851,   854,   853,   856,
     855,   858,   857,   860,   859,   862,   861,   864,   863,   866,
     865,   868,   867,   870,   869,   872,   871,   874,   873,   876,
     875,   878,   877,   880,   879,   882,   881,   884,   883,   886,
     885,   888,   887,   889,   889,   891,   892,   890,   894,   893,
     896,   895,   898,   897,   900,   899,   902,   901,   904,   903,
     906,   905,   908,   909,   910,   911,   907,   912,   912,   913,
     913,   915,   916,   914,   918,   917,   919,   920,   919,   921,
     919,   923,   924,   922,   926,   927,   928,   929,   930,   925,
     931,   931,   932,   932,   933,   933,   935,   936,   934,   938,
     939,   937,   940,   940,   941,   940,   943,   944,   942,   945,
     945,   946,   946,   947,   947,   947,   949,   948,   951,   950,
     953,   954,   952,   956,   955,   957,   958,   958,   959,   961,
     962,   960,   964,   963,   965,   965,   967,   968,   969,   966,
     970,   972,   973,   974,   971,   976,   977,   975,   979,   980,
     978,   982,   981,   984,   985,   983,   986,   988,   987,   990,
     989,   992,   993,   994,   991,   996,   997,   998,   995,  1000,
    1001,   999,  1003,  1002,  1004,  1006,  1007,  1005,  1008,  1008,
    1010,  1009,  1009,  1012,  1013,  1011,  1015,  1014,  1017,  1018,
    1019,  1016,  1021,  1020,  1023,  1022,  1024,  1024,  1026,  1027,
    1028,  1029,  1025,  1031,  1030,  1030,  1033,  1032,  1034,  1034,
    1036,  1035,  1037,  1035,  1038,  1035,  1039,  1039,  1041,  1042,
    1040,  1044,  1043,  1046,  1045,  1048,  1049,  1047,  1050,  1051,
    1050,  1053,  1054,  1052,  1055,  1056,  1055,  1058,  1057,  1060,
    1059,  1061,  1063,  1062,  1065,  1064,  1066,  1066,  1067,  1067,
    1068,  1068,  1069,  1069,  1070,  1070,  1071,  1071,  1072,  1072,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,
    1073,  1085,  1086,  1087,  1088,  1084,  1090,  1091,  1092,  1093,
    1089,  1095,  1096,  1097,  1098,  1099,  1100,  1094,  1101,  1101,
    1101,  1101,  1101,  1101,  1101,  1101,  1102,  1102,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1104,  1106,  1105,  1108,  1109,  1107,  1111,  1112,  1110,  1113,
    1113,  1114,  1113,  1115,  1116,  1117,  1115,  1118,  1118,  1119,
    1119,  1120,  1120,  1121,  1121,  1122,  1122,  1123,  1123,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1125,  1125,  1125,
    1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,
    1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,  1125,
    1125,  1125,  1125,  1125,  1125,  1127,  1128,  1129,  1130,  1126,
    1131,  1131,  1132,  1132,  1133,  1134,  1133,  1135,  1133,  1136,
    1136,  1138,  1137,  1139,  1139,  1140,  1140,  1141,  1141,  1142,
    1142,  1144,  1145,  1143,  1146,  1146,  1147,  1147,  1148,  1149,
    1149,  1151,  1150,  1153,  1152,  1155,  1154,  1157,  1156,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,  1158,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,
    1168,  1180,  1181,  1181,  1182,  1182,  1183,  1183,  1184,  1185,
    1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,  1204,  1205,
    1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,  1215,
    1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1238,  1239,  1239,  1240,  1240,  1241,  1241,
    1242,  1242,  1243,  1243,  1244,  1244,  1245,  1245,  1246,  1246,
    1247,  1247,  1248,  1248,  1249,  1249,  1250,  1250,  1251,  1251,
    1252,  1252,  1253,  1253,  1254,  1254,  1255,  1255,  1256,  1256,
    1257,  1257,  1258,  1258,  1259,  1259,  1260,  1260,  1261,  1261,
    1262,  1262,  1263,  1263,  1264,  1264,  1265,  1265,  1266,  1266,
    1267,  1267,  1268,  1268,  1269,  1269,  1270,  1270,  1271,  1271,
    1272,  1272,  1273,  1273,  1274,  1274,  1274,  1275,  1275,  1276,
    1276,  1277,  1277,  1278,  1278,  1279,  1279,  1280,  1280,  1281,
    1281,  1282,  1282,  1283,  1283,  1284,  1284,  1285,  1285,  1286,
    1286,  1287,  1287,  1288,  1288,  1289,  1289,  1290,  1290,  1291,
    1291,  1292,  1292,  1293,  1293,  1294,  1294,  1295,  1296,  1297,
    1298,  1298
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     0,     5,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     1,     0,     2,     0,     0,
       3,     0,     2,     0,     0,     3,     0,     0,     0,     0,
       0,    18,     0,     4,     2,     0,     0,     0,     8,     0,
       1,     0,     1,     0,     0,     0,     0,     0,    13,     0,
       0,     3,     0,     5,     0,     0,     5,     0,     0,     0,
       7,     0,     2,     1,     1,     2,     0,     1,     0,     0,
       0,     0,     0,     0,    17,     0,     0,     0,     7,     0,
       3,     0,     3,     0,     3,     0,     1,     0,     4,     0,
       4,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     4,     0,     1,     0,     0,     0,
       0,    11,     0,     1,     0,     0,     0,     0,    11,     0,
       4,     0,     4,     0,     0,     6,     0,     1,     0,     1,
       0,     1,     0,     2,     0,     2,     0,     0,     3,     0,
       0,     0,     0,     0,    18,     0,     2,     0,     2,     0,
       7,     0,     0,     0,     8,     0,     0,     3,     0,     4,
       0,     3,     0,     3,     0,     4,     0,     4,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,    10,     0,     3,     0,     3,     0,     4,
       0,     4,     0,     4,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     0,     0,     0,     0,     0,    14,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     1,     2,     0,     0,     5,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     0,     0,     0,     9,     1,     2,     0,
       1,     0,     0,     5,     0,     3,     0,     0,     3,     0,
       3,     0,     0,     6,     0,     0,     0,     0,     0,    12,
       1,     1,     1,     2,     0,     1,     0,     0,     6,     0,
       0,     6,     0,     1,     0,     3,     0,     0,     6,     1,
       2,     1,     2,     0,     1,     1,     0,     3,     0,     3,
       0,     0,     5,     0,     3,     1,     0,     2,     2,     0,
       0,     6,     0,     3,     0,     1,     0,     0,     0,     8,
       1,     0,     0,     0,     7,     0,     0,     5,     0,     0,
       6,     0,     3,     0,     0,     5,     1,     0,     3,     0,
       3,     0,     0,     0,     7,     0,     0,     0,     7,     0,
       0,     6,     0,     3,     1,     0,     0,     5,     0,     2,
       0,     3,     1,     0,     0,     5,     0,     3,     0,     0,
       0,     8,     0,     4,     0,     3,     0,     1,     0,     0,
       0,     0,    11,     0,     3,     1,     0,     5,     0,     2,
       0,     3,     0,     3,     0,     3,     0,     1,     0,     0,
       6,     0,     3,     0,     3,     0,     0,     6,     0,     0,
       3,     0,     0,     6,     0,     0,     3,     0,     3,     0,
       3,     1,     0,     3,     0,     3,     0,     1,     0,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,    10,     0,     0,     0,     0,
      10,     0,     0,     0,     0,     0,     0,    13,     0,     2,
       2,     2,     2,     2,     2,     2,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     0,     4,     0,     0,     6,     0,     0,     6,     0,
       1,     0,     3,     0,     0,     0,     6,     0,     1,     1,
       2,     0,     2,     0,     2,     0,     2,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     0,     0,     0,    14,
       2,     2,     2,     2,     0,     0,     3,     0,     2,     1,
       2,     0,     4,     0,     2,     1,     2,     1,     2,     0,
       1,     0,     0,     6,     0,     2,     0,     2,     2,     0,
       2,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    19,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     1,     0,     2,     0,     2,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     1,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     2,     1,     1,     1,
       0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     2,     4,  1288,     6,     1,     3,     8,
       5,     0,     0,     0,   676,     0,   247,   591,   706,   269,
     297,   293,   277,   279,   304,   271,   281,   309,   283,   311,
     341,   313,   285,   329,   339,   287,   225,   273,   244,   656,
     685,   565,   265,   216,   352,   354,   348,   258,   233,   358,
     363,   356,   350,   679,   757,   434,   448,   743,   759,   570,
     374,   376,   695,   481,   452,   483,   601,   708,   712,   242,
     668,   751,   745,   561,   396,   408,   660,   461,   465,   467,
     469,   485,   487,   489,   471,   491,   493,   495,   497,   499,
     410,   412,   414,   416,   418,   398,   501,   503,   420,   505,
     507,   509,   511,   513,   515,   517,   519,   521,   523,   525,
     475,   527,   400,   529,   473,   459,   531,   479,   477,   533,
     535,   537,   539,   541,   543,   545,   547,   549,   551,   428,
     553,   402,   394,   430,   432,   619,   384,   404,   406,   671,
     555,   422,   424,   426,   557,   559,   652,   643,   388,   568,
     572,   382,   380,   714,   378,   390,   392,   689,   616,   726,
     386,   718,   604,   649,   677,   692,   636,   369,   291,   436,
     438,   289,   442,   626,   703,   694,   661,   681,   640,   645,
     638,   580,   665,   440,   594,   444,   582,   446,   673,   741,
     738,   761,   762,   764,  1081,  1083,  1085,  1087,   463,  1099,
    1089,  1111,   450,   574,   576,   578,     9,    10,    11,    12,
      13,    14,    15,    17,    22,    24,    18,    29,    49,    51,
      72,    75,    76,    78,    80,   165,   164,    54,    16,    74,
      48,    50,    25,    58,    79,    77,    20,    57,    52,    89,
      47,    53,    59,   163,    92,    93,    21,    39,    40,   141,
     157,   151,   154,   155,    41,    42,    44,    38,    56,    81,
      86,    84,   106,   107,   108,   109,   170,   112,   144,   145,
     146,   137,   139,   140,    83,   166,   167,   181,   168,   183,
     185,    67,   198,    23,    28,    30,    31,    32,    33,    34,
      35,    36,    37,    43,    46,    94,    95,    96,   100,   101,
     102,   103,   104,   171,   105,   110,   111,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   138,   143,   147,   148,    69,    88,   152,    91,   153,
     199,   200,   201,   179,   184,    64,   182,    98,    45,    63,
      85,   169,    19,   178,   176,   150,   177,    97,   149,    55,
      70,   174,   180,    99,   142,   187,    65,   159,    62,   175,
      87,   156,   160,   173,   161,   172,    66,    26,    27,    71,
     158,    73,   162,   186,    82,    60,    61,    90,    68,   188,
     189,   190,   191,   192,   193,   194,   196,   195,   197,     7,
       0,   224,   222,  1216,     0,  1290,   808,   808,   808,   808,
     808,   808,   808,   808,   808,   808,   808,   808,   808,   808,
     808,   808,   808,   808,   808,     0,     0,     0,     0,  1174,
    1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1054,  1174,  1174,  1174,  1054,  1174,  1174,  1054,  1174,
    1174,   923,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1174,  1174,  1174,  1174,  1054,  1054,  1174,
    1054,  1174,  1174,  1174,  1054,  1174,  1174,  1054,     0,     0,
    1174,  1174,   633,  1172,   808,  1174,  1174,   808,  1174,  1174,
       0,     0,     0,     0,  1174,  1174,     0,  1174,  1174,  1174,
       0,  1174,     0,  1174,  1174,  1174,  1174,  1172,  1172,  1172,
    1172,  1174,     0,     0,  1174,  1174,  1174,  1174,  1129,     0,
       0,   248,     0,   592,  1291,   707,     0,   270,   801,     0,
       0,   275,     0,     0,   272,   282,     0,   284,     0,  1190,
       0,   286,   326,     0,   288,     0,   274,     0,   245,   657,
     686,   566,     0,   266,     0,   208,   780,   353,  1220,   345,
    1253,  1188,  1214,   816,  1200,   351,     0,   680,   791,   758,
    1196,   435,   449,     0,   744,   760,   571,   375,   377,   696,
       0,   482,     0,   796,     0,     0,   484,     0,     0,     0,
     239,  1226,     0,     0,   562,     0,   397,   409,   462,   466,
     468,   470,   486,   488,   490,   472,   492,   494,   496,   498,
     500,   411,   413,   415,   417,   419,   399,   502,   504,   421,
     506,   508,   510,   512,   514,   516,   518,   520,   522,   524,
     526,   476,   528,   401,   530,   474,   460,   532,   480,   478,
     534,   536,   538,   540,   542,   544,   546,   548,   550,   552,
     429,   554,   403,   395,   431,   433,     0,   385,   405,   407,
     672,   556,   423,   425,   427,   558,   560,   653,   644,   389,
     569,   573,     0,     0,   715,  1196,   391,   393,  1290,     0,
       0,   387,   716,     0,   605,     0,   650,   678,   693,     0,
    1045,   634,   635,   637,   631,   629,  1230,   292,   437,   439,
     290,   443,     0,     0,   704,   662,   682,   641,   639,   581,
       0,   666,   441,   595,   445,   583,   447,   674,   742,   739,
     763,   765,  1079,  1082,  1084,  1086,  1088,   464,  1100,  1090,
     451,   575,   577,   579,   223,  1287,  1217,  1218,  1289,  1162,
     589,   809,   810,   811,   812,   813,   814,   815,  1172,     0,
     298,   294,   276,   278,     0,   280,   305,     0,   310,     0,
     312,     0,   342,   314,     0,   316,   327,   335,     0,   226,
    1132,     0,   654,     0,     0,  1175,     0,  1173,   209,   816,
    1202,     0,   355,   349,   346,     0,   259,     0,   234,     0,
     359,  1214,     0,   357,     0,   913,   923,     0,   910,   916,
     698,   911,   453,   923,  1061,  1069,  1059,  1071,  1058,  1067,
       0,   602,   709,   713,     0,     0,   240,     0,   669,     0,
     752,   746,   924,   620,   383,   381,   379,   690,   617,   725,
       0,   723,   717,     0,  1147,     0,  1146,   646,  1119,     0,
     630,   632,     0,   370,   627,  1164,     0,     0,     0,  1242,
    1154,  1182,     0,     0,   736,  1078,  1112,  1112,     0,  1219,
     249,   590,   593,   587,   802,  1160,  1290,  1137,   302,  1138,
    1139,  1191,  1186,  1198,  1156,   317,  1204,     0,   337,  1136,
    1186,     0,   246,   655,     0,     0,   687,   567,   563,   267,
     211,   213,     0,   781,  1221,     0,  1254,   816,  1189,  1180,
    1215,     0,   833,   834,   829,   901,   859,   855,   856,   826,
     818,   819,   820,   821,   822,   824,   823,   825,   827,   828,
     830,   831,   832,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,   850,   851,
     852,   853,   854,   857,   858,   860,   861,   862,   863,   864,
     865,   866,   867,   869,   868,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   902,   903,   904,   905,
     906,   907,   908,   909,   817,   364,  1201,  1128,     0,  1112,
    1197,     0,   697,  1196,     0,  1112,  1063,  1060,  1070,  1056,
       0,  1068,  1148,   596,     0,  1124,     0,   243,   239,  1227,
       0,  1140,   754,   748,     0,   622,     0,     0,     0,   727,
    1196,     0,   719,     0,   606,   772,  1046,  1231,  1232,     0,
     705,   663,     0,   683,     0,   642,     0,   667,   584,   675,
     737,   728,     0,  1080,     0,  1101,  1091,  1127,  1182,   588,
    1194,   299,   303,  1255,     0,   343,     0,   315,     0,   330,
       0,   328,     0,  1212,   336,   227,  1161,     0,   658,  1142,
       0,   564,     0,   210,  1251,   214,  1203,  1279,   347,   251,
       0,   235,     0,   360,  1180,   914,   792,   917,     0,   699,
     702,   700,   912,   454,   797,     0,  1072,     0,     0,   603,
     597,   599,   710,  1133,   241,   670,     0,   753,   755,   747,
     749,   925,   621,   623,     0,   691,   618,  1141,   724,  1151,
    1259,  1158,  1263,     0,   773,   647,   651,     0,   927,     0,
     371,   628,     0,  1153,     0,  1243,  1183,     0,   740,  1167,
    1113,  1114,  1114,   250,     0,   803,   295,     0,   306,  1187,
    1222,  1199,  1205,  1236,  1157,  1125,     0,     0,   338,   340,
     229,  1130,     0,     0,   688,   268,   212,     0,   217,     0,
       0,   782,   254,   253,  1214,  1181,     0,  1134,     0,   365,
    1196,  1114,   919,  1171,     0,  1112,  1114,     0,     0,  1062,
    1064,  1065,  1076,  1145,  1149,  1224,  1214,     0,  1123,   754,
     748,     0,     0,  1150,     0,   720,     0,   607,  1120,     0,
     648,   928,     0,  1233,  1234,     0,   664,   684,     0,   585,
     730,   732,   734,   729,     0,  1102,  1092,  1195,  1180,   296,
    1255,  1256,  1257,     0,   344,     0,   331,  1213,  1126,   230,
     228,     0,   659,  1143,  1252,  1249,   215,  1280,  1174,   255,
     252,   260,     0,   236,   361,     0,   915,   793,   918,   920,
     701,   455,   798,  1165,  1168,  1066,  1074,     0,   598,   600,
     711,   756,   750,   926,   625,  1260,  1261,  1264,   614,  1122,
       0,   931,   929,     0,   372,  1152,  1155,  1240,     0,     0,
       0,  1115,  1116,  1116,   804,   300,     0,   307,  1223,  1237,
    1238,  1131,     0,   218,   783,  1180,  1159,     0,  1281,   366,
    1116,     0,  1114,  1116,     0,  1073,  1077,  1225,     0,   721,
       0,   615,   772,   611,   610,   612,  1050,  1051,  1265,   930,
    1235,  1186,     0,   586,     0,   731,   733,   735,     0,  1103,
    1093,  1192,  1257,  1258,     0,     0,   332,  1250,  1210,  1192,
     261,     0,   237,     0,   362,  1208,   794,   922,   456,   799,
    1166,     0,  1075,  1262,  1228,  1121,   608,   613,     0,     0,
     932,  1047,   373,  1241,  1144,  1117,  1269,  1271,     0,   805,
     301,     0,   308,  1239,  1206,     0,   219,   784,     0,  1163,
     231,  1282,     0,   367,   937,  1116,   937,  1169,     0,   722,
     774,  1052,  1053,  1266,  1267,     0,  1104,     0,  1094,  1193,
    1247,  1135,     0,   333,  1211,   206,   923,   262,   232,  1281,
    1209,  1281,   795,   457,   800,  1229,   775,   609,     0,  1048,
    1270,  1271,  1272,  1275,     0,   806,  1207,   318,   204,  1182,
       0,   238,   368,     0,   937,  1268,   933,  1105,     0,  1095,
    1248,   770,   319,   320,   205,   202,   207,   785,   263,   939,
     940,   941,   942,   943,   944,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   972,   971,   973,   974,   975,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,   458,   935,
    1283,  1276,  1283,   771,   807,   321,   322,   203,  1176,  1184,
     256,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,   938,     0,
     937,   934,     0,  1106,  1096,   324,     0,   220,     0,   786,
     257,  1281,  1118,  1049,   936,  1284,  1273,  1273,  1212,   323,
    1177,  1178,  1185,   768,   264,     0,  1107,  1097,   325,   334,
       0,   221,   769,   787,  1274,  1275,  1285,  1179,   776,  1108,
       0,  1098,   777,   788,     0,  1286,   778,     0,  1109,   779,
     789,  1170,  1277,   766,     0,  1110,   767,  1244,  1278,     0,
       0,   790,  1245,  1246
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,    11,    10,    12,   206,  1628,  1535,
    1518,   849,   960,  1153,  1154,  1249,   207,   430,  1325,  1428,
    1495,  1681,   208,   589,   209,   423,   950,  1240,  1320,  1499,
     210,   435,   969,  1256,  1387,  1470,   885,  1088,   211,   456,
     212,   425,   841,   213,   403,   807,  1128,  1254,  1671,   214,
     434,   967,  1385,  1468,  1520,  1630,   215,   429,   846,  1152,
     216,   406,   217,   412,   218,   424,   823,   219,   409,   220,
     410,   221,   413,   222,   415,   223,   419,   224,   422,   225,
     557,   226,   554,   227,   408,  1310,   228,   407,   936,  1226,
    1422,  1133,   229,   411,   938,  1312,  1424,   230,   414,   231,
     416,   232,   418,   943,   946,  1533,  1626,  1665,  1678,   835,
     947,   233,   420,  1233,  1380,  1464,  1517,   948,  1143,   234,
     421,   235,   417,   942,  1230,   853,   965,   236,   433,   237,
     439,   238,   431,   239,   432,   240,   438,   241,   436,   971,
    1258,  1388,   242,   437,  1164,  1335,  1435,  1501,   243,   553,
    1108,  1294,  1411,   244,   447,   245,   448,   246,   540,   247,
     538,   248,   537,   249,   522,   250,   546,   251,   534,   252,
     541,   253,   542,   254,   518,   255,   461,   256,   481,   257,
     498,   258,   517,   259,   523,   260,   524,   261,   462,   262,
     476,   263,   477,   264,   478,   265,   479,   266,   480,   267,
     484,   268,   527,   269,   528,   270,   529,   271,   515,   272,
     519,   273,   520,   274,   442,   275,   555,   276,   556,   277,
     567,   278,   558,   279,   569,   280,   571,   281,   443,   282,
     584,   283,   451,  1074,  1265,  1392,  1475,  1524,   284,   501,
     285,   463,   286,   581,   287,   464,   288,   465,   289,   466,
     290,   470,   291,   500,   292,   496,   293,   504,   294,   503,
     295,   450,   296,   452,   297,   467,   298,   468,   299,   469,
     300,   471,   301,   472,   302,   473,   303,   474,   304,   475,
     305,   482,   306,   483,   307,   485,   308,   486,   309,   487,
     310,   488,   311,   489,   312,   490,   313,   491,   314,   492,
     315,   493,   316,   494,   317,   495,   318,   497,   319,   499,
     320,   502,   321,   505,   322,   506,   323,   507,   324,   508,
     325,   509,   326,   510,   327,   511,   328,   512,   329,   513,
     330,   514,   331,   516,   332,   526,   333,   530,   334,   531,
     335,   460,   957,   336,   428,   844,   337,   535,   338,   446,
     339,   536,   340,   585,   341,   586,   342,   587,   343,   565,
     344,   570,   922,  1217,  1367,   931,   932,   345,   404,   810,
     346,   568,  1179,  1275,  1276,   347,   453,  1083,   348,   548,
     905,  1202,  1358,  1480,  1402,  1403,  1404,   349,   544,  1097,
     350,   521,  1095,  1192,  1282,   351,   559,  1109,   761,   762,
     763,   352,   552,   353,   564,   354,   563,   919,   355,   533,
     356,  1105,  1205,   357,   549,   907,   358,   532,   954,   359,
     426,   842,  1242,   360,   361,   561,   917,  1212,   362,   566,
     921,   363,   457,  1090,   364,   525,   365,   572,   923,   366,
     367,   550,   368,   440,   369,   562,   918,  1214,   370,   427,
     843,  1150,   371,   543,  1096,   372,   551,   373,   374,   449,
     870,  1072,  1169,  1264,   375,   560,   916,   376,   405,   377,
     454,  1084,  1277,   378,   455,   379,   539,   903,   380,   547,
    1200,  1356,  1444,   900,  1100,   381,   545,  1218,  1303,  1368,
    1369,  1370,  1121,   382,   574,   924,   383,   573,   384,   444,
     385,   459,  1093,  1189,  1280,   386,   458,  1092,  1187,  1279,
     387,   441,   388,   445,   389,   390,   575,   391,   576,  1717,
    1693,  1624,  1206,  1507,  1703,  1710,   792,   850,  1157,  1328,
    1429,  1496,  1629,  1683,  1698,  1706,  1713,   650,   866,  1261,
    1390,  1474,   652,   873,  1266,  1393,  1476,   597,   818,  1130,
    1308,  1421,  1490,  1531,   598,   861,  1064,   641,   651,  1073,
     637,  1068,  1260,   644,  1071,  1262,  1338,  1391,   666,  1094,
    1281,  1292,  1361,  1408,  1619,  1660,  1502,  1617,  1658,   764,
     909,  1208,  1484,  1526,  1362,  1450,   653,   654,   655,   875,
     876,  1076,  1175,  1269,   878,  1079,   879,  1080,  1272,  1395,
    1346,   793,   925,   392,   577,   393,   578,   394,   579,   395,
     580,   396,   583,   927,  1222,  1373,  1457,  1513,  1622,  1677,
    1696,   397,   582,   926,  1221,  1372,  1456,  1511,  1620,  1676,
    1695,  1704,  1712,   398,  1125,  1305,  1419,  1661,   765,  1207,
    1405,  1290,  1188,   886,  1144,  1238,   929,   865,   402,  1148,
    1322,   618,  1087,  1163,  1462,   839,   825,   828,   830,   890,
    1099,   956,  1244,  1415,  1180,   756,   754,   881,  1181,  1195,
    1102,  1296,  1113,   781,  1299,   836,  1141,  1104,  1333,   820,
     952,   593,  1432,   774,  1270,  1396,  1123,  1271,  1442,  1708,
    1171,   626,   638,  1667,  1691,  1161,  1117,  1669,  1135,   858,
     832,  1459,  1225,   868,  1137,   863,   963,  1139,  1493,  1473,
    1466,  1239,   860,   591,   930,   852,  1314,  1348,   888,  1479,
     913,  1210,  1364,  1316,  1426,  1413,  1115,  1721,  1515,  1383,
    1248,   856,  1228,  1377,  1285,  1399,  1287,  1451,  1509,  1486,
    1488,  1686,  1529,  1715,  1251,  1434,  1663,  1701,   806,   594,
     809,   595
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1456
static const yytype_int16 yypact[] =
{
      43,    80,    83,    91, -1456, -1456, -1456, -1456,    91, -1456,
   -1456,    79,  1146,    80, -1456,  -148, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
      80, -1456, -1456,  -108,   -52,    80,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -37,   -37,   -37,   -37,   -35,
     -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,   -25,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,  -329,   -35,   -35,   -35,  -329,   -35,   -35,  -329,   -35,
     -35,   -26,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,  -329,  -329,   -35,
    -329,   -35,   -35,   -35,  -329,   -35,   -35,  -329,   -85,   -81,
     -35,   -35,  -132,   -25,   -73,   -35,   -35,   -73,   -35,   -35,
    -180,  -180,  -180,  -180,   -35,   -35,  -107,   -35,   -35,   -35,
    -180,   -35,  -180,   -35,   -35,   -35,   -35,   -25,   -25,   -25,
     -25,   -35,   -37,   -37,   -35,   -35,   -35,   -35, -1456,   -52,
     168, -1456,   172, -1456, -1456, -1456,  -276, -1456, -1456,   -33,
     -33,  -121,   -39,   -33, -1456, -1456,   -43, -1456,   -42,   -19,
     -39, -1456,  -100,  -116, -1456,   -14, -1456,   168, -1456, -1456,
   -1456, -1456,   168, -1456,   168,  -109, -1456, -1456,   -68,  -100,
     -94,   -15,   -51, -1456,   -29, -1456,   -17, -1456, -1456, -1456,
     -16, -1456, -1456,   -17, -1456, -1456, -1456, -1456, -1456, -1456,
     -17, -1456,   -17, -1456,  -214,  -216, -1456,   -57,   -17,   -17,
     -13,   -56,   -10,   -10, -1456,    80, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456,   -17, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456,   -17,   -17, -1456,   -16, -1456, -1456,    80,   -17,
    -162, -1456,   -93,   168, -1456,   168, -1456, -1456, -1456,   168,
   -1456,    -6,     3, -1456, -1456, -1456,   -46, -1456, -1456, -1456,
   -1456, -1456,   -17,   172, -1456, -1456, -1456, -1456, -1456, -1456,
     168, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456,     5, -1456, -1456,
     -17, -1456, -1456, -1456, -1456, -1456, -1456, -1456,   -25,   172,
   -1456, -1456, -1456, -1456,   168, -1456, -1456,   168, -1456,   168,
   -1456,   168, -1456, -1456,   168,  -173, -1456, -1456,   168, -1456,
   -1456,    22,   -70,    -5,     5, -1456,    33, -1456, -1456, -1456,
       8,   168, -1456, -1456, -1456,   172, -1456,   168, -1456,   168,
   -1456,  1479,   168, -1456,   168, -1456,   -26,   168, -1456, -1456,
   -1456, -1456, -1456,   -26, -1456,  -304, -1456, -1456,  -216, -1456,
     168, -1456, -1456, -1456,   168,    37, -1456,   168, -1456,   168,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
       1, -1456, -1456,   -31, -1456,   -18, -1456, -1456, -1456,   172,
   -1456, -1456,   168, -1456, -1456, -1456,    37,   -57,   -40,   -38,
   -1456,    26,    37,    37,   -54,   -86,    32,    32,   168, -1456,
   -1456,   -17, -1456, -1456, -1456, -1456,    80, -1456,   -47, -1456,
   -1456, -1456,    52,    35, -1456, -1456,    34,   -30,    28, -1456,
      52,   172, -1456, -1456,    36,   168, -1456,     5, -1456, -1456,
   -1456,  1627,   168, -1456, -1456,   -30, -1456, -1456, -1456,    60,
   -1456,    61, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,   -17,    32,
   -1456,   -17,  -179,   -16,   -17,    32, -1456, -1456,  -216, -1456,
     168, -1456, -1456,  -164,   -17, -1456,   168, -1456,   -13, -1456,
      37, -1456,    66,    66,   172,   -17,     4,   -17,   168, -1456,
     -16,    80, -1456,   172, -1456,  -206, -1456, -1456,    -8,   -17,
   -1456, -1456,   168, -1456,   168, -1456,   168, -1456, -1456, -1456,
   -1456, -1456,   168, -1456,   172, -1456, -1456, -1456,    26, -1456,
      44, -1456, -1456,    58,   168, -1456,   168, -1456,   168, -1456,
     168, -1456,   168,  -192, -1456, -1456, -1456,    80, -1456, -1456,
      38, -1456,   -52,    80,   -84, -1456, -1456,  -163, -1456,  1284,
     168, -1456,   168, -1456,    60, -1456, -1456, -1456,   168, -1456,
   -1456, -1456, -1456, -1456, -1456,  -294, -1456,   168,   168, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456,   168, -1456, -1456, -1456,
   -1456, -1456, -1456,    57,   168, -1456, -1456, -1456, -1456, -1456,
      11, -1456,  -146,   168, -1456, -1456, -1456,    24,    30,   168,
   -1456, -1456,     2, -1456,     2, -1456, -1456,    -3,  -103, -1456,
   -1456,    67,    67, -1456,   168, -1456,   -12,   168, -1456, -1456,
      23, -1456, -1456,     9, -1456, -1456,   168,   168, -1456, -1456,
     -24, -1456,    56,   168, -1456, -1456, -1456,   172, -1456,   -30,
     168, -1456,   -11,    -9,   -51, -1456,    86, -1456,    86, -1456,
     -16,    67,   -17, -1456,     5,    32,    67,   168,   168,  -127,
   -1456, -1456, -1456, -1456, -1456,    29,   -51,   -17, -1456,    66,
      66,   172,   -17, -1456,   168, -1456,   168, -1456, -1456,   172,
   -1456, -1456,    45, -1456,    17,   168, -1456, -1456,   168, -1456,
   -1456, -1456, -1456, -1456,   172, -1456, -1456, -1456,    60, -1456,
      58, -1456,    85,   168, -1456,   168, -1456, -1456, -1456, -1456,
   -1456,    80, -1456, -1456, -1456,    -7, -1456, -1456,   -35, -1456,
   -1456, -1456,   172, -1456, -1456,    86, -1456, -1456, -1456,    87,
   -1456, -1456, -1456, -1456, -1456, -1456,  -120,   168, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456,    39, -1456,  -184, -1456,
      21,    45, -1456,   168, -1456, -1456, -1456,    25,    59,    59,
      59, -1456,    89,    89, -1456, -1456,   168, -1456, -1456, -1456,
      31, -1456,   172, -1456, -1456,    60, -1456,    97,  -133, -1456,
      89,   -17,    67,    89,   168,  -106, -1456, -1456,   168, -1456,
     168, -1456,   -32,    53, -1456, -1456, -1456, -1456,  -212, -1456,
   -1456,    52,   168, -1456,   168, -1456, -1456, -1456,   172, -1456,
   -1456,   104,    85, -1456,    40,   168, -1456, -1456,    77,   104,
   -1456,   172, -1456,   168, -1456,    88, -1456, -1456, -1456, -1456,
   -1456,   168, -1456, -1456,    47, -1456, -1456, -1456,    18,   172,
   -1456, -1456, -1456, -1456, -1456, -1456,  -112,  -111,   168, -1456,
   -1456,   168, -1456, -1456,    90,   168, -1456, -1456,    86, -1456,
      14, -1456,   168, -1456, -1456,    89, -1456, -1456,   168, -1456,
      16, -1456, -1456, -1456,  -102,   168, -1456,   168, -1456, -1456,
     123, -1456,   168, -1456, -1456, -1456,   -26, -1456, -1456,  -133,
   -1456,  -133,  -118, -1456,  -118, -1456, -1456, -1456,   172, -1456,
   -1456,  -111, -1456,  -105,   172, -1456, -1456,   -20,  -151,    26,
      97, -1456, -1456,  1594, -1456, -1456, -1456, -1456,   168, -1456,
   -1456,    46, -1456,    41, -1456,    42, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456,  -154,  -118,    75,
    -104, -1456,  -104, -1456, -1456, -1456, -1456, -1456,   136,    84,
      48, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,   168,
      -6, -1456,   168, -1456, -1456,    28,   168, -1456,   168, -1456,
   -1456,  -133, -1456,  -118, -1456, -1456,   -97,   -97,  -192, -1456,
   -1456,   -71, -1456,    51, -1456,   168, -1456, -1456, -1456, -1456,
     168, -1456, -1456, -1456, -1456,  -105,   -90, -1456,    54, -1456,
     168, -1456, -1456, -1456,   -89, -1456,    62,   168, -1456, -1456,
   -1456, -1456,   -91,    63,   168, -1456, -1456,  -110, -1456,   172,
     172, -1456, -1456, -1456
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1456, -1456,   345, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456,  -740, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456,  -931, -1456, -1456, -1456, -1456,  -927, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1045, -1456, -1456, -1456,  -334, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456,   438, -1456, -1456,
   -1456, -1456,  -384, -1456, -1456, -1456, -1456,  -355, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456,  -809, -1456,   210,   897, -1456,
    -369, -1456, -1456,   -87, -1456, -1456, -1456, -1456,  -859, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1443, -1456, -1456,  -403,
   -1456, -1456, -1456, -1456, -1001, -1456, -1456, -1456, -1456, -1456,
    -514, -1456, -1456, -1456,  -513, -1456,  -847, -1456, -1456, -1456,
   -1456,  -429, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456,  -910, -1186, -1300, -1456,  -758, -1456,
   -1040, -1456, -1080, -1456, -1301, -1285,  -825,  -634,  -452, -1456,
   -1456,  -389,  -881, -1456, -1456, -1456,  -215, -1456, -1456,  -267,
   -1456, -1456, -1456, -1208, -1456, -1456, -1456,  -520, -1456, -1456,
   -1456,  -816, -1456, -1456, -1456,  -608,  -938, -1456, -1229,  -486,
   -1456,  -585, -1120,  -450, -1456, -1456, -1456,  -868, -1456, -1456,
   -1456,  -416,  -427, -1456, -1456, -1136, -1108, -1456,  -939, -1456,
   -1456, -1026, -1456,  -735, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1274,  -846, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456, -1456,
   -1456, -1456,  -905, -1016, -1456, -1456, -1456, -1456, -1456, -1456,
   -1104, -1268, -1283, -1456, -1456, -1455, -1212, -1456,  -616,    -1,
    -768,  -716
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1058
static const yytype_int16 yytable[] =
{
       6,   840,   623,   910,   804,   915,   845,  1069,   847,   869,
     896,  1145,   399,  1190,  1075,  1065,   871,  1126,   872,   958,
    1223,   854,   649,   808,   882,   883,   808,  1158,  1259,  1334,
     928,  1081,   897,  1504,  1448,  1110,  1306,   619,   620,   621,
     961,  1118,  1119,  1186,  1521,  1203,  1522,  1236,   400,     1,
     864,   935,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
    1400,   659,   639,  1420,   662,  1337,  1237,   646,  1177,   759,
    1342,  1618, -1055,     7,     5, -1057,    13,   966,   760,     1,
    1436,   664,   893,  1439,     9,  1178,   625,   627,   628,   629,
     630,   631,   632,   633,   634,   635,  1389,   874,   894,   895,
     877,   775,   776,   777,   821,   898,   901,   826,  1267,  1268,
     785,  1401,   787,   811,   812,   813,   814,   815,   816,   817,
    1719,  1720,  1151,  1300,  1301,  1302,   590,   904,   914,   906,
    1204,  1106,   899,   908,  1534,   592,   788,   789,   401,   794,
     795,   796,   596,   742,   743,   617,   745,   622,  1159,  1166,
     749,  1416,  1417,   752,   920,  1174,   624,   665,   753,   755,
     773,   805,  1374,   819,   780,  1503,   933,   808,   822,   824,
     827,   831,   829,  1146,   834,   837,   838,   848,   851,   855,
     857,   859,   862,   798,   799,   864,   867,   874,   877,   767,
    1190,   880,   770,   884,   887,   759,  1438,   791,   937,  1185,
    1449,   939,   902,   940,   928,   941,  1684,  1673,   944,   766,
    1131,   889,   949,   760,   912,   945,   951,   953,   955,   400,
     962,  1081,  1086,  1098,  1101,   964,  1116,  1103,  1112,  1497,
    1114,   968,  1122,   970,  1120,  1124,  1066,  1170,  1067,  1430,
    1168,  1070,  1132,  1134,  1136,  1140,  1142,  1138,  1160,  1162,
    1186,  1224,  1147,  1209,  1082,  1227,  1194,  1247,  1085,  -624,
    1250,  1089,  1243,  1091,  1284,  1286,  1289,  1291,  1295,  1298,
    1313,  1304,  1315,  1321,  1319,  1332,  1268,  1309,  1347,  1363,
    1360,  1382,  1329,  1376,  1330,  1394,  1107,  1129,  1414,  -921,
    1431,  1412,  1433,  1398,  1418,  1425,  1458,  1400,  1465,  1461,
    1441,  1326,  1127,  1478,  1204,  1485,  1498,  1487,  1472,  1492,
    1506,  1508,  1514,  1523,  1659,  1662,  1191,  1528,  1481,  1532,
    1406,  1666,  1668,  1623,  1685,  1201,  1690,  1692,  1172,  1149,
    1700,  1625,  1702,  1714,  1707,  1627,  1156,     8,  1184,  1352,
    1670,  1709,  1351,  1155,  1716,  1341,  1220,  1446,   645,   911,
    1409,  1077,  1078,  1447,  1679,  1198,  1631,  1632,  1633,  1634,
    1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,
    1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,
    1655,  1656,  1657,  1688,   959,   833,   891,  1111,  1297,   588,
    1538,  1345,   934,  1467,  1689,  1375,  1460,  1527,  1331,  1687,
    1664,  1537,  1699,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1349,     0,     0,     0,  1165,     0,     0,  1167,  1536,  1340,
    1173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1182,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1193,     0,  1196,  1176,     0,     0,     0,     0,     0,
    1183,     0,  1452,     0,     0,  1211,     0,     0,     0,  1324,
       0,     0,  1197,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1213,     0,  1215,     0,
    1216,     0,     0,     0,     0,     0,  1219,     0,     0,     0,
       0,     0,     0,  1353,     0,     0,     0,     0,  1229,     0,
    1231,  1359,  1232,     0,  1234,  1336,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1371,     0,     0,     0,
       0,     0,     0,     0,  1255,     0,  1257,     0,     0,     0,
       0,     0,  1263,     0,     0,     0,     0,     0,     0,     0,
       0,  1273,  1274,     0,  1386,     0,     0,  1245,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,  1288,     0,     0,
       0,     0,  1407,  1293,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1307,     0,
       0,  1311,     0,     0,  1427,     0,     0,     0,     0,     0,
    1317,  1318,     0,     0,     0,     0,     0,  1323,  1339,     0,
       0,     0,     0,     0,  1327,     0,     0,  1519,     0,     0,
       0,     0,     0,  1350,     0,     0,     0,     0,  1354,     0,
    1455,  1343,  1344,   642,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1469,   892,     0,     0,     0,  1355,     0,
    1357,     0,   667,     0,     0,     0,     0,     0,     0,  1365,
    1482,  1483,  1366,     0,     0,     0,   681,   682,   683,   684,
     685,   686,     0,     0,   689,     0,     0,  1378,     0,  1379,
       0,     0,   697,     0,     0,     0,     0,     0,   703,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   722,   723,   724,
     725,  1397,   727,   728,   729,     0,     0,   732,   733,   734,
    1525,     0,     0,     0,   739,     0,  1530,  1410,     0,     0,
       0,   746,   747,     0,     0,     0,   751,  1437,     0,     0,
    1423,     0,     0,     0,     0,   768,   769,     0,   771,     0,
       0,     0,     0,     0,     0,     0,     0,   782,  1440,   784,
       0,   786,  1443,     0,  1445,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   800,     0,  1453,     0,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1463,
       0,     0,     0,     0,     0,     0,     0,  1471,     0,     0,
       0,     0,     0,     0,     0,  1477,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1489,     0,     0,  1491,     0,     0,     0,  1494,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,     0,
       0,     0,  1505,     0,     0,     0,     0,     0,     0,  1510,
       0,  1512,     0,     0,     0,     0,  1516,     0,   636,   636,
     640,   640,   643,   643,   636,   647,   648,     0,     0,     0,
       0,   657,   658,     0,   660,   661,     0,   663,   636,     0,
     640,  1384,  1674,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1621,     0,   640,   640,   640,   640,   640,   640,
       0,     0,   640,     0,     0,     0,     0,     0,     0,     0,
     640,     0,     0,     0,     0,     0,   640,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1722,  1723,   640,     0,   640,   640,   640,   640,   726,
     640,   640,   640,     0,     0,   640,   640,   640,     0,     0,
       0,     0,   640,     0,     0,     0,     0,     0,     0,   640,
     640,   748,     0,   750,   640,     0,     0,     0,     0,     0,
       0,     0,     0,   640,   640,     0,   640,   772,     0,     0,
       0,     0,   778,   779,     0,   640,   783,   640,     0,   640,
       0,     0,     0,     0,   636,     0,     0,     0,     0,     0,
       0,     0,   640,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1672,     0,     0,  1675,     0,     0,     0,
    1680,     0,  1682,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1694,
       0,     0,     0,     0,  1697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1705,     0,     0,     0,     0,     0,
       0,  1711,     0,     0,     0,     0,     0,     0,  1718,     0,
    1199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1241,     0,     0,     0,
       0,     0,  1246,     0,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,     0,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,     0,   173,   174,   175,   176,
    1381,   177,     0,     0,   178,     0,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,     0,     0,     0,
     972,   973,     0,     0,     0,     0,     0,     0,     0,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     668,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,     0,     0,     0,     0,     0,     0,   687,
     688,   190,   690,   691,   692,   693,   694,   695,   696,     0,
     698,   699,   700,   701,   702,     0,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,     0,   721,     0,     0,     0,     0,     0,     0,
       0,     0,   730,   731,     0,     0,     0,   735,   736,   737,
     738,     0,   740,   741,     0,     0,   744,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   757,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,     0,     0,     0,   797,     0,
       0,     0,   801,   802,   803,     0,     0,   974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   972,   973,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   975,   191,     0,     0,   192,   193,     0,     0,     0,
       0,     0,     0,   194,   195,   196,   197,     0,     0,     0,
     198,   199,   200,     0,  1252,     0,   976,   977,   978,     0,
       0,     0,   201,   202,   203,   204,   205,  1253,     0,   979,
       0,     0,     0,     0,     0,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,     0,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,
    1014,  1015,  1016,     0,     0,     0,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,   974,   972,   973,     0,     0,     0,     0,     0,
       0,     0,  1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   859,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   979,     0,     0,     0,     0,     0,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,     0,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,     0,     0,
     974,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,  1058,  1059,  1060,  1061,  1062,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1063,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   834,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   979,     0,     0,     0,     0,     0,   980,   981,
     982,   983,   984,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,     0,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,     0,     0,     0,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,
    1563,  1564,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,
    1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,
    1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,
    1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,
    1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,
    1613,  1614,  1615,  1616
};

static const yytype_int16 yycheck[] =
{
       1,   617,   429,   761,   589,   773,   622,   866,   624,   643,
     745,   950,    13,  1093,   873,   861,   650,   927,   652,   844,
    1128,   629,   449,     5,   658,   659,     5,   965,  1164,  1258,
     209,   878,   748,  1476,   246,   916,  1222,   426,   427,   428,
     849,   922,   923,   194,  1499,   251,  1501,   239,   196,     6,
     212,   819,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     254,   455,   441,  1373,   458,  1261,   268,   446,   242,   211,
    1266,  1524,   411,     0,     4,   414,     7,   855,   220,     6,
    1390,   460,   726,  1393,     3,   259,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,  1335,   411,   742,   743,
     414,   561,   562,   563,   600,   749,   750,   603,   412,   413,
     570,   305,   572,   399,   400,   401,   402,   403,   404,   405,
     240,   241,   957,   236,   237,   238,   244,   753,   772,   755,
     346,   909,   304,   759,   295,   197,   573,   574,   296,   578,
     579,   580,   225,   537,   538,   192,   540,   192,   967,  1069,
     544,  1369,  1370,   547,   780,  1075,   191,   193,   253,   250,
     350,     3,  1308,   206,   281,  1475,   810,     5,   299,   218,
     223,   200,   224,   951,   284,   301,   200,   296,   256,   283,
     205,   242,   221,   582,   583,   212,   212,   411,   414,   554,
    1280,   258,   557,   216,   260,   211,  1392,   576,   824,  1090,
     422,   827,   305,   829,   209,   831,  1671,  1660,   834,   553,
     936,   231,   838,   220,   270,   398,   204,   297,   233,   196,
     222,  1078,   195,   232,   265,   851,   210,   255,   278,  1468,
     278,   857,   328,   859,   298,   213,   862,  1072,   864,  1385,
     429,   867,   299,   201,   219,   285,   228,   223,   198,   198,
     194,   217,   226,   271,   880,   207,   262,   351,   884,   212,
     433,   887,   234,   889,   263,   421,   252,   247,   276,   282,
     257,   214,   273,   227,   308,   199,   413,   299,   259,   272,
     245,   298,   303,   208,   303,   415,   912,   931,   239,   212,
     203,   276,   435,   264,   215,   274,   202,   254,   231,   269,
     416,  1249,   928,   266,   346,   427,   302,   428,   230,   229,
     304,   423,   199,   441,   249,   429,  1094,   432,   310,   349,
     309,   195,   248,   287,   431,  1103,   407,   286,  1073,   955,
     430,   300,   288,   434,   433,   303,   962,     2,  1088,  1280,
     302,   289,  1279,   961,   291,  1265,  1124,  1402,   445,   762,
    1361,   875,   875,  1403,  1665,  1100,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,  1678,   846,   610,   663,   917,  1214,   400,
    1520,  1269,   818,  1429,  1678,  1310,  1422,  1511,  1254,  1677,
    1622,  1519,  1695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1276,    -1,    -1,    -1,  1068,    -1,    -1,  1071,  1518,  1264,
    1074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1095,    -1,  1097,  1080,    -1,    -1,    -1,    -1,    -1,
    1086,    -1,  1411,    -1,    -1,  1109,    -1,    -1,    -1,  1247,
      -1,    -1,  1098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1112,    -1,  1114,    -1,
    1116,    -1,    -1,    -1,    -1,    -1,  1122,    -1,    -1,    -1,
      -1,    -1,    -1,  1281,    -1,    -1,    -1,    -1,  1134,    -1,
    1136,  1289,  1138,    -1,  1140,  1260,  1142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1160,    -1,  1162,    -1,    -1,    -1,
      -1,    -1,  1168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1177,  1178,    -1,  1332,    -1,    -1,  1152,    -1,    -1,
    1186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1203,    -1,    -1,
      -1,    -1,  1360,  1209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,    -1,
      -1,  1227,    -1,    -1,  1382,    -1,    -1,    -1,    -1,    -1,
    1236,  1237,    -1,    -1,    -1,    -1,    -1,  1243,  1262,    -1,
      -1,    -1,    -1,    -1,  1250,    -1,    -1,  1496,    -1,    -1,
      -1,    -1,    -1,  1277,    -1,    -1,    -1,    -1,  1282,    -1,
    1418,  1267,  1268,   443,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1431,   665,    -1,    -1,    -1,  1284,    -1,
    1286,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,  1295,
    1448,  1449,  1298,    -1,    -1,    -1,   476,   477,   478,   479,
     480,   481,    -1,    -1,   484,    -1,    -1,  1313,    -1,  1315,
      -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,   498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   515,    -1,   517,   518,   519,
     520,  1347,   522,   523,   524,    -1,    -1,   527,   528,   529,
    1508,    -1,    -1,    -1,   534,    -1,  1514,  1363,    -1,    -1,
      -1,   541,   542,    -1,    -1,    -1,   546,  1391,    -1,    -1,
    1376,    -1,    -1,    -1,    -1,   555,   556,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   567,  1394,   569,
      -1,   571,  1398,    -1,  1400,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   584,    -1,  1412,    -1,  1414,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1441,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1458,    -1,    -1,  1461,    -1,    -1,    -1,  1465,
      -1,    -1,    -1,    -1,    -1,    -1,  1472,    -1,    -1,    -1,
      -1,    -1,  1478,    -1,    -1,    -1,    -1,    -1,    -1,  1485,
      -1,  1487,    -1,    -1,    -1,    -1,  1492,    -1,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,    -1,
      -1,   453,   454,    -1,   456,   457,    -1,   459,   460,    -1,
     462,  1328,  1660,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1528,    -1,   476,   477,   478,   479,   480,   481,
      -1,    -1,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,    -1,    -1,    -1,    -1,    -1,   498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1719,  1720,   515,    -1,   517,   518,   519,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,    -1,    -1,
      -1,    -1,   534,    -1,    -1,    -1,    -1,    -1,    -1,   541,
     542,   543,    -1,   545,   546,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   555,   556,    -1,   558,   559,    -1,    -1,
      -1,    -1,   564,   565,    -1,   567,   568,   569,    -1,   571,
      -1,    -1,    -1,    -1,   576,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1659,    -1,    -1,  1662,    -1,    -1,    -1,
    1666,    -1,  1668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1685,
      -1,    -1,    -1,    -1,  1690,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1700,    -1,    -1,    -1,    -1,    -1,
      -1,  1707,    -1,    -1,    -1,    -1,    -1,    -1,  1714,    -1,
    1101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1147,    -1,    -1,    -1,
      -1,    -1,  1153,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    -1,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,   173,
    1321,   175,    -1,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,    -1,
      56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   452,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,    -1,    -1,    -1,    -1,    -1,    -1,   482,
     483,   235,   485,   486,   487,   488,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,    -1,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,   530,   531,   532,
     533,    -1,   535,   536,    -1,    -1,   539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   550,   551,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   575,    -1,    -1,    -1,    -1,    -1,   581,    -1,
      -1,    -1,   585,   586,   587,    -1,    -1,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   267,   406,    -1,    -1,   409,   410,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,   419,   420,    -1,    -1,    -1,
     424,   425,   426,    -1,   290,    -1,   292,   293,   294,    -1,
      -1,    -1,   436,   437,   438,   439,   440,   303,    -1,   305,
      -1,    -1,    -1,    -1,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,    -1,    -1,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   203,    56,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   292,   293,   294,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   305,    -1,    -1,    -1,    -1,    -1,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,    -1,
     203,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,
      -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   284,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   292,
     293,   294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   305,    -1,    -1,    -1,    -1,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,    -1,    -1,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     6,   548,   549,   550,     4,  1296,     0,   549,     3,
     552,   551,   553,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   170,   171,   172,   173,   175,   178,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     235,   406,   409,   410,   417,   418,   419,   420,   424,   425,
     426,   436,   437,   438,   439,   440,   554,   563,   569,   571,
     577,   585,   587,   590,   596,   603,   607,   609,   611,   614,
     616,   618,   620,   622,   624,   626,   628,   630,   633,   639,
     644,   646,   648,   658,   666,   668,   674,   676,   678,   680,
     682,   684,   689,   695,   700,   702,   704,   706,   708,   710,
     712,   714,   716,   718,   720,   722,   724,   726,   728,   730,
     732,   734,   736,   738,   740,   742,   744,   746,   748,   750,
     752,   754,   756,   758,   760,   762,   764,   766,   768,   770,
     772,   774,   776,   778,   785,   787,   789,   791,   793,   795,
     797,   799,   801,   803,   805,   807,   809,   811,   813,   815,
     817,   819,   821,   823,   825,   827,   829,   831,   833,   835,
     837,   839,   841,   843,   845,   847,   849,   851,   853,   855,
     857,   859,   861,   863,   865,   867,   869,   871,   873,   875,
     877,   879,   881,   883,   885,   887,   890,   893,   895,   897,
     899,   901,   903,   905,   907,   914,   917,   922,   925,   934,
     937,   942,   948,   950,   952,   955,   957,   960,   963,   966,
     970,   971,   975,   978,   981,   983,   986,   987,   989,   991,
     995,   999,  1002,  1004,  1005,  1011,  1014,  1016,  1020,  1022,
    1025,  1032,  1040,  1043,  1045,  1047,  1052,  1057,  1059,  1061,
    1062,  1064,  1150,  1152,  1154,  1156,  1158,  1168,  1180,  1296,
     196,   296,  1195,   591,   915,  1015,   608,   634,   631,   615,
     617,   640,   610,   619,   645,   621,   647,   669,   649,   623,
     659,   667,   625,   572,   612,   588,   967,   996,   891,   604,
     564,   679,   681,   675,   597,   578,   685,   690,   683,   677,
     990,  1058,   761,   775,  1046,  1060,   896,   701,   703,  1006,
     808,   779,   810,   923,  1017,  1021,   586,   979,  1053,  1048,
     888,   723,   735,   788,   792,   794,   796,   812,   814,   816,
     798,   818,   820,   822,   824,   826,   737,   739,   741,   743,
     745,   725,   828,   830,   747,   832,   834,   836,   838,   840,
     842,   844,   846,   848,   850,   852,   802,   854,   727,   856,
     800,   786,   858,   806,   804,   860,   862,   864,   866,   868,
     870,   872,   874,   876,   878,   755,   880,   729,   721,   757,
     759,   938,   711,   731,   733,   982,   882,   749,   751,   753,
     884,   886,   964,   956,   715,   894,   898,   709,   707,  1023,
     705,   717,   719,  1000,   935,  1033,   713,  1026,   926,   961,
     988,  1003,   949,   696,   629,   763,   765,   627,   769,   943,
    1012,   972,   992,   953,   951,   906,   976,   767,   918,   771,
     908,   773,   984,  1044,  1041,  1063,  1065,  1151,  1153,  1155,
    1157,   790,  1169,  1159,   777,   900,   902,   904,  1296,   570,
     244,  1260,   197,  1228,  1296,  1298,   225,  1094,  1101,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,   192,  1198,  1198,
    1198,  1198,   192,  1239,   191,  1073,  1238,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1084,  1107,  1239,  1107,
    1084,  1104,  1104,  1084,  1110,  1110,  1107,  1084,  1084,  1239,
    1084,  1105,  1089,  1133,  1134,  1135,  1105,  1084,  1084,  1089,
    1084,  1084,  1089,  1084,  1107,   193,  1115,  1104,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1104,  1104,  1104,  1104,  1104,  1104,  1105,  1105,  1104,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1104,  1105,  1105,
    1105,  1105,  1105,  1104,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1104,  1105,  1104,  1104,  1104,  1104,  1084,  1104,  1104,  1104,
    1105,  1105,  1104,  1104,  1104,  1105,  1105,  1105,  1105,  1104,
    1105,  1105,  1089,  1089,  1105,  1089,  1104,  1104,  1084,  1089,
    1084,  1104,  1089,   253,  1213,   250,  1212,  1105,  1105,   211,
     220,   945,   946,   947,  1126,  1185,  1073,  1094,  1104,  1104,
    1094,  1104,  1084,   350,  1230,  1230,  1230,  1230,  1084,  1084,
     281,  1220,  1104,  1084,  1104,  1230,  1104,  1230,  1239,  1239,
    1105,  1107,  1073,  1148,  1148,  1148,  1148,  1105,  1198,  1198,
    1104,  1105,  1105,  1105,  1228,     3,  1295,   592,     5,  1297,
     916,   399,   400,   401,   402,   403,   404,   405,  1095,   206,
    1226,  1226,   299,   613,   218,  1203,  1226,   223,  1204,   224,
    1205,   200,  1247,  1203,   284,   656,  1222,   301,   200,  1202,
    1295,   589,   968,   997,   892,  1295,   605,  1295,   296,   558,
    1074,   256,  1262,   672,  1222,   283,  1278,   205,  1246,   242,
    1259,  1102,   221,  1252,   212,  1194,  1085,   212,  1250,  1194,
    1007,  1194,  1194,  1090,   411,  1136,  1137,   414,  1141,  1143,
     258,  1214,  1194,  1194,   216,   583,  1190,   260,  1265,   231,
    1206,  1206,  1296,  1194,  1194,  1194,  1250,  1298,  1194,   304,
    1030,  1194,   305,  1024,  1295,   927,  1295,   962,  1295,  1127,
    1185,  1126,   270,  1267,  1194,  1297,  1013,   973,   993,   954,
    1295,   977,   909,   985,  1042,  1149,  1170,  1160,   209,  1193,
    1261,   912,   913,  1194,  1238,  1297,   635,  1295,   641,  1295,
    1295,  1295,   670,   650,  1295,   398,   651,   657,   664,  1295,
     573,   204,  1227,   297,   965,   233,  1208,   889,  1193,  1195,
     559,  1102,   222,  1253,  1295,   673,  1297,   598,  1295,   579,
    1295,   686,    56,    57,   203,   267,   292,   293,   294,   305,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   408,  1103,  1259,  1295,  1295,  1108,  1115,
    1295,  1111,  1008,  1106,   780,  1115,  1138,  1137,  1141,  1142,
    1144,  1143,  1295,   924,  1018,  1295,   195,  1199,   584,  1295,
     980,  1295,  1054,  1049,  1116,   939,  1001,   936,   232,  1207,
    1031,   265,  1217,   255,  1224,   958,  1297,  1295,   697,   944,
    1199,  1214,   278,  1219,   278,  1273,   210,  1243,  1199,  1199,
     298,  1039,   328,  1233,   213,  1181,  1181,  1295,   593,  1194,
    1096,  1298,   299,   638,   201,  1245,   219,  1251,   223,  1254,
     285,  1223,   228,   665,  1191,  1245,  1297,   226,  1196,  1295,
     998,  1193,   606,   560,   561,  1222,  1295,  1075,  1223,  1102,
     198,  1242,   198,  1200,   691,  1194,  1181,  1194,   429,  1009,
    1193,  1237,  1250,  1194,  1181,  1139,  1295,   242,   259,   919,
    1211,  1215,  1194,  1295,   583,  1199,   194,  1055,  1189,  1050,
    1189,  1297,   940,  1194,   262,  1216,  1194,  1295,  1250,  1296,
    1027,  1297,   928,   251,   346,   959,  1069,  1186,  1128,   271,
    1268,  1194,   974,  1295,   994,  1295,  1295,   910,  1034,  1295,
    1297,  1171,  1161,  1243,   217,  1249,   636,   207,  1279,  1295,
     671,  1295,  1295,   660,  1295,  1295,   239,   268,  1192,  1258,
     574,  1296,   969,   234,  1209,  1228,  1296,   351,  1277,   562,
     433,  1291,   290,   303,   594,  1295,   580,  1295,   687,  1242,
    1109,  1086,  1112,  1295,  1010,   781,  1091,   412,   413,  1140,
    1231,  1234,  1145,  1295,  1295,   920,   921,  1019,  1295,  1056,
    1051,  1117,   941,  1295,   263,  1281,   421,  1283,  1295,   252,
    1188,   247,  1118,  1295,   698,   276,  1218,  1218,   282,  1221,
     236,   237,   238,  1035,   214,  1182,  1182,  1295,  1097,   299,
     632,  1295,   642,   257,  1263,   273,  1270,  1295,  1295,   308,
     575,   227,  1197,  1295,  1297,   565,  1223,  1295,  1076,   303,
     303,  1259,   199,  1225,  1225,   692,  1250,  1182,  1113,  1194,
    1193,  1181,  1182,  1295,  1295,  1234,  1147,   259,  1264,  1259,
    1194,  1055,  1050,  1297,  1194,  1295,  1028,  1295,   929,  1297,
     245,  1119,  1131,   272,  1269,  1295,  1295,   911,  1036,  1037,
    1038,  1297,  1172,  1162,  1242,  1279,   208,  1280,  1295,  1295,
     661,  1296,   298,  1276,  1239,   599,  1297,   581,   688,  1225,
    1087,  1114,   782,  1092,   415,  1146,  1232,  1295,   264,  1282,
     254,   305,   931,   932,   933,  1187,   309,  1297,  1120,  1131,
    1295,   699,   276,  1272,   239,  1210,  1210,  1210,   215,  1183,
    1183,  1098,   637,  1295,   643,   274,  1271,  1297,   566,  1077,
    1242,   203,  1229,   435,  1292,   693,  1183,  1194,  1182,  1183,
    1295,   416,  1235,  1295,  1029,  1295,  1069,  1187,   246,   422,
    1132,  1284,  1245,  1295,  1295,  1297,  1173,  1163,   202,  1248,
    1280,   269,  1201,  1295,   662,   231,  1257,  1248,   600,  1297,
     582,  1295,   230,  1256,  1088,   783,  1093,  1295,   266,  1266,
     930,   310,  1297,  1297,  1129,   427,  1286,   428,  1287,  1295,
    1099,  1295,   229,  1255,  1295,   567,  1078,  1225,   302,   576,
    1295,   694,  1123,  1183,  1123,  1295,   304,  1070,   423,  1285,
    1295,  1174,  1295,  1164,   199,  1275,  1295,   663,   557,  1115,
     601,  1292,  1292,   441,   784,  1297,  1130,  1287,   432,  1289,
    1297,  1100,   349,   652,   295,   556,  1189,  1243,  1229,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,  1124,  1123,  1121,
    1175,  1295,  1165,   287,  1068,   300,   653,   303,   555,  1079,
     602,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,  1125,   249,
    1122,  1184,   429,  1293,  1293,   654,   195,  1240,   248,  1244,
     302,   595,  1295,  1123,  1185,  1295,  1176,  1166,   655,  1191,
    1295,   568,  1295,  1080,  1292,   431,  1288,  1288,  1192,  1258,
     407,  1241,   286,  1067,  1295,  1177,  1167,  1295,  1081,  1289,
     430,  1294,   288,  1071,  1178,  1295,  1082,   433,  1236,   289,
    1072,  1295,  1179,  1083,   434,  1290,   291,  1066,  1295,   240,
     241,  1274,  1297,  1297
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (data, lexer, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, lexer)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, data, lexer); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, bison_parser_data &data, treeFlexLexer& lexer)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, data, lexer)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    bison_parser_data &data;
    treeFlexLexer& lexer;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (data);
  YYUSE (lexer);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, bison_parser_data &data, treeFlexLexer& lexer)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, data, lexer)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    bison_parser_data &data;
    treeFlexLexer& lexer;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, data, lexer);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, bison_parser_data &data, treeFlexLexer& lexer)
#else
static void
yy_reduce_print (yyvsp, yyrule, data, lexer)
    YYSTYPE *yyvsp;
    int yyrule;
    bison_parser_data &data;
    treeFlexLexer& lexer;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , data, lexer);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, data, lexer); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, bison_parser_data &data, treeFlexLexer& lexer)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, data, lexer)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    bison_parser_data &data;
    treeFlexLexer& lexer;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (data);
  YYUSE (lexer);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (bison_parser_data &data, treeFlexLexer& lexer);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (bison_parser_data &data, treeFlexLexer& lexer)
#else
int
yyparse (data, lexer)
    bison_parser_data &data;
    treeFlexLexer& lexer;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

    {data.gcc_version = data.curr_string;}
    break;

  case 7:

    {
                GccWrapper::CheckGccCompatibleVersion(data.gcc_version, data.curr_string);
                if(data.final_TM)
                   data.final_TM->merge_tree_managers(data.current_TM);
                else if(data.current_TM)
                   data.final_TM = data.current_TM;
                data.current_TM = tree_managerRef(new tree_manager(data.Param));
             }
    break;

  case 8:

    {data.curr_NODE_ID=data.id=(yyvsp[(1) - (1)].value);}
    break;

  case 9:

    {do_node(data.curr_tree_nodeRef, data.id, data.current_TM); data.curr_tree_nodeRef=tree_nodeRef();}
    break;

  case 203:

    {NSV(function_decl, static_flag, true)}
    break;

  case 205:

    {NSV(function_decl, undefined_flag, true)}
    break;

  case 207:

    {ADDV(function_decl,AddArg)}
    break;

  case 209:

    {NSV(function_decl, operator_flag, true)}
    break;

  case 212:

    {ADD_OP_NAME(data.curr_string)}
    break;

  case 214:

    {NS(function_decl,tmpl_parms)}
    break;

  case 215:

    {NS(function_decl,tmpl_args)}
    break;

  case 216:

    {CTN(function_decl) do_fun_decl(data.implement_node, data.curr_NODE_ID_BIS, data.curr_NODE_ID, data, data.current_TM);}
    break;

  case 217:

    {OPT((yyvsp[(7) - (7)].pred), {NSV(function_decl,fixd,data.curr_number); NSV(function_decl,fixd_flag,true)})}
    break;

  case 218:

    {OPT((yyvsp[(9) - (9)].pred), {NSV(function_decl,virt,data.curr_number); NSV(function_decl,virt_flag,true)})}
    break;

  case 219:

    {OPT((yyvsp[(11) - (11)].pred), NS(function_decl,fn))}
    break;

  case 220:

    {OPT((yyvsp[(16) - (16)].pred), NS(function_decl,body))}
    break;

  case 221:

    {OPT((yyvsp[(18) - (18)].pred), NS(function_decl,inline_body))}
    break;

  case 222:

    {CTN_ID(data.curr_string)}
    break;

  case 224:

    {CTN_ID(true)}
    break;

  case 225:

    {CTN(function_type)}
    break;

  case 226:

    {NS(function_type, retn)}
    break;

  case 227:

    {OPT((yyvsp[(6) - (6)].pred), NS(function_type, prms))}
    break;

  case 230:

    {

                    NSV(function_type, varargs_flag, true);
                 }
    break;

  case 232:

    {NSV(parm_decl,register_flag, true)}
    break;

  case 233:

    {CTN(parm_decl)}
    break;

  case 234:

    {OPT((yyvsp[(4) - (4)].pred), NS(parm_decl, argt))}
    break;

  case 235:

    {OPT((yyvsp[(6) - (6)].pred), NS(parm_decl, size))}
    break;

  case 236:

    {NSV(parm_decl,algn, data.curr_unumber)}
    break;

  case 237:

    {NSV(parm_decl, used, data.curr_number)}
    break;

  case 238:

    {OPT((yyvsp[(13) - (13)].pred), NS(parm_decl, smt_ann))}
    break;

  case 240:

    {ADDV(gimple_bind,add_vars)}
    break;

  case 242:

    {CTN(gimple_bind)}
    break;

  case 243:

    {NS(gimple_bind,body)}
    break;

  case 244:

    {
                     CTN(integer_cst)
                  }
    break;

  case 245:

    {
                     NS(integer_cst,type)
                  }
    break;

  case 246:

    {
                    NSV(integer_cst, value, data.curr_long_long_number)
                  }
    break;

  case 247:

    {CTN(tree_list)}
    break;

  case 248:

    {OPT((yyvsp[(3) - (3)].pred), NS(tree_list, purp))}
    break;

  case 249:

    {OPT((yyvsp[(5) - (5)].pred), NS(tree_list, valu))}
    break;

  case 250:

    {OPT((yyvsp[(7) - (7)].pred), NS(tree_list, chan))}
    break;

  case 252:

    {NSV(var_decl,static_static_flag, true)}
    break;

  case 253:

    {NSV(var_decl,static_flag, true)}
    break;

  case 254:

    {NSV(var_decl,extern_flag, true)}
    break;

  case 255:

    {NSV(var_decl,extern_flag, true)NSV(var_decl,static_flag, true)}
    break;

  case 257:

    {NSV(var_decl,register_flag, true)}
    break;

  case 258:

    {CTN(var_decl)}
    break;

  case 259:

    {OPT((yyvsp[(4) - (4)].pred), {NSV(var_decl,use_tmpl,data.curr_number)})}
    break;

  case 260:

    {OPT((yyvsp[(8) - (8)].pred), NS(var_decl, init))}
    break;

  case 261:

    {OPT((yyvsp[(10) - (10)].pred), NS(var_decl, size))}
    break;

  case 262:

    {NSV(var_decl,algn, data.curr_unumber)}
    break;

  case 263:

    {NSV(var_decl, used, data.curr_number)}
    break;

  case 264:

    {OPT((yyvsp[(17) - (17)].pred), NS(var_decl, smt_ann))}
    break;

  case 265:

    {CTN(string_cst)}
    break;

  case 266:

    {OPT((yyvsp[(3) - (3)].pred), NS(string_cst,type))}
    break;

  case 267:

    {NSV(string_cst, strg, data.curr_string)}
    break;

  case 268:

    {NSV(string_cst, lngt, data.curr_number)}
    break;

  case 269:

    {CTN(void_type)}
    break;

  case 271:

    {CTN(boolean_type)}
    break;

  case 273:

    {CTN(lang_type)}
    break;

  case 276:

    {NSV(complex_type, unsigned_flag, true)}
    break;

  case 277:

    {CTN(complex_type)}
    break;

  case 279:

    {CTN(vector_type)}
    break;

  case 280:

    {NS(vector_type, elts)}
    break;

  case 281:

    {CTN(CharType)}
    break;

  case 283:

    {CTN(offset_type)}
    break;

  case 285:

    {CTN(set_type)}
    break;

  case 287:

    {CTN(qual_union_type)}
    break;

  case 289:

    {CTN(typename_type)}
    break;

  case 291:

    {CTN(template_type_parm)}
    break;

  case 293:

    {CTN(real_type)}
    break;

  case 294:

    {NSV(real_type, prec, data.curr_unumber)}
    break;

  case 296:

    {NSV(integer_type, unsigned_flag, true)}
    break;

  case 297:

    {CTN(integer_type)}
    break;

  case 298:

    {NSV(integer_type, prec, data.curr_unumber)}
    break;

  case 299:

    {OPT((yyvsp[(6) - (6)].pred), NSV(integer_type, str, data.curr_string))}
    break;

  case 300:

    {OPT((yyvsp[(9) - (9)].pred), NS(integer_type,min))}
    break;

  case 301:

    {OPT((yyvsp[(11) - (11)].pred), NS(integer_type,max))}
    break;

  case 303:

    {NSV(enumeral_type, unsigned_flag, true)}
    break;

  case 304:

    {CTN(enumeral_type)}
    break;

  case 305:

    {NSV(enumeral_type, prec, data.curr_unumber)}
    break;

  case 306:

    {OPT((yyvsp[(7) - (7)].pred),NS(enumeral_type,min))}
    break;

  case 307:

    {OPT((yyvsp[(9) - (9)].pred), NS(enumeral_type,max))}
    break;

  case 308:

    {NS(enumeral_type,csts)}
    break;

  case 309:

    {CTN(pointer_type)}
    break;

  case 310:

    {NS(pointer_type, ptd)}
    break;

  case 311:

    {CTN(reference_type)}
    break;

  case 312:

    {NS(reference_type, refd)}
    break;

  case 313:

    {CTN(array_type)}
    break;

  case 314:

    {NS(array_type, elts)}
    break;

  case 315:

    {OPT((yyvsp[(6) - (6)].pred), NS(array_type, domn))}
    break;

  case 317:

    {NSV(record_type, ptrmem_flag, true)}
    break;

  case 319:

    {NSV(record_type, spec_flag, true)}
    break;

  case 321:

    {NSV(record_type, struct_flag, true)}
    break;

  case 323:

    {ADDV(record_type, add_flds)}
    break;

  case 325:

    {ADDV(record_type, add_fncs)}
    break;

  case 327:

    {NS(record_type,tmpl_parms)}
    break;

  case 328:

    {NS(record_type,tmpl_args)}
    break;

  case 329:

    {CTN(record_type)}
    break;

  case 330:

    {OPT((yyvsp[(6) - (6)].pred), NS(record_type, ptd))}
    break;

  case 331:

    {OPT((yyvsp[(8) - (8)].pred), NS(record_type, cls))}
    break;

  case 332:

    {OPT((yyvsp[(10) - (10)].pred), NS(record_type, bfld))}
    break;

  case 333:

    {OPT((yyvsp[(12) - (12)].pred), NS(record_type, vfld))}
    break;

  case 334:

    {OPT((yyvsp[(18) - (18)].pred), NS(record_type, binf))}
    break;

  case 336:

    {ADDV(union_type, add_flds)}
    break;

  case 338:

    {ADDV(union_type, add_fncs)}
    break;

  case 339:

    {CTN(union_type)}
    break;

  case 340:

    {OPT((yyvsp[(7) - (7)].pred), NS(union_type, binf))}
    break;

  case 341:

    {CTN(method_type)}
    break;

  case 342:

    {OPT((yyvsp[(4) - (4)].pred), NS(method_type, retn))}
    break;

  case 343:

    {OPT((yyvsp[(6) - (6)].pred), NS(method_type, prms))}
    break;

  case 344:

    {OPT((yyvsp[(8) - (8)].pred), NS(method_type, clas))}
    break;

  case 346:

    {NS(type_decl,tmpl_parms)}
    break;

  case 347:

    {NS(type_decl,tmpl_args)}
    break;

  case 348:

    {CTN(type_decl)}
    break;

  case 350:

    {CTN(translation_unit_decl)}
    break;

  case 352:

    {CTN(label_decl)}
    break;

  case 354:

    {CTN(const_decl)}
    break;

  case 355:

    {OPT((yyvsp[(4) - (4)].pred), NS(const_decl, cnst))}
    break;

  case 356:

    {CTN(namespace_decl)}
    break;

  case 357:

    {OPT((yyvsp[(4) - (4)].pred), NS(namespace_decl, dcls))}
    break;

  case 358:

    {CTN(result_decl)}
    break;

  case 359:

    {OPT((yyvsp[(4) - (4)].pred), NS(result_decl, init))}
    break;

  case 360:

    {NS(result_decl, size)}
    break;

  case 361:

    {NSV(result_decl,algn, data.curr_unumber)}
    break;

  case 362:

    {OPT((yyvsp[(10) - (10)].pred), NS(result_decl, smt_ann))}
    break;

  case 363:

    {CTN(field_decl)}
    break;

  case 364:

    {OPT((yyvsp[(5) - (5)].pred), NS(field_decl, init))}
    break;

  case 365:

    {OPT((yyvsp[(7) - (7)].pred), NS(field_decl, size))}
    break;

  case 366:

    {NSV(field_decl,algn, data.curr_unumber)}
    break;

  case 367:

    {OPT((yyvsp[(11) - (11)].pred), NS(field_decl, bpos))}
    break;

  case 368:

    {OPT((yyvsp[(13) - (13)].pred), NS(field_decl, smt_ann))}
    break;

  case 369:

    {CTN(template_decl)}
    break;

  case 370:

    {OPT((yyvsp[(4) - (4)].pred), NS(template_decl,rslt))}
    break;

  case 371:

    {OPT((yyvsp[(6) - (6)].pred), NS(template_decl,inst))}
    break;

  case 372:

    {OPT((yyvsp[(8) - (8)].pred), NS(template_decl,spcs))}
    break;

  case 373:

    {OPT((yyvsp[(10) - (10)].pred), NS(template_decl,prms))}
    break;

  case 374:

    {CTN(exc_ptr_expr)}
    break;

  case 376:

    {CTN(filter_expr)}
    break;

  case 378:

    {CTN(gimple_return)}
    break;

  case 379:

    {OPT((yyvsp[(4) - (4)].pred), NS(gimple_return,op))}
    break;

  case 380:

    {CTN(gimple_goto)}
    break;

  case 381:

    {NS(gimple_goto,op)}
    break;

  case 382:

    {CTN(gimple_label)}
    break;

  case 383:

    {NS(gimple_label,op)}
    break;

  case 384:

    {CTN(unsave_expr)}
    break;

  case 386:

    {CTN(gimple_resx)}
    break;

  case 388:

    {CTN(va_arg_expr)}
    break;

  case 390:

    {CTN(exit_expr)}
    break;

  case 392:

    {CTN(loop_expr)}
    break;

  case 394:

    {CTN(nop_expr)}
    break;

  case 396:

    {CTN(gimple_nop)}
    break;

  case 398:

    {CTN(negate_expr)}
    break;

  case 400:

    {CTN(truth_not_expr)}
    break;

  case 402:

    {CTN(convert_expr)}
    break;

  case 404:

    {CTN(addr_expr)}
    break;

  case 406:

    {CTN(reference_expr)}
    break;

  case 408:

    {CTN(cleanup_point_expr)}
    break;

  case 410:

    {CTN(fix_trunc_expr)}
    break;

  case 412:

    {CTN(fix_ceil_expr)}
    break;

  case 414:

    {CTN(fix_floor_expr)}
    break;

  case 416:

    {CTN(fix_round_expr)}
    break;

  case 418:

    {CTN(float_expr)}
    break;

  case 420:

    {CTN(abs_expr)}
    break;

  case 422:

    {CTN(conj_expr)}
    break;

  case 424:

    {CTN(realpart_expr)}
    break;

  case 426:

    {CTN(imagpart_expr)}
    break;

  case 428:

    {CTN(card_expr)}
    break;

  case 430:

    {CTN(non_lvalue_expr)}
    break;

  case 432:

    {CTN(view_convert_expr)}
    break;

  case 434:

    {CTN(indirect_ref)}
    break;

  case 436:

    {CTN(cast_expr)}
    break;

  case 438:

    {CTN(static_cast_expr)}
    break;

  case 440:

    {CTN(reinterpret_cast_expr)}
    break;

  case 442:

    {CTN(sizeof_expr)}
    break;

  case 444:

    {CTN(throw_expr)}
    break;

  case 446:

    {CTN(arrow_expr)}
    break;

  case 448:

    {CTN(buffer_ref)}
    break;

  case 450:

    {CTN(gimple_predict)}
    break;

  case 452:

    {
         CTN(gimple_assign)
      }
    break;

  case 453:

    {
         NS(gimple_assign,op0)
      }
    break;

  case 454:

    {
         NS(gimple_assign,op1)
      }
    break;

  case 455:

    {
#if defined(HAVE_MAPPING) && defined(HAVE_CODE_ESTIMATION_BUILT)
         std::map<ComponentTypeConstRef, ProbabilityDistribution> weights;
         if((data.Param->getOption<bool>(OPT_gcc_costs)))
         {
            weights[data.driving_component] = data.curr_double_number;
         }
         OPT((yyvsp[(8) - (8)].pred), GetPointer<gimple_assign>(data.curr_tree_nodeRef)->weight_information->recursive_weight = weights);
#endif
      }
    break;

  case 456:

    {
#if HAVE_CODE_ESTIMATION_BUILT
         OPT((yyvsp[(10) - (10)].pred), GetPointer<gimple_assign>(data.curr_tree_nodeRef)->weight_information->instruction_size = data.curr_unumber);
#endif
      }
    break;

  case 457:

    {
#if HAVE_RTL_BUILT
         OPT((yyvsp[(12) - (12)].pred), GetPointer<gimple_assign>(data.curr_tree_nodeRef)->weight_information->rtl_instruction_size = data.curr_number);
#endif
      }
    break;

  case 458:

    {
#if HAVE_RTL_BUILT
         GetPointer<WeightedNode>(data.curr_tree_nodeRef)->weight_information->rtl_nodes = data.rtls;
         data.rtls.clear();
#endif
      }
    break;

  case 459:

    {CTN(gt_expr)}
    break;

  case 461:

    {CTN(plus_expr)}
    break;

  case 463:

    {CTN(pointer_plus_expr)}
    break;

  case 465:

    {CTN(minus_expr)}
    break;

  case 467:

    {CTN(mult_expr)}
    break;

  case 469:

    {CTN(trunc_div_expr)}
    break;

  case 471:

    {CTN(trunc_mod_expr)}
    break;

  case 473:

    {CTN(le_expr)}
    break;

  case 475:

    {CTN(truth_or_expr)}
    break;

  case 477:

    {CTN(ne_expr)}
    break;

  case 479:

    {CTN(eq_expr)}
    break;

  case 481:

    {CTN(compound_expr)}
    break;

  case 483:

    {CTN(init_expr)}
    break;

  case 485:

    {CTN(ceil_div_expr)}
    break;

  case 487:

    {CTN(floor_div_expr)}
    break;

  case 489:

    {CTN(round_div_expr)}
    break;

  case 491:

    {CTN(ceil_mod_expr)}
    break;

  case 493:

    {CTN(floor_mod_expr)}
    break;

  case 495:

    {CTN(round_mod_expr)}
    break;

  case 497:

    {CTN(rdiv_expr)}
    break;

  case 499:

    {CTN(exact_div_expr)}
    break;

  case 501:

    {CTN(min_expr)}
    break;

  case 503:

    {CTN(max_expr)}
    break;

  case 505:

    {CTN(lshift_expr)}
    break;

  case 507:

    {CTN(rshift_expr)}
    break;

  case 509:

    {CTN(lrotate_expr)}
    break;

  case 511:

    {CTN(rrotate_expr)}
    break;

  case 513:

    {CTN(bit_ior_expr)}
    break;

  case 515:

    {CTN(bit_xor_expr)}
    break;

  case 517:

    {CTN(bit_and_expr)}
    break;

  case 519:

    {CTN(bit_not_expr)}
    break;

  case 521:

    {CTN(truth_andif_expr)}
    break;

  case 523:

    {CTN(truth_orif_expr)}
    break;

  case 525:

    {CTN(truth_and_expr)}
    break;

  case 527:

    {CTN(truth_xor_expr)}
    break;

  case 529:

    {CTN(lt_expr)}
    break;

  case 531:

    {CTN(ge_expr)}
    break;

  case 533:

    {CTN(unordered_expr)}
    break;

  case 535:

    {CTN(ordered_expr)}
    break;

  case 537:

    {CTN(unlt_expr)}
    break;

  case 539:

    {CTN(unle_expr)}
    break;

  case 541:

    {CTN(ungt_expr)}
    break;

  case 543:

    {CTN(unge_expr)}
    break;

  case 545:

    {CTN(uneq_expr)}
    break;

  case 547:

    {CTN(ltgt_expr)}
    break;

  case 549:

    {CTN(in_expr)}
    break;

  case 551:

    {CTN(set_le_expr)}
    break;

  case 553:

    {CTN(range_expr)}
    break;

  case 555:

    {CTN(complex_expr)}
    break;

  case 557:

    {CTN(predecrement_expr)}
    break;

  case 559:

    {CTN(preincrement_expr)}
    break;

  case 561:

    {CTN(with_cleanup_expr)}
    break;

  case 563:

    {ADDV(vector_cst, add_valu)}
    break;

  case 564:

    {ADDV(vector_cst, add_valu)}
    break;

  case 565:

    {CTN(vector_cst)}
    break;

  case 566:

    {NS(vector_cst,type)}
    break;

  case 568:

    {CTN(try_catch_expr)}
    break;

  case 570:

    {CTN(vtable_ref)}
    break;

  case 572:

    {CTN(try_finally)}
    break;

  case 574:

    {CTN(mem_ref)}
    break;

  case 576:

    {CTN(widen_sum_expr)}
    break;

  case 578:

    {CTN(widen_mult_expr)}
    break;

  case 580:

    {CTN(vec_new_expr)}
    break;

  case 582:

    {CTN(try_block)}
    break;

  case 583:

    {NSV(try_block,line,data.curr_number)}
    break;

  case 584:

    {NS(try_block,body)}
    break;

  case 585:

    {NS(try_block,hdlr)}
    break;

  case 586:

    {OPT((yyvsp[(9) - (9)].pred), NS(try_block,next))}
    break;

  case 587:

    {ADDV(tree_vec, add_op)}
    break;

  case 588:

    {ADDV(tree_vec, add_op)}
    break;

  case 591:

    {CTN(tree_vec)}
    break;

  case 592:

    {NSV(tree_vec, lngt, data.curr_size_t_number)}
    break;

  case 594:

    {CTN(template_id_expr)}
    break;

  case 597:

    {NS(target_expr,init1)}
    break;

  case 598:

    {OPT((yyvsp[(3) - (3)].pred), NS(target_expr,clnp))}
    break;

  case 599:

    {NS(target_expr,clnp)}
    break;

  case 600:

    {OPT((yyvsp[(3) - (3)].pred), NS(target_expr,init3))}
    break;

  case 601:

    {CTN(target_expr)}
    break;

  case 602:

    {NS(target_expr,decl)}
    break;

  case 604:

    {CTN(ssa_name)}
    break;

  case 605:

    {NS(ssa_name, var)}
    break;

  case 606:

    {NSV(ssa_name, vers, data.curr_unumber)}
    break;

  case 607:

    {OPT((yyvsp[(7) - (7)].pred), NS(ssa_name, ptr_info))}
    break;

  case 608:

    {OPT((yyvsp[(10) - (10)].pred), NSV(ssa_name, virtual_flag, true));}
    break;

  case 609:

    {OPT((yyvsp[(12) - (12)].pred), NSV(ssa_name, default_flag, true));}
    break;

  case 612:

    {ADDV(ssa_name, add_def)}
    break;

  case 613:

    {ADDV(ssa_name, add_def)}
    break;

  case 615:

    {NSV(ssa_name, volatile_flag, true)}
    break;

  case 616:

    {CTN(gimple_switch)}
    break;

  case 617:

    {NS(gimple_switch,op0)}
    break;

  case 618:

    {NS(gimple_switch,op1)}
    break;

  case 619:

    {CTN(save_expr)}
    break;

  case 620:

    {NS(ternary_expr,op0)}
    break;

  case 623:

    {NS(ternary_expr, op1)}
    break;

  case 624:

    {NS(ternary_expr, op1)}
    break;

  case 625:

    {NS(ternary_expr, op2)}
    break;

  case 626:

    {CTN(scope_ref)}
    break;

  case 627:

    {NS(scope_ref,op0)}
    break;

  case 628:

    {NS(scope_ref,op1)}
    break;

  case 629:

    {ADDV(statement_list, add_stmt)}
    break;

  case 630:

    {ADDV(statement_list, add_stmt)}
    break;

  case 631:

    {ADDB(statement_list, add_bloc,data.curr_blocRef)}
    break;

  case 632:

    {ADDB(statement_list, add_bloc,data.curr_blocRef)}
    break;

  case 636:

    {CTN(statement_list)}
    break;

  case 638:

    {CTN(new_expr)}
    break;

  case 640:

    {CTN(return_stmt)}
    break;

  case 641:

    {NSV(return_stmt,line,data.curr_number)}
    break;

  case 642:

    {OPT((yyvsp[(5) - (5)].pred), NS(return_stmt,expr))}
    break;

  case 643:

    {CTN(postincrement_expr)}
    break;

  case 645:

    {CTN(modop_expr)}
    break;

  case 648:

    {ADD_UNSIGNED(gimple_phi, add_def_edge)}
    break;

  case 649:

    {CTN(gimple_phi)}
    break;

  case 650:

    {NS(gimple_phi,res)}
    break;

  case 651:

    {OPT((yyvsp[(6) - (6)].pred), NSV(gimple_phi, virtual_flag, true));}
    break;

  case 652:

    {CTN(postdecrement_expr)}
    break;

  case 655:

    {NSV(real_cst, overflow_flag, true)}
    break;

  case 656:

    {CTN(real_cst)}
    break;

  case 657:

    {NS(real_cst,type)}
    break;

  case 658:

    {NSV(real_cst, valr,data.curr_string)}
    break;

  case 659:

    {NSV(real_cst, valx, data.curr_string)}
    break;

  case 660:

    {CTN(placeholder_expr)}
    break;

  case 661:

    {CTN(decl_stmt)}
    break;

  case 662:

    {NSV(decl_stmt,line,data.curr_number)}
    break;

  case 663:

    {NS(decl_stmt,decl)}
    break;

  case 664:

    {NS(decl_stmt,next)}
    break;

  case 665:

    {CTN(overload)}
    break;

  case 666:

    {NS(overload,crnt)}
    break;

  case 667:

    {OPT((yyvsp[(5) - (5)].pred), NS(overload,chan))}
    break;

  case 668:

    {CTN(labeled_block_expr)}
    break;

  case 669:

    {OPT((yyvsp[(4) - (4)].pred), NS(labeled_block_expr,lab))}
    break;

  case 670:

    {NS(labeled_block_expr,body)}
    break;

  case 671:

    {CTN(fdesc_expr)}
    break;

  case 673:

    {CTN(handler)}
    break;

  case 674:

    {NSV(handler,line,data.curr_number)}
    break;

  case 675:

    {NS(handler,body)}
    break;

  case 676:

    {CTN(error_mark)}
    break;

  case 677:

    {CTN(catch_expr)}
    break;

  case 679:

    {CTN(component_ref)}
    break;

  case 681:

    {CTN(expr_stmt)}
    break;

  case 682:

    {NSV(expr_stmt,line,data.curr_number)}
    break;

  case 683:

    {NS(expr_stmt,expr)}
    break;

  case 684:

    {NS(expr_stmt,next)}
    break;

  case 685:

    {CTN(complex_cst)}
    break;

  case 686:

    {NS(complex_cst,type)}
    break;

  case 687:

    {NS(complex_cst,real)}
    break;

  case 688:

    {NS(complex_cst,imag)}
    break;

  case 689:

    {CTN(exit_block_expr)}
    break;

  case 690:

    {OPT((yyvsp[(4) - (4)].pred), NSV(exit_block_expr, string_id, data.curr_string))}
    break;

  case 691:

    {NS(exit_block_expr,exit)}
    break;

  case 692:

    {CTN(eh_filter_expr)}
    break;

  case 694:

    {CTN(ctor_initializer)}
    break;

  case 695:

    {CTN(constructor)}
    break;

  case 696:

    {OPT((yyvsp[(3) - (3)].pred),NS(constructor,type))}
    break;

  case 700:

    {data.curr_NODE_ID_BIS=data.curr_NODE_ID;}
    break;

  case 701:

    {ADDV2(constructor, add_idx_valu)}
    break;

  case 702:

    {ADDV(constructor, add_valu)}
    break;

  case 703:

    {CTN(compound_stmt)}
    break;

  case 704:

    {NSV(compound_stmt,line,data.curr_number)}
    break;

  case 705:

    {NS(compound_stmt,body)}
    break;

  case 706:

    {CTN(block)}
    break;

  case 707:

    {OPT((yyvsp[(3) - (3)].pred), {NSV(block, bl, data.curr_string); NSV(block,bl_flag,true)})}
    break;

  case 708:

    {CTN(cond_expr)}
    break;

  case 709:

    {NS(cond_expr, op0)}
    break;

  case 710:

    {NS(cond_expr, op1)}
    break;

  case 711:

    {NS(cond_expr, op2)}
    break;

  case 712:

    {CTN(gimple_cond)}
    break;

  case 713:

    {NS(gimple_cond, op0)}
    break;

  case 714:

    {CTN(goto_subroutine)}
    break;

  case 717:

    {NSV(gimple_asm, volatile_flag, true)}
    break;

  case 718:

    {CTN(gimple_asm)}
    break;

  case 719:

    {NSV(gimple_asm,str,data.curr_string)}
    break;

  case 720:

    {OPT((yyvsp[(7) - (7)].pred), NS(gimple_asm,out))}
    break;

  case 721:

    {OPT((yyvsp[(9) - (9)].pred), NS(gimple_asm,in))}
    break;

  case 722:

    {OPT((yyvsp[(11) - (11)].pred), NS(gimple_asm,clob))}
    break;

  case 723:

    {NS(case_label_expr,op0)}
    break;

  case 724:

    {OPT((yyvsp[(3) - (3)].pred), NS(case_label_expr,op1))}
    break;

  case 725:

    {NSV(case_label_expr, default_flag, true)}
    break;

  case 726:

    {CTN(case_label_expr)}
    break;

  case 727:

    {NS(case_label_expr,got)}
    break;

  case 730:

    {data.curr_token_enum=lexer.bison2token(TOK_BISON_PUB); }
    break;

  case 731:

    {ADD_ACCESS_BINF(binfo, add_access_binf)}
    break;

  case 732:

    {data.curr_token_enum=lexer.bison2token(TOK_BISON_PROT);}
    break;

  case 733:

    {ADD_ACCESS_BINF(binfo, add_access_binf)}
    break;

  case 734:

    {data.curr_token_enum=lexer.bison2token(TOK_BISON_PRIV);}
    break;

  case 735:

    {ADD_ACCESS_BINF(binfo, add_access_binf)}
    break;

  case 737:

    {NSV(binfo, virt_flag, true)}
    break;

  case 738:

    {CTN(binfo)}
    break;

  case 739:

    {OPT((yyvsp[(3) - (3)].pred), NS(binfo,type))}
    break;

  case 741:

    {CTN(baselink)}
    break;

  case 742:

    {OPT((yyvsp[(3) - (3)].pred), NS(baselink,type))}
    break;

  case 743:

    {CTN(array_ref)}
    break;

  case 745:

    {CTN(call_expr)}
    break;

  case 746:

    {NS(call_expr,fn)}
    break;

  case 749:

    {ADDV(call_expr,AddArg)}
    break;

  case 751:

    {CTN(gimple_call)}
    break;

  case 752:

    {NS(gimple_call,fn)}
    break;

  case 755:

    {ADDV(gimple_call,AddArg)}
    break;

  case 757:

    {CTN(bit_field_ref)}
    break;

  case 759:

    {CTN(array_range_ref)}
    break;

  case 761:

    {CTN(template_parm_index)}
    break;

  case 762:

    {CTN(with_size_expr)}
    break;

  case 764:

    {CTN(obj_type_ref)}
    break;

  case 767:

    {NSV(decl_node, C_flag, true)}
    break;

  case 768:

    {(yyval.pred)=false;}
    break;

  case 769:

    {(yyval.pred)=true;}
    break;

  case 770:

    {(yyval.pred)=false;}
    break;

  case 771:

    {(yyval.pred)=true;}
    break;

  case 772:

    {(yyval.pred)=false;}
    break;

  case 773:

    {(yyval.pred)=true;}
    break;

  case 774:

    {(yyval.pred)=false;}
    break;

  case 775:

    {(yyval.pred)=true;}
    break;

  case 776:

    {(yyval.pred)=false;}
    break;

  case 777:

    {(yyval.pred)=true;}
    break;

  case 778:

    {(yyval.pred)=false;}
    break;

  case 779:

    {(yyval.pred)=true;}
    break;

  case 780:

    {OPT((yyvsp[(1) - (1)].pred), NS(decl_node,name))}
    break;

  case 781:

    {OPT((yyvsp[(3) - (3)].pred), NS(decl_node,mngl))}
    break;

  case 782:

    {OPT((yyvsp[(5) - (5)].pred), NS(decl_node,orig))}
    break;

  case 783:

    {OPT((yyvsp[(7) - (7)].pred), NS(decl_node,type))}
    break;

  case 784:

    {OPT((yyvsp[(9) - (9)].pred), NS(decl_node,scpe))}
    break;

  case 785:

    {OPT((yyvsp[(12) - (12)].pred), NS(decl_node,chan))}
    break;

  case 786:

    {OPT((yyvsp[(14) - (14)].pred), NS(decl_node,attributes))}
    break;

  case 787:

    {OPT((yyvsp[(16) - (16)].pred), NSV(decl_node, artificial_flag, true))}
    break;

  case 788:

    {OPT((yyvsp[(18) - (18)].pred), NSV(decl_node, operating_system_flag, true))}
    break;

  case 789:

    {OPT((yyvsp[(20) - (20)].pred), NSV(decl_node, library_system_flag, true))}
    break;

  case 790:

    {NSV(decl_node, uid, data.curr_unumber)}
    break;

  case 791:

    {OPT((yyvsp[(1) - (1)].pred), NS(expr_node,type))}
    break;

  case 792:

    {
#if HAVE_MAPPING_BUILT
                  std::map<ComponentTypeConstRef, ProbabilityDistribution> weights;
                  if((data.Param->getOption<bool>(OPT_gcc_costs)))
                  {
                     weights[data.driving_component] = data.curr_double_number;
                  }
                  OPT((yyvsp[(4) - (4)].pred), GetPointer<expr_node>(data.curr_tree_nodeRef)->weight_information->recursive_weight = weights);
#endif
               }
    break;

  case 793:

    {
#if HAVE_CODE_ESTIMATION_BUILT
                  OPT((yyvsp[(6) - (6)].pred), GetPointer<expr_node>(data.curr_tree_nodeRef)->weight_information->instruction_size = data.curr_unumber);
#endif
               }
    break;

  case 794:

    {
#if HAVE_RTL_BUILT
                  OPT((yyvsp[(8) - (8)].pred), GetPointer<expr_node>(data.curr_tree_nodeRef)->weight_information->rtl_instruction_size = data.curr_unumber);
#endif
               }
    break;

  case 795:

    {
#if HAVE_RTL_BUILT
                  THROW_ASSERT(GetPointer<WeightedNode>(data.curr_tree_nodeRef), "Tree node is not an expr node but " + data.curr_tree_nodeRef->get_kind_text());
                  GetPointer<WeightedNode>(data.curr_tree_nodeRef)->weight_information->rtl_nodes = data.rtls;
                  data.rtls.clear();
#endif
               }
    break;

  case 796:

    {NSV(expr_node_vops, virtual_operands, data.curr_vopsRef)}
    break;

  case 797:

    {
#if HAVE_MAPPING_BUILT
                       std::map<ComponentTypeConstRef, ProbabilityDistribution> weights;
                       if((data.Param->getOption<bool>(OPT_gcc_costs)))
                       {
                          weights[data.driving_component] = data.curr_double_number;
                       }
                       OPT((yyvsp[(4) - (4)].pred), GetPointer<expr_node_vops>(data.curr_tree_nodeRef)->weight_information->recursive_weight = weights);
#endif
                    }
    break;

  case 798:

    {
#if HAVE_CODE_ESTIMATION_BUILT
                       OPT((yyvsp[(6) - (6)].pred), GetPointer<expr_node_vops>(data.curr_tree_nodeRef)->weight_information->instruction_size = data.curr_unumber);
#endif
                    }
    break;

  case 799:

    {
#if HAVE_RTL_BUILT
                       OPT((yyvsp[(8) - (8)].pred), GetPointer<expr_node_vops>(data.curr_tree_nodeRef)->weight_information->rtl_instruction_size = data.curr_unumber);
#endif
                    }
    break;

  case 800:

    {
#if HAVE_RTL_BUILT
                       GetPointer<expr_node_vops>(data.curr_tree_nodeRef)->weight_information->rtl_nodes = data.rtls;
                       data.rtls.clear();
#endif
                    }
    break;

  case 801:

    {OPT((yyvsp[(1) - (1)].pred), do_qual<type_node>(data.curr_tree_nodeRef, data.curr_number);)}
    break;

  case 802:

    {OPT((yyvsp[(3) - (3)].pred), NS(type_node,name))}
    break;

  case 803:

    {OPT((yyvsp[(5) - (5)].pred), NS(type_node,unql))}
    break;

  case 804:

    {OPT((yyvsp[(7) - (7)].pred), NS(type_node,size))}
    break;

  case 805:

    {OPT((yyvsp[(9) - (9)].pred), NS(type_node,scpe))}
    break;

  case 806:

    {OPT((yyvsp[(11) - (11)].pred), NSV(type_node,algn, data.curr_unumber))}
    break;

  case 807:

    {OPT((yyvsp[(13) - (13)].pred), NSV(type_node, system_flag, true))}
    break;

  case 808:

    {(yyval.pred)=false;}
    break;

  case 809:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_R);(yyval.pred)=true;}
    break;

  case 810:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_V);(yyval.pred)=true;}
    break;

  case 811:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_VR);(yyval.pred)=true;}
    break;

  case 812:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_C);(yyval.pred)=true;}
    break;

  case 813:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_CR);(yyval.pred)=true;}
    break;

  case 814:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_CV);(yyval.pred)=true;}
    break;

  case 815:

    {data.curr_number=lexer.bison2token(TOK_BISON_QUAL_CVR);(yyval.pred)=true;}
    break;

  case 818:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NEW))}
    break;

  case 819:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DELETE))}
    break;

  case 820:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ASSIGN))}
    break;

  case 821:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MEMBER))}
    break;

  case 822:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PUBLIC))}
    break;

  case 823:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PROTECTED))}
    break;

  case 824:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PRIVATE))}
    break;

  case 825:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NORETURN))}
    break;

  case 826:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VOLATILE))}
    break;

  case 827:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NOINLINE))}
    break;

  case 828:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ALWAYS_INLINE))}
    break;

  case 829:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_USED))}
    break;

  case 830:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_UNUSED))}
    break;

  case 831:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_CONST))}
    break;

  case 832:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_TRANSPARENT_UNION))}
    break;

  case 833:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_CONSTRUCTOR))}
    break;

  case 834:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DESTRUCTOR))}
    break;

  case 835:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MODE))}
    break;

  case 836:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_SECTION))}
    break;

  case 837:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ALIGNED))}
    break;

  case 838:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_WEAK))}
    break;

  case 839:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ALIAS))}
    break;

  case 840:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NO_INSTRUMENT_FUNCTION))}
    break;

  case 841:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MALLOC))}
    break;

  case 842:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NO_STACK_LIMIT))}
    break;

  case 843:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PURE))}
    break;

  case 844:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DEPRECATED))}
    break;

  case 845:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VECTOR_SIZE))}
    break;

  case 846:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VISIBILITY))}
    break;

  case 847:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_TLS_MODEL))}
    break;

  case 848:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NONNULL))}
    break;

  case 849:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NOTHROW))}
    break;

  case 850:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MAY_ALIAS))}
    break;

  case 851:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_WARN_UNUSED_RESULT))}
    break;

  case 852:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_FORMAT))}
    break;

  case 853:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_FORMAT_ARG))}
    break;

  case 854:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NULL))}
    break;

  case 855:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_GLOBAL_INIT))}
    break;

  case 856:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_GLOBAL_FINI))}
    break;

  case 857:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_CONVERSION))}
    break;

  case 858:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VIRTUAL))}
    break;

  case 859:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LSHIFT))}
    break;

  case 860:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MUTABLE))}
    break;

  case 861:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PSEUDO_TMPL))}
    break;

  case 862:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VECNEW))}
    break;

  case 863:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_VECDELETE))}
    break;

  case 864:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_POS))}
    break;

  case 865:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NEG))}
    break;

  case 866:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ADDR))}
    break;

  case 867:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DEREF))}
    break;

  case 868:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LNOT))}
    break;

  case 869:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NOT))}
    break;

  case 870:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PREINC))}
    break;

  case 871:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PREDEC))}
    break;

  case 872:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PLUSASSIGN))}
    break;

  case 873:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_PLUS))}
    break;

  case 874:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MINUSASSIGN))}
    break;

  case 875:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MINUS))}
    break;

  case 876:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MULTASSIGN))}
    break;

  case 877:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MULT))}
    break;

  case 878:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DIVASSIGN))}
    break;

  case 879:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_DIV))}
    break;

  case 880:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MODASSIGN))}
    break;

  case 881:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MOD))}
    break;

  case 882:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ANDASSIGN))}
    break;

  case 883:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_AND))}
    break;

  case 884:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_ORASSIGN))}
    break;

  case 885:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_OR))}
    break;

  case 886:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_XORASSIGN))}
    break;

  case 887:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_XOR))}
    break;

  case 888:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LSHIFTASSIGN))}
    break;

  case 889:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_RSHIFTASSIGN))}
    break;

  case 890:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_RSHIFT))}
    break;

  case 891:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_EQ))}
    break;

  case 892:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_NE))}
    break;

  case 893:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LT))}
    break;

  case 894:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_GT))}
    break;

  case 895:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LE))}
    break;

  case 896:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_GE))}
    break;

  case 897:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LAND))}
    break;

  case 898:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_LOR))}
    break;

  case 899:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_COMPOUND))}
    break;

  case 900:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_MEMREF))}
    break;

  case 901:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_REF))}
    break;

  case 902:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_SUBS))}
    break;

  case 903:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_POSTINC))}
    break;

  case 904:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_POSTDEC))}
    break;

  case 905:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_CALL))}
    break;

  case 906:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_THUNK))}
    break;

  case 907:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_THIS_ADJUSTING))}
    break;

  case 908:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_RESULT_ADJUSTING))}
    break;

  case 909:

    {ADD_ATTR(lexer.bison2token(TOK_BISON_BITFIELD))}
    break;

  case 910:

    {OPT((yyvsp[(2) - (2)].pred), NS(unary_expr,op))}
    break;

  case 911:

    {NS(binary_expr,op0)}
    break;

  case 912:

    {OPT((yyvsp[(4) - (4)].pred), NS(binary_expr,op1))}
    break;

  case 913:

    {NS(ternary_expr,op0)}
    break;

  case 914:

    {NS(ternary_expr,op1)}
    break;

  case 915:

    {OPT((yyvsp[(6) - (6)].pred), NS(ternary_expr,op2))}
    break;

  case 916:

    {NS(quaternary_expr,op0)}
    break;

  case 917:

    {NS(quaternary_expr,op1)}
    break;

  case 920:

    {NS(quaternary_expr, op2)}
    break;

  case 921:

    {NS(quaternary_expr, op2)}
    break;

  case 922:

    {NS(quaternary_expr, op3)}
    break;

  case 924:

    {NSV(srcp, include_name, data.curr_string)}
    break;

  case 925:

    {NSV(srcp, line_number, data.curr_unumber)}
    break;

  case 926:

    {NSV(srcp, column_number, data.curr_unumber)}
    break;

  case 928:

    {data.current_TM->add_parallel_loop();NBV(bloc, hpl, 1)}
    break;

  case 929:

    {ADDVALUE(bloc, add_pred, data.curr_unumber)}
    break;

  case 930:

    {ADDVALUE(bloc, add_pred, data.curr_unumber)}
    break;

  case 932:

    {ADDVALUE(bloc, add_succ, data.curr_unumber)}
    break;

  case 934:

    {ADDP(bloc, add_phi)}
    break;

  case 936:

    {ADDP(bloc, add_stmt)}
    break;

  case 938:

    {
#if HAVE_RTL_BUILT
                 data.rtls.push_back(std::pair<enum rtl_kind, enum mode_kind>(data.single_rtl, data.mode_rtl));
#endif
              }
    break;

  case 939:

    {SET_DATA(data.single_rtl, abs_R);}
    break;

  case 940:

    {SET_DATA(data.single_rtl, and_R);}
    break;

  case 941:

    {SET_DATA(data.single_rtl, ashift_R);}
    break;

  case 942:

    {SET_DATA(data.single_rtl, ashiftrt_R);}
    break;

  case 943:

    {SET_DATA(data.single_rtl, bswap_R);}
    break;

  case 944:

    {SET_DATA(data.single_rtl, call_R);}
    break;

  case 945:

    {SET_DATA(data.single_rtl, call_insn_R);}
    break;

  case 946:

    {SET_DATA(data.single_rtl, clz_R);}
    break;

  case 947:

    {SET_DATA(data.single_rtl, code_label_R);}
    break;

  case 948:

    {SET_DATA(data.single_rtl, compare_R);}
    break;

  case 949:

    {SET_DATA(data.single_rtl, concat_R);}
    break;

  case 950:

    {SET_DATA(data.single_rtl, ctz_R);}
    break;

  case 951:

    {SET_DATA(data.single_rtl, div_R);}
    break;

  case 952:

    {SET_DATA(data.single_rtl, eq_R);}
    break;

  case 953:

    {SET_DATA(data.single_rtl, ffs_R);}
    break;

  case 954:

    {SET_DATA(data.single_rtl, fix_R);}
    break;

  case 955:

    {SET_DATA(data.single_rtl, float_R);}
    break;

  case 956:

    {SET_DATA(data.single_rtl, float_extend_R);}
    break;

  case 957:

    {SET_DATA(data.single_rtl, float_truncate_R);}
    break;

  case 958:

    {SET_DATA(data.single_rtl, fract_convert_R);}
    break;

  case 959:

    {SET_DATA(data.single_rtl, ge_R);}
    break;

  case 960:

    {SET_DATA(data.single_rtl, geu_R);}
    break;

  case 961:

    {SET_DATA(data.single_rtl, gt_R);}
    break;

  case 962:

    {SET_DATA(data.single_rtl, gtu_R);}
    break;

  case 963:

    {SET_DATA(data.single_rtl, high_R);}
    break;

  case 964:

    {SET_DATA(data.single_rtl, if_then_else_R);}
    break;

  case 965:

    {SET_DATA(data.single_rtl, insn_R);}
    break;

  case 966:

    {SET_DATA(data.single_rtl, ior_R);}
    break;

  case 967:

    {SET_DATA(data.single_rtl, jump_insn_R);}
    break;

  case 968:

    {SET_DATA(data.single_rtl, label_ref_R);}
    break;

  case 969:

    {SET_DATA(data.single_rtl, le_R);}
    break;

  case 970:

    {SET_DATA(data.single_rtl, leu_R);}
    break;

  case 971:

    {SET_DATA(data.single_rtl, lo_sum_R);}
    break;

  case 972:

    {SET_DATA(data.single_rtl, lshiftrt_R);}
    break;

  case 973:

    {SET_DATA(data.single_rtl, lt_R);}
    break;

  case 974:

    {SET_DATA(data.single_rtl, ltgt_R);}
    break;

  case 975:

    {SET_DATA(data.single_rtl, ltu_R);}
    break;

  case 976:

    {SET_DATA(data.single_rtl, write_mem_R);}
    break;

  case 977:

    {SET_DATA(data.single_rtl, read_mem_R);}
    break;

  case 978:

    {SET_DATA(data.single_rtl, minus_R);}
    break;

  case 979:

    {SET_DATA(data.single_rtl, mod_R);}
    break;

  case 980:

    {SET_DATA(data.single_rtl, mult_R);}
    break;

  case 981:

    {SET_DATA(data.single_rtl, ne_R);}
    break;

  case 982:

    {SET_DATA(data.single_rtl, neg_R);}
    break;

  case 983:

    {SET_DATA(data.single_rtl, not_R);}
    break;

  case 984:

    {SET_DATA(data.single_rtl, ordered_R);}
    break;

  case 985:

    {SET_DATA(data.single_rtl, parallel_R);}
    break;

  case 986:

    {SET_DATA(data.single_rtl, parity_R);}
    break;

  case 987:

    {SET_DATA(data.single_rtl, pc_R);}
    break;

  case 988:

    {SET_DATA(data.single_rtl, plus_R);}
    break;

  case 989:

    {SET_DATA(data.single_rtl, popcount_R);}
    break;

  case 990:

    {SET_DATA(data.single_rtl, reg_R);}
    break;

  case 991:

    {SET_DATA(data.single_rtl, rotate_R);}
    break;

  case 992:

    {SET_DATA(data.single_rtl, rotatert_R);}
    break;

  case 993:

    {SET_DATA(data.single_rtl, sat_fract_R);}
    break;

  case 994:

    {SET_DATA(data.single_rtl, set_R);}
    break;

  case 995:

    {SET_DATA(data.single_rtl, sign_extend_R);}
    break;

  case 996:

    {SET_DATA(data.single_rtl, smax_R);}
    break;

  case 997:

    {SET_DATA(data.single_rtl, smin_R);}
    break;

  case 998:

    {SET_DATA(data.single_rtl, sqrt_R);}
    break;

  case 999:

    {SET_DATA(data.single_rtl, symbol_ref_R);}
    break;

  case 1000:

    {SET_DATA(data.single_rtl, truncate_R);}
    break;

  case 1001:

    {SET_DATA(data.single_rtl, udiv_R);}
    break;

  case 1002:

    {SET_DATA(data.single_rtl, umax_R);}
    break;

  case 1003:

    {SET_DATA(data.single_rtl, umin_R);}
    break;

  case 1004:

    {SET_DATA(data.single_rtl, umod_R);}
    break;

  case 1005:

    {SET_DATA(data.single_rtl, uneq_R);}
    break;

  case 1006:

    {SET_DATA(data.single_rtl, unge_R);}
    break;

  case 1007:

    {SET_DATA(data.single_rtl, ungt_R);}
    break;

  case 1008:

    {SET_DATA(data.single_rtl, unle_R);}
    break;

  case 1009:

    {SET_DATA(data.single_rtl, unlt_R);}
    break;

  case 1010:

    {SET_DATA(data.single_rtl, unordered_R);}
    break;

  case 1011:

    {SET_DATA(data.single_rtl, unsigned_fix_R);}
    break;

  case 1012:

    {SET_DATA(data.single_rtl, unsigned_float_R);}
    break;

  case 1013:

    {SET_DATA(data.single_rtl, unsigned_fract_convert_R);}
    break;

  case 1014:

    {SET_DATA(data.single_rtl, unsigned_sat_fract_R);}
    break;

  case 1015:

    {SET_DATA(data.single_rtl, xor_R);}
    break;

  case 1016:

    {SET_DATA(data.single_rtl, zero_extend_R);}
    break;

  case 1017:

    {SET_DATA(data.mode_rtl, none_R);}
    break;

  case 1018:

    {SET_DATA(data.mode_rtl, qc_R);}
    break;

  case 1019:

    {SET_DATA(data.mode_rtl, hc_R);}
    break;

  case 1020:

    {SET_DATA(data.mode_rtl, sc_R);}
    break;

  case 1021:

    {SET_DATA(data.mode_rtl, dc_R);}
    break;

  case 1022:

    {SET_DATA(data.mode_rtl, tc_R);}
    break;

  case 1023:

    {SET_DATA(data.mode_rtl, cqi_R);}
    break;

  case 1024:

    {SET_DATA(data.mode_rtl, chi_R);}
    break;

  case 1025:

    {SET_DATA(data.mode_rtl, csi_R);}
    break;

  case 1026:

    {SET_DATA(data.mode_rtl, cdi_R);}
    break;

  case 1027:

    {SET_DATA(data.mode_rtl, cti_R);}
    break;

  case 1028:

    {SET_DATA(data.mode_rtl, qf_R);}
    break;

  case 1029:

    {SET_DATA(data.mode_rtl, hf_R);}
    break;

  case 1030:

    {SET_DATA(data.mode_rtl, sf_R);}
    break;

  case 1031:

    {SET_DATA(data.mode_rtl, df_R);}
    break;

  case 1032:

    {SET_DATA(data.mode_rtl, tf_R);}
    break;

  case 1033:

    {SET_DATA(data.mode_rtl, qi_R);}
    break;

  case 1034:

    {SET_DATA(data.mode_rtl, hi_R);}
    break;

  case 1035:

    {SET_DATA(data.mode_rtl, si_R);}
    break;

  case 1036:

    {SET_DATA(data.mode_rtl, di_R);}
    break;

  case 1037:

    {SET_DATA(data.mode_rtl, ti_R);}
    break;

  case 1038:

    {SET_DATA(data.mode_rtl, v2si_R);}
    break;

  case 1039:

    {SET_DATA(data.mode_rtl, v4hi_R);}
    break;

  case 1040:

    {SET_DATA(data.mode_rtl, v8qi_R);}
    break;

  case 1041:

    {SET_DATA(data.mode_rtl, cc_R);}
    break;

  case 1042:

    {SET_DATA(data.mode_rtl, ccfp_R);}
    break;

  case 1043:

    {SET_DATA(data.mode_rtl, ccfpe_R);}
    break;

  case 1044:

    {SET_DATA(data.mode_rtl, ccz_R);}
    break;

  case 1045:

    {CB()}
    break;

  case 1046:

    {NBV(bloc, number, data.curr_unumber)}
    break;

  case 1047:

    {OPT((yyvsp[(8) - (8)].pred),NBV(bloc, true_edge, data.curr_unumber))}
    break;

  case 1048:

    {OPT((yyvsp[(10) - (10)].pred),NBV(bloc, false_edge, data.curr_unumber))}
    break;

  case 1050:

    {data.curr_unumber=bloc::ENTRY_BLOCK_ID;}
    break;

  case 1052:

    {data.curr_unumber=bloc::EXIT_BLOCK_ID;}
    break;

  case 1054:

    {data.curr_vopsRef = vopsRef();}
    break;

  case 1055:

    {CVOPS()}
    break;

  case 1057:

    {CVOPS()}
    break;

  case 1059:

    {ADDVVOPS(vops, add_vuse, data.curr_vuseRef)}
    break;

  case 1060:

    {ADDVVOPS(vops, add_vuse, data.curr_vuseRef)}
    break;

  case 1061:

    {CVUSE()}
    break;

  case 1064:

    {ADDVVUSE(vuse, add_vuse_op)}
    break;

  case 1065:

    {ADDVVUSE(vuse, add_loads)}
    break;

  case 1066:

    {ADDVVUSE(vuse, add_loads)}
    break;

  case 1067:

    {ADDVVOPS(vops, add_vdef, data.curr_vdefRef)}
    break;

  case 1068:

    {ADDVVOPS(vops, add_vdef, data.curr_vdefRef)}
    break;

  case 1071:

    {CVDEF()}
    break;

  case 1072:

    {NS2(data.curr_vdefRef,vdef,vdefinition)}
    break;

  case 1075:

    {ADDVVDEF(vdef, add_stores)}
    break;

  case 1077:

    {ADDVVDEF(vdef, add_vdef_op)}
    break;

  case 1080:

    {ADDV(memory_tag, add_alias)}
    break;

  case 1081:

    {CTN(struct_field_tag)}
    break;

  case 1083:

    {CTN(name_memory_tag)}
    break;

  case 1085:

    {CTN(symbol_memory_tag)}
    break;

  case 1087:

    {CTN(memory_partition_tag)}
    break;

  case 1089:

    {CTN(target_mem_ref461)}
    break;

  case 1090:

    {NS(target_mem_ref461,type)}
    break;

  case 1091:

    {
#if HAVE_MAPPING_BUILT
               std::map<ComponentTypeConstRef, ProbabilityDistribution> weights;
               if((data.Param->getOption<bool>(OPT_gcc_costs)))
                   weights[data.driving_component] = data.curr_double_number;
               OPT((yyvsp[(5) - (5)].pred), GetPointer<target_mem_ref461>(data.curr_tree_nodeRef)->weight_information->recursive_weight = weights);
#endif
            }
    break;

  case 1092:

    {
#if HAVE_CODE_ESTIMATION_BUILT
                OPT((yyvsp[(7) - (7)].pred), GetPointer<target_mem_ref461>(data.curr_tree_nodeRef)->weight_information->instruction_size = data.curr_unumber);
#endif
            }
    break;

  case 1093:

    {
#if HAVE_RTL_BUILT
               OPT((yyvsp[(9) - (9)].pred), GetPointer<target_mem_ref461>(data.curr_tree_nodeRef)->weight_information->rtl_instruction_size = data.curr_unumber);
#endif
            }
    break;

  case 1094:

    {OPT((yyvsp[(11) - (11)].pred), NS(target_mem_ref461,base))}
    break;

  case 1095:

    {OPT((yyvsp[(13) - (13)].pred), NS(target_mem_ref461,offset))}
    break;

  case 1096:

    {OPT((yyvsp[(15) - (15)].pred), NS(target_mem_ref461,idx))}
    break;

  case 1097:

    {OPT((yyvsp[(17) - (17)].pred), NS(target_mem_ref461,step))}
    break;

  case 1098:

    {OPT((yyvsp[(19) - (19)].pred), NS(target_mem_ref461,idx2))}
    break;

  case 1099:

    {CTN(target_mem_ref)}
    break;

  case 1100:

    {NS(target_mem_ref,type)}
    break;

  case 1101:

    {
                  #if HAVE_MAPPING_BUILT
                                         std::map<ComponentTypeConstRef, ProbabilityDistribution> weights;
                                         if((data.Param->getOption<bool>(OPT_gcc_costs)))
                                            weights[data.driving_component] = data.curr_double_number;
                                         OPT((yyvsp[(5) - (5)].pred), GetPointer<target_mem_ref>(data.curr_tree_nodeRef)->weight_information->recursive_weight = weights);
                  #endif
                                      }
    break;

  case 1102:

    {
                  #if HAVE_CODE_ESTIMATION_BUILT
                                         OPT((yyvsp[(7) - (7)].pred), GetPointer<target_mem_ref>(data.curr_tree_nodeRef)->weight_information->instruction_size = data.curr_unumber);
                  #endif
                                      }
    break;

  case 1103:

    {
                  #if HAVE_RTL_BUILT
                                         OPT((yyvsp[(7) - (9)].pred), GetPointer<target_mem_ref>(data.curr_tree_nodeRef)->weight_information->rtl_instruction_size = data.curr_unumber);
                  #endif
                                      }
    break;

  case 1104:

    {OPT((yyvsp[(11) - (11)].pred), NS(target_mem_ref,symbol))}
    break;

  case 1105:

    {OPT((yyvsp[(13) - (13)].pred), NS(target_mem_ref,base))}
    break;

  case 1106:

    {OPT((yyvsp[(15) - (15)].pred), NS(target_mem_ref,idx))}
    break;

  case 1107:

    {OPT((yyvsp[(17) - (17)].pred), NS(target_mem_ref,step))}
    break;

  case 1108:

    {OPT((yyvsp[(19) - (19)].pred), NS(target_mem_ref,offset))}
    break;

  case 1109:

    {NS(target_mem_ref,orig)}
    break;

  case 1110:

    {OPT((yyvsp[(23) - (23)].pred), NS(target_mem_ref,tag));}
    break;

  case 1111:

    {CTN(trait_expr)}
    break;

  case 1112:

    {(yyval.pred)=false;}
    break;

  case 1113:

    {(yyval.pred)=true;}
    break;

  case 1114:

    {(yyval.pred)=false;}
    break;

  case 1115:

    {(yyval.pred)=true;}
    break;

  case 1116:

    {(yyval.pred)=false;}
    break;

  case 1117:

    {(yyval.pred)=true;}
    break;

  case 1172:

    {(yyval.pred)=false;}
    break;

  case 1173:

    {(yyval.pred)=true;}
    break;

  case 1174:

    {(yyval.pred)=false;}
    break;

  case 1175:

    {(yyval.pred)=true;}
    break;

  case 1176:

    {(yyval.pred)=false;}
    break;

  case 1177:

    {(yyval.pred)=true;}
    break;

  case 1178:

    {(yyval.pred)=false;}
    break;

  case 1179:

    {(yyval.pred)=true;}
    break;

  case 1180:

    {(yyval.pred)=false;}
    break;

  case 1181:

    {(yyval.pred)=true;}
    break;

  case 1182:

    {(yyval.pred)=false;}
    break;

  case 1183:

    {(yyval.pred)=true;}
    break;

  case 1184:

    {(yyval.pred)=false;}
    break;

  case 1185:

    {(yyval.pred)=true;}
    break;

  case 1186:

    {(yyval.pred)=false;}
    break;

  case 1187:

    {(yyval.pred)=true;}
    break;

  case 1188:

    {(yyval.pred)=false;}
    break;

  case 1189:

    {(yyval.pred)=true;}
    break;

  case 1190:

    {(yyval.pred)=false;}
    break;

  case 1191:

    {(yyval.pred)=true;}
    break;

  case 1192:

    {(yyval.pred)=false;}
    break;

  case 1193:

    {(yyval.pred)=true;}
    break;

  case 1194:

    {(yyval.pred)=false;}
    break;

  case 1195:

    {(yyval.pred)=true;}
    break;

  case 1196:

    {(yyval.pred)=false;}
    break;

  case 1197:

    {(yyval.pred)=true;}
    break;

  case 1198:

    {(yyval.pred)=false;}
    break;

  case 1199:

    {(yyval.pred)=true;}
    break;

  case 1200:

    {(yyval.pred)=false;}
    break;

  case 1201:

    {(yyval.pred)=true;}
    break;

  case 1202:

    {(yyval.pred)=false;}
    break;

  case 1203:

    {(yyval.pred)=true;}
    break;

  case 1204:

    {(yyval.pred)=false;}
    break;

  case 1205:

    {(yyval.pred)=true;}
    break;

  case 1206:

    {(yyval.pred)=false;}
    break;

  case 1207:

    {(yyval.pred)=true;}
    break;

  case 1208:

    {(yyval.pred)=false;}
    break;

  case 1209:

    {(yyval.pred)=true;}
    break;

  case 1210:

    {(yyval.pred)=false;}
    break;

  case 1211:

    {(yyval.pred)=true;}
    break;

  case 1212:

    {(yyval.pred)=false;}
    break;

  case 1213:

    {(yyval.pred)=true;}
    break;

  case 1214:

    {(yyval.pred)=false;}
    break;

  case 1215:

    {(yyval.pred)=true;}
    break;

  case 1216:

    {(yyval.pred)=false;}
    break;

  case 1217:

    {(yyval.pred)=true;}
    break;

  case 1218:

    {(yyval.pred)=false;}
    break;

  case 1219:

    {(yyval.pred)=true;}
    break;

  case 1220:

    {(yyval.pred)=false;}
    break;

  case 1221:

    {(yyval.pred)=true;}
    break;

  case 1222:

    {(yyval.pred)=false;}
    break;

  case 1223:

    {(yyval.pred)=true;}
    break;

  case 1224:

    {(yyval.pred)=false;}
    break;

  case 1225:

    {(yyval.pred)=true;}
    break;

  case 1226:

    {(yyval.pred)=false;}
    break;

  case 1227:

    {(yyval.pred)=true;}
    break;

  case 1228:

    {(yyval.pred)=false;}
    break;

  case 1229:

    {(yyval.pred)=true;}
    break;

  case 1230:

    {(yyval.pred)=false;}
    break;

  case 1231:

    {(yyval.pred)=true;}
    break;

  case 1232:

    {(yyval.pred)=false;}
    break;

  case 1233:

    {(yyval.pred)=true;}
    break;

  case 1234:

    {(yyval.pred)=false;}
    break;

  case 1235:

    {(yyval.pred)=true;}
    break;

  case 1236:

    {(yyval.pred)=false;}
    break;

  case 1237:

    {(yyval.pred)=true;}
    break;

  case 1238:

    {(yyval.pred)=false;}
    break;

  case 1239:

    {(yyval.pred)=true;}
    break;

  case 1240:

    {(yyval.pred)=false;}
    break;

  case 1241:

    {(yyval.pred)=true;}
    break;

  case 1242:

    {(yyval.pred)=false;}
    break;

  case 1243:

    {(yyval.pred)=true;}
    break;

  case 1244:

    {(yyval.pred)=false;}
    break;

  case 1245:

    {(yyval.pred)=true;}
    break;

  case 1246:

    {(yyval.pred)=true;}
    break;

  case 1247:

    {(yyval.pred)=false;}
    break;

  case 1248:

    {(yyval.pred)=true;}
    break;

  case 1249:

    {(yyval.pred)=false;}
    break;

  case 1250:

    {(yyval.pred)=true;}
    break;

  case 1251:

    {(yyval.pred)=false;}
    break;

  case 1252:

    {(yyval.pred)=true;}
    break;

  case 1253:

    {(yyval.pred)=false;}
    break;

  case 1254:

    {(yyval.pred)=true;}
    break;

  case 1255:

    {(yyval.pred)=false;}
    break;

  case 1256:

    {(yyval.pred)=true;}
    break;

  case 1257:

    {(yyval.pred)=false;}
    break;

  case 1258:

    {(yyval.pred)=true;}
    break;

  case 1259:

    {(yyval.pred)=false;}
    break;

  case 1260:

    {(yyval.pred)=true;}
    break;

  case 1261:

    {(yyval.pred)=false;}
    break;

  case 1262:

    {(yyval.pred)=true;}
    break;

  case 1263:

    {(yyval.pred)=false;}
    break;

  case 1264:

    {(yyval.pred)=true;}
    break;

  case 1265:

    {(yyval.pred)=false;}
    break;

  case 1266:

    {(yyval.pred)=true;}
    break;

  case 1267:

    {(yyval.pred)=false;}
    break;

  case 1268:

    {(yyval.pred)=true;}
    break;

  case 1269:

    {(yyval.pred)=false;}
    break;

  case 1270:

    {(yyval.pred)=true;}
    break;

  case 1271:

    {(yyval.pred)=false;}
    break;

  case 1272:

    {(yyval.pred)=true;}
    break;

  case 1273:

    {(yyval.pred)=false;}
    break;

  case 1274:

    {(yyval.pred)=true;}
    break;

  case 1275:

    {(yyval.pred)=false;}
    break;

  case 1276:

    {(yyval.pred)=true;}
    break;

  case 1277:

    {(yyval.pred)=false;}
    break;

  case 1278:

    {(yyval.pred)=true;}
    break;

  case 1279:

    {(yyval.pred)=false;}
    break;

  case 1280:

    {(yyval.pred)=true;}
    break;

  case 1281:

    {(yyval.pred)=false;}
    break;

  case 1282:

    {(yyval.pred)=true;}
    break;

  case 1283:

    {(yyval.pred)=false;}
    break;

  case 1284:

    {(yyval.pred)=true;}
    break;

  case 1285:

    {(yyval.pred)=false;}
    break;

  case 1286:

    {(yyval.pred)=true;}
    break;

  case 1287:

    {data.curr_NODE_ID=(yyvsp[(1) - (1)].value);}
    break;

  case 1288:

    {data.curr_string=std::string((yyvsp[(1) - (1)].text)+1, (yyvsp[(1) - (1)].text)+strlen((yyvsp[(1) - (1)].text))-1);}
    break;

  case 1289:

    {data.curr_number=(yyvsp[(1) - (1)].long_value); data.curr_unumber = (yyvsp[(1) - (1)].long_value); data.curr_size_t_number=(yyvsp[(1) - (1)].long_value); data.curr_long_long_number=(yyvsp[(1) - (1)].long_value); data.curr_long_number=(yyvsp[(1) - (1)].long_value); data.curr_double_number=(yyvsp[(1) - (1)].long_value);}
    break;

  case 1290:

    {(yyval.pred) = false;}
    break;

  case 1291:

    {(yyval.pred) = true;}
    break;



      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (data, lexer, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (data, lexer, yymsg);
	  }
	else
	  {
	    yyerror (data, lexer, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, data, lexer);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, data, lexer);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (data, lexer, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, data, lexer);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, data, lexer);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}




/**
* EPILOGUE
*/

extern tree_managerRef tree_parseY(const ParameterConstRef Param, std::string fn)
{
    fileIO_istreamRef sname = fileIO_istream_open(fn);
    if(sname->fail()) THROW_ERROR(std::string("FILE does not exist: ")+fn);
    treeFlexLexer lexer(sname.get(), 0);
    bison_parser_data data(Param, Param->get_class_debug_level("tree_parse"));
    data.final_TM = tree_managerRef();
    data.current_TM = tree_managerRef();
#if YYDEBUG
    yydebug = 1;
#endif
    yyparse(data, lexer);
    if(data.final_TM)
      data.final_TM->merge_tree_managers(data.current_TM);
    else
      data.final_TM = data.current_TM;
    return data.final_TM;
}

void yyerror(bison_parser_data &data, treeFlexLexer& lexer, char *msg)
{
  lexer.yyerror(msg);
}
int yylex(YYSTYPE *lvalp, treeFlexLexer& lexer)
{
  lexer.lvalp=lvalp;
  return lexer.yylex();
}

